;
;  HelloWorld Fresh example
;

format PE GUI 4.0
include '%finc%/win32/win32a.inc'

section '.code' code readable executable
        invoke  GetModuleHandle, 0
        mov     [hInstance],eax
        mov     [wc.hInstance],eax
        mov     [wc.style],CS_HREDRAW or CS_VREDRAW
        mov     [wc.lpfnWndProc],WndProc
        mov     [wc.cbClsExtra], 0
        mov     [wc.cbWndExtra], 0
        invoke  LoadIcon, NULL, IDI_APPLICATION
        mov     [wc.hIcon],eax
        invoke  LoadCursor, NULL, IDC_ARROW
        mov     [wc.hCursor],eax
        mov     [wc.hbrBackground],COLOR_WINDOW
        mov     [wc.lpszMenuName],NULL
        mov     [wc.lpszClassName], szAppName
        invoke  RegisterClass, wc
        invoke  CreateWindowEx, 0,szAppName,szCaption, \
                              WS_OVERLAPPEDWINDOW, \
                              CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT, \
                              NULL,NULL,[hInstance],NULL
        mov     [hwnd],eax
        invoke  ShowWindow, eax,SW_SHOWNORMAL

message_loop:
        invoke  GetMessage, msg,0,0,0
        or      eax,eax
        jz      finish
        invoke  TranslateMessage, msg
        invoke  DispatchMessage, msg
        jmp     message_loop

finish:
        invoke  ExitProcess, [msg.wParam]


proc WndProc hwnd,msg,wparam,lparam
local hdc:DWORD, rect:RECT, ps:PAINTSTRUCT
        push    ebx esi edi
        cmp     [msg],WM_DESTROY
        je      .wm_destroy
        cmp     [msg],WM_PAINT
        je      .wm_paint
        invoke  DefWindowProc, [hwnd],[msg],[wparam],[lparam]
        pop     edi esi ebx
        ret
  .wm_paint:
        lea     eax,[ps]
        invoke  BeginPaint, [hwnd],eax
        mov     [hdc],eax
        lea     eax,[rect]
        invoke  GetClientRect, [hwnd],eax
        lea     eax,[rect]
        invoke  DrawText, [hdc],szText,-1,eax,DT_SINGLELINE or DT_CENTER or DT_VCENTER
        lea     eax,[ps]
        invoke  EndPaint, [hdc],eax
        jmp     .finish
  .wm_destroy:
        invoke  PostQuitMessage, 0
  .finish:
        xor     eax,eax
        pop     edi esi ebx
        ret
endp


section '.data' data readable writeable

szAppName db 'HelloWin', 0
szCaption db 'Hello!', 0
szText    db 'Hello from Win32 assembly program!', 0

hwnd      dd ?
hInstance dd ?
msg       MSG
wc        WNDCLASS


section '.idata' import data readable

library kernel32,'KERNEL32.DLL',\
        user32,'USER32.DLL',\
        gdi32,'GDI32.DLL'

include '%finc%/win32/apia/kernel32.inc'
include '%finc%/win32/apia/user32.inc'
include '%finc%/win32/apia/gdi32.inc'