iglobal
  include 'actions.inc'   ; menus, action, etc

  cAddFileTitle db 'Add file to the project', 0
  cSetMainTitle db 'Select main file', 0
endg


ActionEvents:

;----------------------------------------------------------------
; This is OnIdle handler of the application.
; When message queue is empty, this subroutine is called once.
; The idea is to provide updating of the status of the controls
; without performance decreasing.
;----------------------------------------------------------------

proc OnIdle

local .changed:DWORD

        push    esi edi ebx
        mov     [.changed], 0

;----------------------------------------------------------------------
; Set actPaste state enable/disable. Only for text data in clipboard.
;----------------------------------------------------------------------
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actPaste, 0
        test    eax,eax
        jz      @f
        mov     eax, 1
@@:
        mov     edi,eax

        stdcall CanAction, [ptrCurrentFile], WM_PASTE
        or      eax, eax
        jz      @f
        mov     eax,1
@@:
        cmp     eax,edi
        je      .nextcheck1

        mov     ebx, MF_BYCOMMAND or MF_GRAYED
        test    eax,eax
        jz      @f
        mov     ebx, MF_BYCOMMAND or MF_ENABLED
@@:
        inc     [.changed]
        invoke  SendMessage,[hMainToolbar],TB_ENABLEBUTTON,actPaste, eax
        invoke  EnableMenuItem,[hMainMenu],actPaste,ebx
        invoke  EnableMenuItem,[hEditorMenu],actPaste,ebx

.nextcheck1:
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actUndo, 0
        xor     esi, esi
        test    eax, eax
        jz      @f
        inc     esi
@@:
        mov     edi, MF_BYCOMMAND or MF_GRAYED

        stdcall CanAction, [ptrCurrentFile], WM_UNDO
        test    eax, eax
        jz      @f
        mov     eax, 1
        mov     edi, MF_BYCOMMAND or MF_ENABLED
@@:
        cmp     esi, eax
        je      .nextcheck2

        inc     [.changed]
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actUndo, eax
        invoke  EnableMenuItem,[hMainMenu], actUndo, edi
        invoke  EnableMenuItem,[hEditorMenu], actUndo, edi

.nextcheck2:
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actSave, 0
        test    eax, eax
        setnz   bh

        stdcall GetModified, [ptrCurrentFile]
        test    eax,eax
        setnz   bl

.checkchange:
        xor     bh,bl
        jz      .checksaveall     ; equal

        mov     edi, MF_BYCOMMAND or MF_GRAYED
        test    bl,bl
        jz      @f
        mov     edi, MF_BYCOMMAND or MF_ENABLED
@@:
        movzx   ebx, bl
        inc     [.changed]
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actSave, ebx
        invoke  EnableMenuItem,[hMainMenu], actSave, edi
        invoke  EnableMenuItem,[hTabMenu], actSave, edi

; Check for actSaveAll...
.checksaveall:
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actSaveAll, 0
        test    eax, eax
        setnz   bh

        stdcall EnumOpenFiles, _checkfirstforsave, NULL
        test    eax, eax
        setnz   bl

        xor     bh, bl
        jz      .nextcheck3

        mov     edi, MF_BYCOMMAND or MF_GRAYED
        test    bl,bl
        jz      @f
        mov     edi, MF_BYCOMMAND or MF_ENABLED
@@:
        movzx   ebx, bl
        inc     [.changed]
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actSaveAll, ebx
        invoke  EnableMenuItem,[hMainMenu], actSaveAll, edi

.nextcheck3:
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actCompile, 0
        test    eax, eax
        setnz   bh

        invoke  SendMessage, [hProjManager], PMM_GETMAINFILE, 0, 0
        test    eax, eax
        setnz   bl

        mov     eax, [ptrCurrentFile]
        test    eax, eax
        jz      @f

        cmp     [eax+TOpenFile.ptrType], ftCommonSource
        sete    al
        or      bl, al
        jmp     .checkcomp

@@:
        setnz   al
        or      bl,al

.checkcomp:
        xor     bh, bl
        jz      .nextcheck4

        mov     edi, MF_BYCOMMAND or MF_GRAYED
        test    bl,bl
        jz      @f
        mov     edi, MF_BYCOMMAND or MF_ENABLED
@@:
        movzx   ebx, bl
        inc     [.changed]
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actCompile, ebx
        invoke  EnableMenuItem,[hMainMenu], actCompile, edi
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actRun, ebx
        invoke  EnableMenuItem,[hMainMenu], actRun, edi
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actDebug, ebx
        invoke  EnableMenuItem,[hMainMenu], actDebug, edi

.nextcheck4:

.finish:
        cmp     [.changed], 0
        je      .quit

        invoke  InvalidateRect, [hMainToolbar], NULL, FALSE
.quit:
        pop     ebx edi esi
        ret
endp


proc _checkfirstforsave .ptrFile, .dummy
        stdcall GetModified, [.ptrFile]
        test    eax, eax
        jnz     .forsave
        clc
        ret

.forsave:
        stc
        ret
endp



;---------------------------------------------------
; Opens file(s) in the Fresh
;
;---------------------------------------------------
proc OnOpen .wparam, .lparam
        stdcall OpenFilesDialog, cOpenFileTitle, TRUE, AllFilter, OpenFileByNameEdit2, NULL, NULL
        ret
endp




proc OnOpenFileAtCursor .wparam, .lparam
local .line[256]:BYTE
local .pos:AEPOS
        mov     esi, [ptrCurrentFile]
        mov     eax, [esi+TOpenFile.ptrType]
        cmp     [eax+TFileType.CreateProc], CreateSourceEditor
        jne     .finish

        mov     ebx, [esi+TOpenFile.hEditor]
        test    ebx, ebx
        je      .finish

        lea     eax, [.pos]
        invoke  SendMessage, ebx, AEM_GETPOS, eax, 0

        lea     esi, [.line]
        invoke  SendMessage, ebx, AEM_GETLINE, 0, esi

        mov     ebx, [.pos.caretPosition]
        dec     ebx
        mov     ax, $2227
; Search to left
.toleft:
        dec     ebx
        js      .finish

        cmp     [esi+ebx], al
        je      .found
        cmp     [esi+ebx], ah
        jne     .toleft
        mov     al,ah
.found:
        lea     edi, [esi+ebx+1]
; search to right
.toright:
        inc     ebx
        cmp     ebx, $100
        jae     .finish

        cmp     [esi+ebx], al
        jne     .toright
.foundName:
        mov     byte [esi+ebx], 0

        stdcall ConvertPath, edi
        push    eax
        stdcall OpenFileByName, eax, NULL, TRUE
        stdcall StrDel ; from stack.

.finish:
        ret
endp






;----------------------------------------------------
; Save the current project and all open files to disk.
;----------------------------------------------------
proc OnSaveAll .wparam, .lparam
        stdcall EnumOpenFiles, _dosaveonefile, 0
        ret
endp


proc  _dosaveonefile .ptrFile, .dummy
        stdcall SaveFile, [.ptrFile]
        ret
endp



;----------------------------------------------------
; Save the current editor file to the disk.
;----------------------------------------------------
proc OnSave .wparam, .lparam
        stdcall SaveFile, [ptrCurrentFile]
        ret
endp


;----------------------------------------------------------
; Save the current editor file to the disk with new name.
;----------------------------------------------------------
proc OnSaveAs .wparam, .lparam
        mov     esi, [ptrCurrentFile]
        test    esi, esi
        jz      .finish
        xor     ebx, ebx
        inc     ebx
        xchg    [esi+TOpenFile.fNeverSaved], ebx

        stdcall SaveFile, esi
        test    eax, eax
        jnz     .finish

        xchg    [esi+TOpenFile.fNeverSaved], ebx

.finish:
        ret
endp



;------------------------------------------
; actExit action handler
;------------------------------------------
proc OnExit .wparam, .lparam
        invoke  PostMessage, [hApplication], WM_CLOSE, 0, 0
        ret
endp




;------------------------------------------
; actClose action handler.
; Closes the current file.
;------------------------------------------
proc OnFileClose .wparam, .lparam
        xor     eax, eax
        xchg    eax,[ptrCurrentFile]
        stdcall CloseFile, eax
        ret
endp


;------------------------------------------
; actCloseAll action handler.
;------------------------------------------
proc OnCloseAll .wparam, .lparam
        mov     [ptrCurrentFile], 0
        invoke  SendMessage, [hProjManager], WM_CLOSE, 0, 0
        stdcall EnumOpenFiles, _docloseone, NULL
        ret
endp



proc _docloseone .ptrFile, .dummy
        stdcall CloseFile, [.ptrFile]
        cmp     eax, cfrCanceled
        je      .stop
        clc
        ret

.stop:
        stc
        ret
endp



proc OnCleanupMRU .wparam, .lparam
        stdcall  ValidateMRUList, [ptrMRUFiles], _MRUCheckCallback
        stdcall  ValidateMRUList, [ptrMRUProj], _MRUCheckCallback
        ret
endp


proc _MRUCheckCallback .hMRUItem
        stdcall StrPtr, [.hMRUItem]
        invoke  CreateFile, eax, 0, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
        cmp     eax, INVALID_HANDLE_VALUE
        je      .qfalse
        invoke  CloseHandle, eax
        mov     eax, TRUE
        ret

.qfalse:
        xor     eax, eax
        ret
endp



;------------------------------------------
; aux procedure. make simultaneous switch
; of menu item and toolbutton with the same
; action.
;------------------------------------------
proc ActionSetCheck .ID, .check
        push    esi ebx
        movzx   ebx, word [.ID]
        mov     eax, MF_UNCHECKED
        xor     esi,esi
        cmp     [.check], FALSE
        je      @f
        mov     eax, MF_CHECKED
        inc     esi
@@:
        or      eax, MF_BYCOMMAND
        invoke  CheckMenuItem, [hMainMenu], ebx, eax
        invoke  SendMessage, [hMainToolbar], TB_CHECKBUTTON, ebx, esi
        pop     ebx esi
        ret
endp

;------------------------------------------
; actGridView action handler
;------------------------------------------
proc OnGridView .wparam, .lparam
        xor     [fGridVisible],1
        stdcall ActionSetCheck, [.wparam], [fGridVisible]
;        invoke  SendMessage, [hProjManager], PMM_REFRESHFORMS, 0, 0

        stdcall EnumOpenFiles, DoRefreshForms, 0
        ret
endp


proc DoRefreshForms .ptrFile, .dummy
        mov     eax, [.ptrFile]
        cmp     [eax+TOpenFile.ptrType], ftFormSource
        jne     .finish

        cmp     [eax+TOpenFile.hEditor], 0
        je      .finish

        invoke  GetProp, [eax+TOpenFile.hEditor], [propWinTemplate]
        test    eax, eax
        jz      .finish

        invoke  InvalidateRect, [eax+TWinTemplateDT.hwnd], NULL, TRUE

.finish:
        clc
        ret
endp


;------------------------------------------
; actSnap action handler
;------------------------------------------
proc OnSnap .wparam, .lparam
        xor     [fSnapToGrid],1
        stdcall ActionSetCheck, [.wparam], [fSnapToGrid]
        ret
endp

;------------------------------------------
; actSnap action handler
;------------------------------------------
proc OnPartialSelect .wparam, .lparam
        xor     [fPartialSelect],1
        stdcall ActionSetCheck, [.wparam], [fPartialSelect]
        ret
endp


proc OnViewProjMan .wparam, .lparam
        invoke  IsWindowVisible, [hProjManager]
        mov     ebx, SW_SHOWNORMAL
        xor     eax, TRUE
        jnz     @f
        mov     ebx, SW_HIDE
@@:
        stdcall ActionSetCheck, [.wparam], eax
        invoke  ShowWindow, [hProjManager], ebx
        ret
endp


proc OnViewPropEditor .wparam, .lparam
        invoke  IsWindowVisible, [hPropEditor]
        mov     ebx, SW_SHOWNORMAL
        xor     eax, TRUE
        jnz     @f
        mov     ebx, SW_HIDE
@@:
        stdcall ActionSetCheck, [.wparam], eax
        invoke  ShowWindow, [hPropEditor], ebx
        ret
endp


proc OnViewSourceEditor .wparam, .lparam
        invoke  IsWindowVisible, [hEditorsHost]
        test    eax, eax
        jnz     .setfocus

        mov     ebx, SW_SHOWNORMAL
        mov     eax, TRUE
        stdcall ActionSetCheck, [.wparam], eax
        invoke  ShowWindow, [hEditorsHost], ebx
        ret

.setfocus:
        invoke  SetActiveWindow, [hEditorsHost]
        ret
endp



proc OnShowForm .wparam, .lparam
        mov     eax, [ptrCurrentFile]
        test    eax, eax
        jz      .exit

        cmp     [eax+TOpenFile.ptrType], ftFormSource
        jne      .exit

        invoke  SendMessage, [eax+TOpenFile.hEditor], FEM_SWITCHMODE, 0, 0

.exit:
        ret
endp



proc OnUndo .wparam, .lparam
        stdcall CommonAction2, WM_UNDO
        ret
endp


proc OnPaste .wparam, .lparam
        stdcall CommonAction2, WM_PASTE
        ret
endp

proc OnDelete .wparam, .lparam
        stdcall CommonAction2, WM_CLEAR
        ret
endp


proc OnCut .wparam, .lparam
        stdcall CommonAction2, WM_CUT
        ret
endp


proc OnCopy .wparam, .lparam
        stdcall CommonAction2, WM_COPY
        ret
endp

proc OnSelectAll uses ebx, wparam,lparam
local aepos:AEPOS
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        or      eax,eax
        jz      .finish
        mov     ebx,eax
        mov     [aepos.selectionLine],1
        mov     [aepos.selectionPosition],1
        mov     [aepos.caretLine],-1
        mov     [aepos.caretPosition],1
        lea     eax,[aepos]
        invoke  SendMessage,ebx,AEM_SETPOS,eax,0
        lea     eax,[aepos]
        invoke  SendMessage,ebx,AEM_GETPOS,eax,0
        invoke  SendMessage,ebx,AEM_GETLINELENGTH,[aepos.caretLine],0
        inc     eax
        mov     [aepos.caretPosition],eax
        lea     eax,[aepos]
        invoke  SendMessage,ebx,AEM_SETPOS,eax,0
.finish:
        ret
endp

proc CommonAction2 .cmd
        invoke  GetFocus
        mov     esi, eax

        invoke  GetProp, esi, [propOpenFileStructure]
        test    eax, eax
        jnz     .toeditor

        mov     eax, esi

.loop:
        mov     ebx, eax
        invoke  GetProp, ebx, [propTemplateDT]
        test    eax, eax
        jnz     .toformeditor

        invoke  GetParent, ebx
        test    eax, eax
        jnz     .loop

.control:
        invoke  SendMessage, esi, [.cmd], 0, 0
        ret

.toeditor:
        stdcall CommonAction, eax, [.cmd]
        ret

.toformeditor:
        cmp     [eax+TWinTemplateDT.ptrFile], 0
        je      .next

        mov     eax, [eax+TWinTemplateDT.ptrFile]
        jmp     .toeditor

.next:
        mov     eax, [eax+TWinTemplateDT.parent]
        test    eax, eax
        jnz     .toformeditor
        ret
endp

;------------------------------------------------
; Temporary action handler for functions
; not implemented on this stage.
;------------------------------------------------
proc OnNotImplemented .wparam, .lparam
        invoke  MessageBox, [hApplication], cNotImplText, cNotImplTitle, MB_OK or MB_ICONINFORMATION
        ret
endp


iglobal
  cNotImplText db 'Sorry, but this feature is not implemented yet. :)', 0
  cNotImplTitle db 'Information', 0
endg



;------------------------------------------
; actAbout action handler
; using of message box is only temporary.
; this must be more fancy :)
;------------------------------------------
proc OnAbout .wparam, .lparam
        stdcall CreateForm, AboutForm, [hApplication]

        stdcall LoadGif, [hInstance], resBmpAbout
        push    eax
        invoke  SendDlgItemMessage, ebx, 101, STM_SETIMAGE, IMAGE_BITMAP, eax
        invoke  SendDlgItemMessage, ebx, 102, WM_SETTEXT, 0, cAboutText

        stdcall ShowModal, ebx, MSF_CENTER
        invoke  DestroyWindow, ebx
        invoke  DeleteObject

        ret
endp

iglobal
  ; About box form definition.
  Window AboutForm, wtParent or wtEnd, waNone, 'TForm', 'About "Fresh"...', WS_CAPTION or WS_CLIPCHILDREN or WS_SYSMENU or WS_DLGFRAME, 0, NULL, 0, 0, 400, 300, NULL
  Window NONE, wtChild, waBottom, 'Button', 'Close', WS_VISIBLE or WS_CHILD or WS_BORDER, 0, MR_OK, 10, 50, 64, 25, NULL
  Window NONE, wtChild, waLeft, 'Static', '', WS_VISIBLE or WS_CHILD or SS_BITMAP or SS_CENTERIMAGE or WS_BORDER, 0, 101, 0, 10, 165, 19, NULL
  Window NONE, wtChild or wtEnd, waClient, 'Static', '', WS_VISIBLE or WS_CHILD or SS_LEFT or WS_BORDER, WS_EX_CLIENTEDGE, 102, 0, 10, 180, 19, NULL

  cAboutText db $0d, '  Fresh 1.2', $0d, $0d
             db ' IDE: ', FRESH_VERSION, $0d
             db ' build: '
             create_build_time DAY, MONTH, YEAR
             db $0d
             db '    John Found', $0d
             db '    Fredrik Klasson (aka scientica)', $0d
             db '    Tommy Lillehagen',$0d
             db '    Mateusz Tymek (aka decard)', $0d
             db '    Victor Loh (aka roticv)', $0d
             db '    Yunus Sina Gulsen (aka VeSCeRa)', $0d, $0d
             db '  Compiler: FASM ',VERSION_STRING, $0d
             db '    Tomasz Grysztar (aka Privalov)', 0
endg




;*****************************************************************************
; Bookmarks actions and some edit actions by Tommy Lillehagen.
;*****************************************************************************

proc OnToggleBM uses ebx, .wparam, .lparam
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx,eax
        invoke  SendMessage, eax, AEM_GETFLAGS, 0, 0
        btc     eax,FLAG_BOOKMARK shr 1
        invoke  SendMessage, ebx, AEM_SETFLAGS, 0, eax
.finish:
        ret
endp



proc OnNextBM .wparam, .lparam
local .pos:AEPOS
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx,eax
        invoke  SendMessage,ebx, AEM_NEXTBOOKMARK, 0, 0
.finish:
        ret
endp



proc OnPrevBM .wparam, .lparam
local .pos:AEPOS
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx,eax
        invoke  SendMessage, ebx, AEM_PREVBOOKMARK, 0, 0
.finish:
        ret
endp


proc OnClearBM .wparam, .lparam
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        invoke  SendMessage, eax, AEM_CLEARALLFLAGS, 0, FLAG_BOOKMARK
.finish:
        ret
endp


proc OnComment .wparam, .lparam
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_COMMENT, 0, 1
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0

.finish:
        ret
endp



proc OnUncomment .wparam, .lparam
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_COMMENT, 0, 0
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0
.finish:
        ret
endp



proc OnIndent .wparam, .lparam
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_INDENT, 0, 1
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0
.finish:
        ret
endp


proc OnOutdent .wparam, .lparam
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_INDENT, 0, 0
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0
.finish:
        ret
endp



;************************************************************************
; OnCreateSource - this is just a test, not a working compilation procedure.
; Returns modal result from progress window.
;************************************************************************
proc OnCompile .wparam, .lparam
local .exit:DWORD
        mov     [comp_handle], 0

        invoke  SendMessage, [frmMsg], MWM_CLEARMESSAGES, 0, 0

; Set compiler properties...
        mov     eax, [poMemory]
        cmp     eax, 8192               ; 8MEG is smallest possible memory
        jge     @f
        mov     eax, 8192
@@:
        mov     [compiler_memory], eax

; Set output filename...

        xor     eax, eax
        cmp     [poBinNameAuto], FALSE
        jne     .setoutputname

        stdcall StrLen, [poBinName]
        test    eax, eax
        jz      .setoutputname

uglobal
  out_filename_buffer rb 256
endg
        lea     ecx, [eax+1]
        stdcall StrPtr, [poBinName]
        mov     esi, eax
        mov     edi, out_filename_buffer
        rep movsb

        mov     eax, out_filename_buffer

.setoutputname:
        mov     [output_file], eax

        stdcall ProgressWndCreate, 7, 1, cProgressCaption,0

        invoke  SendMessage, [hProjManager], PMM_GETMAINFILE, 0, 0
        test    eax, eax
        jnz     .docompile

        mov     eax, [ptrCurrentFile]
        test    eax, eax
        jz      .finish

        cmp     [eax+TOpenFile.ptrType], ftCommonSource
        jne     .finish

.docompile:
        stdcall PrepareForCompilation, [eax+TOpenFile.hFileName]
        test    eax, eax
        jz      .outofmemory

        invoke  CreateThread, NULL, $4000, flat_assembler, NULL, NULL, comp_handle
        mov     [comp_handle], eax

        stdcall ShowModal, ebx, MSF_CENTER
        mov     [.exit], eax

        cmp     [.exit], MR_CANCEL
        jne     .compended

        invoke  TerminateThread, [comp_handle], -1

.compended:
        stdcall CleanupAfterCompilation

        cmp     [.exit], MR_OK
        je      .finalize

; find the error message.
        invoke  SendMessage, [frmMsg], MWM_FIRSTERROR, 0, 0

.finalize:
        invoke  CloseHandle, [comp_handle]
        stdcall ProgressWndDestroy
        mov     eax, [.exit]
        ret

.outofmemory:
        invoke  MessageBox, [hApplication], cOutOfMemory, NULL, MB_ICONERROR or MB_OK
        mov     eax, MR_ABORT
        ret

.finish:
        mov     eax, MR_ABORT
        ret
endp

uglobal
  comp_handle dd ?
endg

iglobal
    cProgressCaption db 'Compiling...',0
    cOutOfMemory db "Can't allocate memory for compilator. Check settings of Fresh.", 0
endg



proc OnDebug .wparam, .lparam
local .sinfo:STARTUPINFO
local .pinfo:PROCESS_INFORMATION
        stdcall OnCompile, 0, 0
        cmp     eax, MR_OK
        jne     .finish         ; There are errors during compilation.

;        cmp     [output_format],4
;        jae     OnRun.runObject

        mov     ecx, sizeof.STARTUPINFO
        shr     ecx, 2
        lea     edi,[.sinfo]
        xor     eax, eax
        rep stosd
        mov     [.sinfo.cb], sizeof.STARTUPINFO
        mov     [.sinfo.dwFlags],0

        stdcall GetExternalDebuggerName
        jc      .nodebuger

        push    eax

        stdcall StrCharCat, eax, ' '

.nodebuger:
        stdcall StrCat, eax, [CompiledFileName]
        stdcall StrPtr, eax

        lea     edx,[.sinfo]
        lea     ecx,[.pinfo]
        invoke  CreateProcess, NULL, eax, NULL,NULL,FALSE,NORMAL_PRIORITY_CLASS,NULL,NULL,edx,ecx
        stdcall StrDel ; from the stack
        test    eax,eax
        jnz     .ok

        stdcall LastError
.ok:
        invoke  CloseHandle,[.pinfo.hThread]
        invoke  CloseHandle,[.pinfo.hProcess]
.finish:
        ret
endp



proc OnClearMessages .wparam, .lparam
        invoke  SendMessage, [frmMsg], MWM_CLEARMESSAGES, 0, 0
        ret
endp



iglobal
  Window  dlgCategorySelect,  wtParent or wtEnd, waNone, 'TForm', 'Add category:', $06080000, WS_EX_DLGMODALFRAME, 0, 0, 0, 252, 208, CategorySelectProc
  Window  NONE,  wtChild, waNone, 'Static', 'Category &Name:', ComCtrlStyle, 0, 0, 4, 4, 200, 16, NULL
  Window  NONE,  wtChild, waNone, 'Edit', '', ComCtrlStyle or WS_TABSTOP or ES_AUTOHSCROLL,  WS_EX_CLIENTEDGE, 101, 4, 20, 236, 19, NULL
  Window  NONE,  wtChild, waNone, 'Static', 'Category &Icon:', ComCtrlStyle, 0, 0, 4, 42, 200, 16, NULL
  Window  NONE,  wtChild, waNone, LISTVIEW_CLASS, '', ComCtrlStyle or WS_TABSTOP or LVS_ICON or LVS_SINGLESEL or LVS_SHAREIMAGELISTS or LVS_NOLABELWRAP or LVS_AUTOARRANGE or LVS_NOSCROLL or LVS_SHOWSELALWAYS, WS_EX_CLIENTEDGE, 102, 4, 58, 236, 92, NULL
  Window  NONE,  wtChild, waNone, 'Button', 'OK', ComCtrlStyle or WS_TABSTOP or BS_DEFPUSHBUTTON, 0, MR_OK, 48, 156, 64, 24, NULL
  Window  NONE,  wtChild or wtEnd, waNone, 'Button', 'Cancel', ComCtrlStyle or WS_TABSTOP, 0, MR_CANCEL, 128, 156, 64, 24, NULL
endg


proc CategorySelectProc .hwnd, .wmsg, .wparam, .lparam
locals
.lvi LVITEM
.tvi TVITEM
.str rb 256
endl
        cmp     [.wmsg], FM_AFTERCREATE
        je      .aftercreate

        stc
        ret

.aftercreate:
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETIMAGELIST, LVSIL_NORMAL, [imlCategories]
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETICONSPACING, 0, $00240018
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_BORDERSELECT

        invoke  ImageList_GetImageCount, [imlCategories]
        mov     ebx, eax
        xor     esi, esi

.imageadd:
        lea     eax, [.str]
        lea     ecx, [esi+1]
        stdcall NumToStr, ecx, eax, 0, ntsUnsigned or ntsZeroTerminated or ntsDec

        mov     [.lvi.mask], LVIF_IMAGE or LVIF_TEXT
        mov     [.lvi.pszText], eax
        mov     [.lvi.iItem], esi
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.iImage], esi
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_INSERTITEM, 0, eax
        inc     esi
        dec     ebx
        jnz     .imageadd

        mov     [.lvi.stateMask], LVIS_FOCUSED or LVIS_SELECTED
        mov     [.lvi.state], LVIS_FOCUSED or LVIS_SELECTED
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETITEMSTATE, 0, eax

        invoke  GetDlgItem, [hProjManager], ProjTreeCtrlID
        mov     ebx, eax

        invoke  SendMessage, ebx, TVM_GETNEXTITEM, TVGN_CARET, 0
        stdcall GetFullItemName, ebx, eax
        push    eax
        stdcall StrPtr, eax
        invoke  SendDlgItemMessage, [.hwnd], 101, WM_SETTEXT, 0, eax
        invoke  SendDlgItemMessage, [.hwnd], 101, EM_SETSEL, 0, -1
        stdcall StrDel ; from the stack.

        clc
        ret
endp


proc OnAddCategory .wparam, .lparam
local .res:DWORD
        mov     [.res], FALSE

        stdcall CreateForm, dlgCategorySelect, [hApplication]

        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .finishadd

        invoke  SendDlgItemMessage, ebx, 102, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
        cmp     eax, -1
        jne     @f

        mov     eax, 4
@@:
        mov     edi, eax

        invoke   GetDlgItem, ebx, 101
        stdcall  GetControlText, eax
        push     eax ; for delete

        stdcall StrCharCat, eax, '\'
        stdcall GetCategoryTree, eax, TVI_ROOT, edi

        invoke  SendDlgItemMessage, [hProjManager], ProjTreeCtrlID, TVM_SELECTITEM, TVGN_CARET, eax

        stdcall StrDel ; From the stack.
        mov     [.res], TRUE

.finishadd:
        invoke  DestroyWindow, ebx
        mov     eax, [.res]
        ret
endp


proc OnAddFile .wparam, .lparam
        stdcall OpenFilesDialog, cAddFileTitle, TRUE, AllFilter, _AddFileCallback, FALSE, NULL
        ret
endp

proc _AddFileCallback .hFileName, .lParam
        stdcall OpenFileByName, [.hFileName], NULL, FALSE
        test    eax, eax
        jz      .finish
        invoke  SendMessage, [hProjManager], PMM_ADDFILE, eax, -1
.finish:
        ret
endp


proc OnSetMainFile .wparam, .lparam
        stdcall OpenFilesDialog, cSetMainTitle, FALSE, FileFilter, _SetMainCallback, NULL
        ret
endp


proc _SetMainCallback .hFileName, .dummy
        stdcall OpenFileByName, [.hFileName], NULL, FALSE
        test    eax, eax
        jz      .finish
        invoke  SendMessage, [hProjManager], PMM_ADDFILE, eax, 0
.finish:
        ret
endp




proc OnShowNotUsed, .wparam, .lparam
        stdcall OnClearMessages, 0, 0
        stdcall ShowNotUsed
        ret
endp


proc OnRearrangeWindows .wparam, .lparam
        stdcall RearrangeWindows
        ret
endp

proc OnNextWindow .wparam, .lparam
        invoke  SendMessage, [hEditorsHost], _EHM_SETACTIVETAB, 1, TRUE
        ret
endp



proc OnPrevWindow .wparam, .lparam
        invoke  SendMessage, [hEditorsHost], _EHM_SETACTIVETAB, -1, TRUE
        ret
endp


iglobal
  cIncludeFilesTitle db 'Filenames as "include" statement', 0
  cIncludeRoot       db '%finc%\', 0
endg

proc OnIncludeFile .wparam, .lparam
locals
  .aepos AEPOS
  .hwnd  dd ?
  .IncludeGroup dd ?
endl
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish

        mov     [.hwnd], eax

        stdcall StrNew
        mov     [.IncludeGroup], eax

        stdcall ConvertPath, cIncludeRoot
        push    eax
        stdcall OpenFilesDialog, cIncludeFilesTitle, TRUE, AllFilter, _DoInsertOneFile, eax, [.IncludeGroup]
        stdcall StrDel ; from the stack

        lea     esi, [.aepos]
        invoke  SendMessage, [.hwnd], AEM_GETPOS, esi, 0
        mov     [esi+AEPOS.caretPosition], 1
        mov     [esi+AEPOS.selectionPosition], 1
        mov     eax, [esi+AEPOS.caretLine]
        mov     [esi+AEPOS.selectionLine], eax
        invoke  SendMessage, [.hwnd], AEM_SETPOS, esi, 0

        invoke  SendMessage, [.hwnd], AEM_GETMODE, 0, 0
        push    eax
        invoke  SendMessage, [.hwnd], AEM_SETMODE, 0, 0

        stdcall StrCat, [.IncludeGroup], cIncludeEnd2
        stdcall StrPtr, [.IncludeGroup]
        invoke  SendMessage, [.hwnd], EM_REPLACESEL, TRUE, eax

        stdcall StrDel, [.IncludeGroup]

        pop     eax
        invoke  SendMessage, [.hwnd], AEM_SETMODE, eax, 0

        lea     esi, [.aepos]
        invoke  SendMessage, [.hwnd], AEM_GETPOS, esi, 0
        mov     eax, [esi+AEPOS.selectionPosition]
        mov     ecx, [esi+AEPOS.selectionLine]
        mov     [esi+AEPOS.caretPosition], eax
        mov     [esi+AEPOS.caretLine], ecx
        invoke  SendMessage, [.hwnd], AEM_SETPOS, esi, 0

.finish:
        ret
endp


proc _DoInsertOneFile .hFileName, .hGroup
        stdcall _RelativeToFinc, [.hFileName]
        stdcall StrCat, [.hGroup], cIncludeCommand

        stdcall StrCat, [.hGroup], eax
        stdcall StrDel, eax

        stdcall StrCat, [.hGroup], cIncludeEnd
        ret
endp


proc _RelativeToFinc .hFileName
local .olddir[1024]:BYTE
        lea     eax, [.olddir]
        invoke  GetCurrentDirectory, 1024, eax

        stdcall ConvertPath, cIncludeRoot
        push    eax

        stdcall StrPtr, eax
        invoke  SetCurrentDirectory, eax
        stdcall StrDel ; from the stack

        stdcall GetRelativePath, [.hFileName]
        stdcall StrInsert, eax, cIncludeRoot, 0
        push    eax

        lea     eax, [.olddir]
        invoke  SetCurrentDirectory, eax

        pop     eax
        ret
endp

;************************************************************************
; ReplaceVarString - replaces some variable (actually string) in hEdit with
; the value of hString.
; hEdit - handle of AsmEdit control
; ptrVar - pointer to varname string.
; hString - handle of the string that will replace the var name.
;************************************************************************
proc ReplaceVarString .hEdit, .ptrVar, .hString

local .oldpos:AEPOS
local .aepos:AEPOS

        push    ebx esi

        lea     eax, [.oldpos]
        invoke  SendMessage, [.hEdit], AEM_GETPOS, eax, 0

        stdcall StrPtr, [.hString]
        mov     esi, eax
        test    esi, esi
        jz      .endofsearch

        mov     ebx, [.hEdit]

        mov     [.aepos.selectionPosition], 1
        mov     [.aepos.selectionLine], 1
        mov     [.aepos.caretPosition], 1
        mov     [.aepos.caretLine], 1
        lea     eax, [.aepos]
        invoke  SendMessage, ebx, AEM_SETPOS, eax, 0
        invoke  SendMessage, ebx, AEM_FINDFIRST, AEFIND_CASESENSITIVE, [.ptrVar]
        test    eax, eax
        jz      .endofsearch

        invoke  SendMessage, ebx, EM_REPLACESEL, FALSE, esi

.loop:
        invoke  SendMessage, ebx, AEM_FINDNEXT, 0, 0
        test    eax, eax
        jz      .endofsearch

        invoke  SendMessage, ebx, EM_REPLACESEL, FALSE, esi
        jmp     .loop

.endofsearch:
        lea     eax, [.oldpos]
        invoke  SendMessage, [.hEdit], AEM_SETPOS, eax, 0

        pop     esi ebx
        ret
endp





        DispSize  'action events', ($ - ActionEvents)
