;************************************************************************************************
;* Fresh.asm
;*
;* This file is main file of the:
;*
;* ..::Fresh::.. - assembler RAD IDE with built-in FASM assembler.
;*
;* This is pre-alpha version, and it do almost nothing useful.
;* But there are already builded almost all ideas about user
;* interface and common behaviour.
;*
;* This work will be FreeWare with source. So, you can use it
;* for any purposes, but the copyright still remains with the
;* authors.
;*
;* Credits:
;*   Tomasz Grysztar (aka Privalov) - for exelent work with FASM
;*    - the base for Fresh.
;*
;* The team: (everyone is welcome)
;*    John Found
;*    Fredrik Klasson (aka scientica)
;*    Tommy Lillehagen
;*    Mateusz Tymek
;*    Victor Loh (aka roticv)
;*    Yunus Sina Gulsen (aka VeSCeRa)
;*
;*    Tomasz Grysztar - FASM compiler and AsmEdit control.
;*
;* Contact the authors: http://board.flatassembler.net/
;* FASM main site:      http://www.flatassembler.net/
;*
;************************************************************************************************
format PE GUI 4.0
stack 0x10020           ; 64K stack is required by HtmlHelp

entry start

include '%finc%\win32\win32a.inc'
include '%finc%\win32\equates\htmlhelp.inc'

;************************************************************************
; Macro library options...
;************************************************************************

..ShowSizes = 0      ; if 1 - displays the messages passed through
                     ; DispSize macro.

..ShowUserMessages = 0 ; if 1 - displays list with user defined Windows
                       ; messages - names and values, created by "message"
                       ; macro.


include 'version.inc'

include '%finc%\libs\msgutils.inc'
include '%finc%\libs\arrays.inc'
include '%finc%\libs\strlib.inc'
include '%finc%\libs\giflib.inc'
include '%finc%\libs\gui.inc'
include '%finc%\libs\parents.inc'
include '%finc%\libs\tform.inc'
include '%finc%\libs\templates.inc'
include '%finc%\libs\application.inc'
include '%finc%\libs\TDataGrid.inc'
include '%finc%\libs\lists.inc'
include 'asmedit\asmedit.inc'
include 'lister.inc'
include 'dumper.inc'
include 'designtime.inc'
include 'virtfiles.inc'
include 'macroses.inc'
include 'resourceid.inc'
include 'projmanager.inc'
include 'Controls.inc'
include 'editorhost.inc'
include 'msgwindow.inc'
include '%finc%/libs/splitter.inc'
include 'buttonedit.inc'
include 'propgrid.inc'
include 'MainWindow.inc'
include 'fasm/Version.inc'
include 'LabelsList.inc'
include 'debug.inc'
include 'debugger.inc'
include 'dbgserver.inc'
include 'propeditor.inc'
include 'formsDT.inc'
include 'filemanager.inc'
include 'FormEditor.inc'
include 'SizerClass.inc'

section '.code' code readable executable

  include '%finc%\libs\msgutils.asm'
  include '%finc%\libs\gui.asm'
  include '%finc%\libs\arrays.asm'
  include '%finc%\libs\strlib.asm'
  include '%finc%\libs\scrollbars.asm'
  include 'errors.asm'
  include 'LabelsList.asm'
  include 'fasm.asm'
  include 'virtfiles.asm'
  include 'LabelsExplorer.asm'
  include '%finc%\libs\parents.asm'
  include '%finc%\libs\tform.asm'
  include '%finc%\libs\templates.asm'
  include '%finc%\libs\application.asm'
  include '%finc%\libs\giflib.asm'
  include 'asmedit\asmedit.asm'
  include 'asmedit\syntax.asm'
  include 'Controls.asm'
  include 'SizerClass.asm'
  include '%finc%\libs\TDataGrid.asm'
  include 'MainWindow.asm'
  include 'ActionEvents.asm'
  include 'actNewFile.asm'
  include 'formutils.asm'
  include 'opendialog.asm'
  include 'propeditor.asm'
  include 'projmanager.asm'
  include 'msgwindow.asm'
  include 'palette.asm'

  include '%finc%/libs/splitter.asm'
  include 'propgrid.asm'
  include 'buttonedit.asm'

  include 'progresswnd.frm'

  include 'findreplace.asm'
  include 'editorhost.asm'
  include 'sourceeditor.asm'

  include 'fileutils.asm'
  include 'mrulist.asm'

  include 'IDEparams.asm'

  include 'HelpFilesOptions.frm'

  include 'EditPath.frm'
  include 'EditPathsOptions.frm'
  include 'IDEOptions.frm'

  include 'formsDT.asm'
  include 'help.asm'

  include 'lister.asm'
  include 'dumper.asm'

  include 'dbgserver.asm'
  include 'debugger.asm'
  include 'debug.asm'

  include 'dialogs.asm'
  include '%finc%\libs\lists.asm'
  include 'FormEditor.asm'

  include 'filemanager.asm'
  include 'watcheditor.frm'

  include 'EDITOptions.frm'
  include 'EditorBehaviour.frm'
  include 'EditorColors.frm'

  include 'frmStyleEditor.frm'
  include 'ProjectOptions.frm'
  include 'GraphicEditor.frm'
  include 'templates.frm'
  include 'ExternalOptions.frm'

; Common initialized globals
iglobal
  ; Standard class names
  cEditClassName          db      'EDIT',0
  cStaticClassName        db      'STATIC', 0
  cButtonClassName        db      'BUTTON', 0
  cComboClassName         db      'COMBOBOX', 0
  cScrollClassName        db      'SCROLLBAR', 0
  cListboxClassName       db      'LISTBOX', 0
  ; some CommCtrl class names
  cTabClassName           db      TABCONTROL_CLASS, 0
  cTreeViewClassName      db      TREEVIEW_CLASS, 0
  cStatusBarClassName     db      STATUS_CLASS, 0
  cProgressbarClassName   db      PROGRESS_CLASS, 0
  cListviewClassName      db      LISTVIEW_CLASS, 0
uglobal
  hInstance       dd 0  ; Instance handle for common use.
  hHeap           dd 0
  hFreshDirectory dd 0  ; string containing Fresh directory.
  ComCtrlsFlags   INITCOMMONCONTROLSEX
endg


start:

; Main init sequence
        invoke  GetModuleHandle,0
        mov     [hInstance],eax
        invoke  GetProcessHeap
        mov     [hHeap], eax

; Init ALL common controls
        mov     [ComCtrlsFlags.dwSize], sizeof.INITCOMMONCONTROLSEX
        mov     [ComCtrlsFlags.dwICC], $1fff
        invoke  InitCommonControlsEx,ComCtrlsFlags

; Init COM
        invoke  CoInitializeEx, 0,2   ;COINIT_APARTMENTTHREADED

; call all "initialize" procedures in the included modules...
        InitializeAll
        call PreapareSyntaxStr

; Startup windows creation
        stdcall InitApplication, resAppIcon, cMainTitle

; Accelerator table creating
        invoke  CreateAcceleratorTable, Accelerators, [Accelerators.Count]
        invoke  SetProp, [hApplication], [propAccelerators], eax
        invoke  SetProp, [hApplication], [propOnIdle], OnIdle
        stdcall InitMainWindow, [hApplication]  ; Create main window.
        stdcall RearrangeWindows

; Create the tool palette
        stdcall  OnReloadVCL, 0, [hMainWindow]

; Command line parameters.
        stdcall  ParseCommandLine

        stdcall StrNew
        mov     ebx,eax
        mov     [hFreshDirectory],eax
        stdcall StrSetLength, eax,MAX_PATH
        stdcall StrPtr, ebx
        push    eax
        push    eax

        invoke  GetModuleFileName, [hInstance], eax, MAX_PATH
        stdcall ExtractDirectory   ; arguments from stack


; Main message loop
Run:
        call    ProcessMessages
        jc      .terminate

if defined AppLib
        invoke  SendMessage, [hApplication], AM_ONIDLE, 0, 0
end if
        invoke  WaitMessage
        jmp     Run

.terminate:
        push    eax

        invoke  CoUninitialize

        FinalizeAll
        invoke  ExitProcess ; exit code from the stack.
        int3                ; this instruction never will be executed.


;*****************************************************************
; Main static data section.
; Actually this is the only data section in the program.
;*****************************************************************
section '.data' data readable writeable

  IncludeAllGlobals


section '.idata' import data readable writeable

        ImportLib "%finc%\win32\apia\",      \
            kernel32,   \
            user32,     \
            gdi32,      \
            comctl32,   \
            comdlg32,   \
            shell32,    \
            ole32

section '.res' resource from 'images\freshnew.res' data readable