;<ff
Window frmMainOptions, 3, 0, 'TForm', 'IDE options', $6480000, $10001, 0, 170, 222, 460, 320, IDEOptionsWinProc;
Window NONE, 0, 1, 'SysListView32', 'ListView', $5000200C, $200, 1000, 0, 0, 128, 286, 0;
Window NONE, 3, 4, 'TForm', 'Form', $50000000, $10000, 1001, 128, 246, 324, 40, 0;
Window NONE, 0, 0, 'BUTTON', 'OK', $50010001, $0, 1, 184, 8, 64, 25, 0;
Window NONE, 2, 0, 'BUTTON', 'Cancel', $50010000, $0, 2, 256, 8, 64, 25, 0;
;ff>
;***********************************************************
; This file contains routines for reading/writing/handling
; parameters of Fresh IDE
;***********************************************************

; Special OM_ messages for options applet windows.
message OM_SAVEOPTIONS
message OM_LOADOPTIONS


iglobal
  cTitleBtnEdit db '...',0      ; common button text for TButtonEdit

  cOptionsApplets dd frmIDEOptions, frmExternalOptions, frmHelpFiles, 0
endg

;---------------------------------------------------
; Opens IDE options dialog.
;---------------------------------------------------
proc OnIDEOptions .wparam, .lparam
locals
.str rb 1024
.lvi LVITEM
.ptr dd ?
endl
        stdcall CreateForm, frmMainOptions, [hMainWindow]
        stdcall ShowModal, ebx, MSF_CENTER
        invoke  DestroyWindow, ebx

        stdcall CheckParams
        invoke  PostMessage, [hMainWindow], WM_COMMAND, actReloadVCL, 0
        ret
endp



;-----------------------------------------------------------------------
; Window procedure for the Options form.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
winproc IDEOptionsWinProc

local .lvi:LVITEM

ondefault
        stc
        ret

onmessage WM_COMMAND
        cmp     word [wparam], MR_OK
        jne     .ondefault

        invoke  GetDlgItem, [hwnd], 1000
        mov     ebx, eax
        lea     edi, [.lvi]

        invoke  SendMessage, ebx, LVM_GETITEMCOUNT, 0, 0
        dec     eax
        mov     [edi+LVITEM.iItem], eax

        mov     [edi+LVITEM.mask], LVIF_PARAM
        mov     [edi+LVITEM.iSubItem], 0

.itemsave:
        invoke  SendMessage, ebx, LVM_GETITEM, 0, edi
        invoke  SendMessage, [edi+LVITEM.lParam], OM_SAVEOPTIONS, 0, 0
        dec     [edi+LVITEM.iItem]
        jns     .itemsave

        jmp     .ondefault


onmessage WM_NOTIFY

        cmp     [wparam], 1000
        jne     .ondefault

        mov     esi, [lparam]
        cmp     [esi+NMHDR.code], LVN_ITEMCHANGED
        jne     .ondefault

        test    [esi+NMLISTVIEW.uChanged], LVIF_STATE
        jz      .ondefault

        mov     eax, [esi+NMLISTVIEW.uNewState]
        xor     eax, [esi+NMLISTVIEW.uOldState]
        test    eax, LVIS_FOCUSED
        jz      .ondefault

        mov     ecx, SW_SHOWNORMAL
        test    [esi+NMLISTVIEW.uNewState], LVIS_FOCUSED
        jnz     @f
        mov     ecx, SW_HIDE
@@:

; show window
        invoke  ShowWindow, [esi+NMLISTVIEW.lParam], ecx
        stdcall AlignChildren, [hwnd]

        clc
        ret


onmessage FM_AFTERCREATE
locals
  .hlv dd ?
  .rect RECT
endl
        invoke  GetDlgItem, [hwnd], 1000
        mov     ebx, eax

        lea     eax, [.rect]
        invoke  GetClientRect, ebx, eax
        mov     eax, 64 shl 16
        mov     ax, word [.rect.right]

        invoke  SendDlgItemMessage, [hwnd], 1000, LVM_SETICONSPACING, 0, eax

        invoke  GetDlgItem, [hwnd], 1000
        mov     [.hlv], eax

        stdcall ImageList_LoadGif, [hInstance], 282, 32, FALSE
        invoke  SendMessage, [.hlv], LVM_SETIMAGELIST, LVSIL_NORMAL, eax

        xor     esi, esi
        lea     edi, [.lvi]

        mov     [edi+LVITEM.mask], LVIF_TEXT or LVIF_PARAM or LVIF_IMAGE
        mov     [edi+LVITEM.iSubItem], 0


.addloop:
        mov     ecx, [4*esi+cOptionsApplets]
        jecxz   .endadd

        stdcall CreateForm, ecx, [hwnd]
        stdcall SetAlign, ebx, waClient

        mov     [edi+LVITEM.lParam], ebx
        stdcall GetControlText, ebx, 0
        push    eax

        stdcall StrPtr, eax
        mov     [edi+LVITEM.pszText], eax
        mov     [edi+LVITEM.iImage], esi

        invoke  SendMessage, [.hlv], LVM_INSERTITEM, 0, edi

        stdcall StrDel ; from the stack.

        invoke  SendMessage, ebx, OM_LOADOPTIONS, 0, 0

        inc     esi
        jmp     .addloop

.endadd:
        invoke  SendMessage, [.hlv], LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_BORDERSELECT

        stdcall ListViewCenterIcons, [.hlv], 64

        mov     [.lvi.stateMask], TVIS_FOCUSED or TVIS_SELECTED
        mov     [.lvi.state], TVIS_FOCUSED or TVIS_SELECTED
        lea     eax, [.lvi]
        invoke  SendMessage, [.hlv], LVM_SETITEMSTATE, 0, eax

        clc
        ret

endwp




proc ButtonEditFileSelect .hFileName, .hButtonEdit
        stdcall StrPtr, [.hFileName]
        invoke  SendMessage, [.hButtonEdit], WM_SETTEXT, 0, eax
        ret
endp



proc ListViewCenterIcons .hListView, .ystep
locals
.lvi LVITEM
.rect RECT
.point POINT
endl
        lea     eax, [.rect]
        invoke  GetClientRect, [.hListView], eax

        invoke  SendMessage, [.hListView], LVM_GETITEMCOUNT, 0, 0
        mov     ebx, eax

        mov     edi, [.ystep]

        imul    eax, edi
        add     eax, 16
        mov     [.point.y], eax

        mov     eax, [.rect.right]
        sar     eax, 1
        sub     eax, 16         ; for 32x32 icons
        mov     [.point.x], eax

        lea     esi, [.point]

.itemloop:
        dec     ebx
        js      .endloop

        sub     [esi+POINT.y], edi

        invoke  SendMessage, [.hListView], LVM_SETITEMPOSITION32, ebx, esi
        jmp     .itemloop

.endloop:
        ret
endp