iglobal
  cHHCtrlLib    db "HHCTRL.OCX", 0
  cHtmlHelpA    db "HtmlHelpA", 0
  cFreshHelp    db "%fresh%\"
  cFreshDefHelp db "doc\freshguide.chm", 0
  .size = $ - cFreshDefHelp
endg

uglobal
  HtmlHelp     dd ?
  hHHCtrl      dd ?
  hDefHelpFile dd ?
endg

proc InitHelp
        invoke  LoadLibrary, cHHCtrlLib
        mov     [hHHCtrl],eax
        or      eax,eax
        jz      .finish
        invoke  GetProcAddress, eax, cHtmlHelpA
        mov     [HtmlHelp],eax

; Edited by JohnFound 01.02.2004
        stdcall ConvertPath, cFreshHelp
        mov     ebx,eax
        stdcall FileExists, ebx
        jz      .default_dir

        mov     [hDefHelpFile],ebx
        jmp     .finish

     .default_dir:
        ; Valid string handle already exists in ebx

        stdcall StrSetLength, ebx, MAX_PATH
        stdcall StrPtr,ebx

        mov     edi,eax
        invoke  GetModuleFileName, NULL, edi, MAX_PATH
        test    eax, eax
        jz      .fault

        add     edi,eax ; eax contains the length of the string in edi.
        dec     edi
        ; search for '/' or '\'
     .find_slash:
        cmp     byte[edi],'\'
        je      .got_slash
        cmp     byte[edi],'/'
        je      .got_slash
        dec     edi
        dec     eax
        jnz     .find_slash

     .got_slash:
        inc     edi
        mov     ecx, cFreshDefHelp.size
        mov     esi, cFreshDefHelp
        rep movsb
        mov     [hDefHelpFile],ebx

     .finish:
        ret

.fault:
        stdcall StrDel, ebx
        mov     [hDefHelpFile],0
        ret
endp


uglobal
  OnHelp.aklink    HH_AKLINK
  OnHelp.hHelpPath dd ?
endg

proc OnHelp uses ebx esi, .wparam, .lparam
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, 0, 0
        test    eax, eax
        jz      .finish
        mov     ebx,eax

        mov     esi,[lpszReadLine]
        invoke  SendMessage, ebx, AEM_GETWORDATCARET, 0xffff, esi

        cmp     [HtmlHelp],NULL
        je      .winhelp

        xor     eax,eax

        cmp     [hDefHelpFile], eax
        je      .winhelp

        mov     [.aklink.cbStruct],sizeof.HH_AKLINK
        mov     [.aklink.fReserved],eax
        mov     [.aklink.pszUrl],eax
        mov     [.aklink.pszMsgText],eax
        mov     [.aklink.pszMsgTitle],eax
        mov     [.aklink.pszWindow],eax
        mov     [.aklink.fIndexOnFail],eax

        stdcall StrPtr, [hDefHelpFile]
        mov     ebx,eax
        lea     eax,[.aklink]
        invoke  HtmlHelp, NULL, ebx, HH_KEYWORD_LOOKUP, eax
        or      eax,eax   ; if eax==0 then given word donesn't exist in fresh help
        jnz     .finish   ;  file - so we search in user defined help file

.winhelp:
        mov     ebx,[lpszReadLine]
        stdcall GetHelpFileName
        jc      .finish
        push    eax
        stdcall StrPtr, eax
        invoke  WinHelp, [hEditorsHost], eax, HELP_PARTIALKEY, ebx
        stdcall StrDel ; from the stack
.finish:
        ret
endp
