ttText = 0
ttStr = 1
ttRem = 2
ttNum = 3
ttChar = 4

clDefaultText   = 0
clSymbol        = 1
clNumber        = 2
clString        = 3
clComment       = 4
clRegister      = 5
clInstruction   = 6

uglobal
  hSyntaxStr    dd ?
  iSyntaxStrLen dd ?
  lbuf rb 0x10000
endg


initialize PreapareSyntaxStr
        stdcall StrNew
        mov     [hSyntaxStr],eax
        stdcall StrSetLength, eax,256
        mov     [iSyntaxStrLen],255
        ret
endp

finalize DestroySyntaxStr
        stdcall StrDel, [hSyntaxStr]
        ret
endp

proc fasm_syntax uses esi edi ebx, .ptrLine,.uChars,.ptrColors
locals
.status      dd ?
.wlen        dd ?
.w           dd ?
.lastword    dd ?
.Quo         db ?
endl
        pushad
        mov     eax,[.uChars]
        cmp     [iSyntaxStrLen],eax
        ja      .buffer_ok
        stdcall StrSetLength, [hSyntaxStr],eax
   .buffer_ok:
        stdcall StrPtr, [hSyntaxStr]
        mov     [.w],eax
        mov     [.status],ttText
        xor     ah,ah
        mov     [.wlen], 0
        mov     esi, [.ptrLine]
        mov     edi, [.ptrColors]
        mov     [.lastword], edi
        mov     ecx,[.uChars]

.loop:
        lodsb
        cmp     [.status], ttRem
        je      .endif
        cmp     [.status], ttStr
        jne     .ifnotstr
        cmp     al,[.Quo]
        jne     .endif
        mov     [.status], ttText
        jmp     .endif

.ifnotstr:
        cmp     al, ';'
        jne     .notrem
        mov     [.status], ttRem
        mov     ah, clComment
        jmp     .endif

.notrem:
        cmp     al, '"'
        je      .str
        cmp     al, "'"
        jne     .notstr

.str:
        mov     [.status], ttStr
        mov     [.Quo], al
        mov     ah, clString
        jmp     .endif

.notstr:
        call    .CharInSymbols
        jnc     .notsym
        mov     [.status], ttChar
        mov     ah, clSymbol
        call    .MakeWord
        jmp     .endif

.notsym:
        lea     edx,[esi-1]             ; johnfound: first char number bug fix
        cmp     edx, [.ptrLine]          ;
        je      .maybenum               ;

        cmp     [.status], ttChar
        jne     .notnumbeg

.maybenum:                                 ;
        call    .CharInNum
        jnc     .notnum
        mov      [.status], ttNum
        mov      ah, clNumber
        jmp      .endif

.notnum:
        mov     [.status], ttText
        xor     ah,ah
        mov     [.wlen], 1
        mov     edx,[.w]
        mov     [edx], al
        mov     [.lastword], edi
        jmp     .endif

.notnumbeg:
        cmp     [.status], ttText
        jne     .endif
        xor     ah,ah
        mov     ebx, [.w]
        add     ebx, [.wlen]
        mov     [ebx], al
        inc     [.wlen]

.endif:
        mov     [edi], ah
        inc     edi
        dec     ecx
        jnz     .loop

.endwhile:
        popad
        ret

.MakeWord:
        push    edi esi eax ecx
        cmp     [.wlen],0
        je      .end
        mov     ah, clRegister
        mov     esi, [.w]
        push    esi edi
        mov     edi, [.w]
 .new_char:
        lodsb
        cmp     al,0
        je      .ok
        cmp     al,"A"
        jl      @F
        cmp     al,"Z"
        jg      @F
        add     al,20h
        @@:
        stosb
        jmp     .new_char
        .ok:
        pop     edi esi
        stdcall FindInstr, sRegs, esi, [.wlen]
        jc      .found
        mov     ah, clInstruction
        stdcall FindInstr, sInstr, esi, [.wlen]
        jnc      .notfound

.found:
        mov     ebx, [.wlen]
        mov     edi, [.lastword]

.chgcolor:
        mov     [edi], ah
        inc     edi
        dec     ebx
        jnz     .chgcolor

.notfound:
        and     [.wlen], 0

.end:
        pop     ecx eax esi edi
        retn


.CharInSymbols:
        push    esi eax
        mov     esi, chars

@@:
        mov     ah, [esi]
        inc     esi
        test    ah,ah
        jz      @f
        cmp     al, ah
        jne     @b
        stc
        pop     eax esi
        retn

@@:
        clc
        pop     eax esi
        retn


.CharInNum:
        cmp     al, '$'
        jne     @f
        stc
        retn

@@:
        cmp     al, '0'
        jb      @f
        cmp     al, '9'
        ja      @f
        stc
        retn

@@:
        clc
        retn
endp



proc FindInstr .ptrArray, .ptrWord, .len
local .koko:DWORD

        push    eax ebx ecx edx esi edi

        mov     ecx, [.ptrArray]
        mov     edi, [.ptrWord]
        mov     edx, [.len]

        cmp     edx, [ecx]
        jb      .notfound

        cmp     edx, [ecx+4]
        ja      .notfound

        mov     esi, [ecx+8]
        sub     edx, [ecx]
        movzx   ebx, word [esi+2*edx]
        add     esi, ebx
        mov     edx,[.len]
        add     edx, 3

.loopmain:
        xor     ebx, ebx

.loopword:
        mov     al,[esi+ebx]
        test    al,al
        jz      .notfound
        cmp     [edi+ebx], al
        ja      .next
        jb      .notfound
        inc     ebx
        cmp     ebx, [.len]
        jne     .loopword
        stc
        jmp     .end

.next:
        add     esi, edx
        jmp     .loopmain

.notfound:
        clc

.end:
        pop     edi esi edx ecx ebx eax
        ret
endp


  macro dps [txt] {
    forward
      if txt eq 0
        db 0
      else
        db txt
        db 0
        dw 0
      end if
  }


  struc synList minLen,maxLen,ptr {
    .MinLen  dd minLen
    .MaxLen  dd maxLen
    .ptrList dd ptr
  }


iglobal
  sInstr synList 2, 11, instructions
  sRegs  synList 2, 4, regs

  regs:
    dw reg2-regs
    dw reg3-regs
    dw reg4-regs

  reg2:
    dps 'ah','al','ax','bh','bl','bp','bx','ch','cl','cs','cx','dh'
    dps 'di','dl','ds','dx','es','fs','gs','si','sp','ss','st',0

  reg3:
    dps 'cr0','cr2','cr3','cr4','dr0','dr1','dr2','dr3','dr5','dr6'
    dps 'dr7','eax','ebp','ebx','ecx','edi','edx','esi','esp','mm0'
    dps 'mm1','mm2','mm3','mm4','mm5','mm6','mm7','st0','st1','st2'
    dps 'st3','st4','st5','st6','st7','st8',0

  reg4:
    dps 'xmm0','xmm1','xmm2','xmm3','xmm4','xmm5','xmm6','xmm7',0

  chars db ' +-/*:=|&~()[]<>{},\#',0
endg


;ttText = 0
;ttStr = 1
;ttRem = 2
;ttNum = 3
;ttChar = 4
;
;clDefaultText   = 0
;clSymbol        = 1
;clNumber        = 2
;clString        = 3
;clComment       = 4
;clRegister      = 5
;clInstruction   = 6
;
;proc fasm_syntax .lpLine,.uChars,.lpColors
;        push    ebx esi edi
;        mov     esi,[.lpLine]
;        mov     edi,[.lpColors]
;        mov     ebx,characters
;        mov     ecx,[.uChars]
;        xor     edx,edx
;  .scan_syntax:
;        lodsb
;  .check_character:
;        cmp     al,20h
;        je      .syntax_space
;        cmp     al,3Bh
;        je      .syntax_comment
;        mov     ah,al
;        xlatb
;        or      al,al
;        jz      .syntax_symbol
;        or      edx,edx
;        jnz     .syntax_neutral
;        cmp     ah,27h
;        je      .syntax_string
;        cmp     ah,22h
;        je      .syntax_string
;        cmp     ah,24h
;        je      .syntax_pascal_hex
;        cmp     ah,39h
;        ja      .syntax_neutral
;        cmp     ah,30h
;        jae     .syntax_number
;  .syntax_neutral:
;        or      edx,-1
;        inc     edi
;        loop    .scan_syntax
;        jmp     .done
;  .syntax_space:
;        xor     edx,edx
;        inc     edi
;        loop    .scan_syntax
;        jmp     .done
;  .syntax_pascal_hex:
;        cmp     ecx,1
;        je      .syntax_number
;        mov     al,[esi]
;        cmp     al,20h
;        je      .syntax_neutral
;        cmp     al,3Bh
;        je      .syntax_neutral
;        xlatb
;        or      al,al
;        jz      .syntax_neutral
;  .syntax_number:
;        mov     al,2
;        stosb
;        loop    .number_character
;        jmp     .done
;  .number_character:
;        lodsb
;        mov     ah,al
;        xlatb
;        xchg    al,ah
;        or      ah,ah
;        jz      .check_character
;        cmp     al,20h
;        je      .check_character
;        cmp     al,3Bh
;        je      .check_character
;        mov     al,2
;        stosb
;        loop    .number_character
;        jmp     .done
;  .syntax_symbol:
;        mov     al,1
;        stosb
;        xor     edx,edx
;        loop    .scan_syntax
;        jmp     .done
;  .syntax_string:
;        mov     al,3
;        stosb
;        dec     ecx
;        jz      .done
;        lodsb
;        cmp     al,ah
;        jne     .syntax_string
;        mov     al,3
;        stosb
;        dec     ecx
;        jz      .done
;        lodsb
;        cmp     al,ah
;        je      .syntax_string
;        xor     edx,edx
;        jmp     .check_character
;  .syntax_comment:
;        mov     al,4
;        stosb
;        loop    .syntax_comment
;  .done:
;        pop     edi esi ebx
;        ret
;endp