proc PseudoAlign .hwnd, .ptrRect, .winalign
local .bounds:TBounds
        lea     eax, [.bounds]
        stdcall AlignWindow, [.hwnd], [.ptrRect], eax, [.winalign]
        test    eax, eax
        jz      .finish
        invoke  SetWindowPos, [.hwnd], NULL,                                                     \
                              [.bounds.x], [.bounds.y], [.bounds.width], [.bounds.height],      \
                              SWP_NOZORDER or SWP_NOCOPYBITS
.finish:
        ret
endp



proc RearrangeWindows
local .workrect:RECT
local .rect1   :RECT
local .rect2   :RECT
        push    ebx

        lea     ebx, [.workrect]
        invoke  GetClientRect, [hMainWindow], ebx
        mov     [.workrect.bottom], 80
        invoke  AdjustWindowRectEx, ebx, [MainForm+TWinTemplate.style], TRUE, [MainForm+TWinTemplate.styleEx]

        mov     eax, [.workrect.bottom]
        mov     ecx, [.workrect.right]
        sub     eax, [.workrect.top]
        sub     ecx, [.workrect.left]
        invoke  SetWindowPos, [hMainWindow], 0, 0, 0, ecx, eax, SWP_NOMOVE or SWP_NOZORDER

        lea     ebx, [.workrect]
        invoke  SystemParametersInfo, SPI_GETWORKAREA,0,ebx,0
        stdcall PseudoAlign, [hMainWindow], ebx, waTop


        invoke  IsWindowVisible, [hProjManager]
        mov     esi, eax
        invoke  IsWindowVisible, [hPropEditor]
        test    esi, eax
        jnz     .both

        mov     ecx, [hProjManager]
        test    esi, esi
        jnz     .leftpane
        mov     ecx, [hPropEditor]
        test    eax, eax
        jz      .client

.leftpane:
        stdcall PseudoAlign, ecx, ebx, waLeft
        jmp     .client

.both:
        stdcall PseudoAlign, [hPropEditor], ebx, waLeft

        lea     eax, [.rect1]
        invoke  GetWindowRect, [hPropEditor], eax

        mov     eax, [.rect1.left]
        mov     ecx, [.rect1.right]
        sub     ecx, eax
        mov     [.rect2.left], eax
        mov     [.rect2.right], ecx
        mov     [.rect1.right], ecx

        mov     eax, [.rect1.top]
        mov     ecx, [.rect1.bottom]
        sub     ecx, eax
        sar     ecx, 1
        add     eax, ecx
        mov     [.rect2.top], eax
        mov     [.rect2.bottom], ecx
        mov     [.rect1.bottom], ecx

        invoke  SetWindowPos, [hPropEditor], NULL, [.rect1.left], [.rect1.top], [.rect1.right], [.rect1.bottom], SWP_NOZORDER or SWP_NOACTIVATE
        invoke  SetWindowPos, [hProjManager], NULL, [.rect2.left], [.rect2.top], [.rect2.right], [.rect2.bottom], SWP_NOZORDER or SWP_NOACTIVATE

.client:
        stdcall PseudoAlign, [hEditorsHost], ebx, waClient

        invoke  SetFocus, [hEditorsHost]

        pop     ebx
        ret
endp