;
;  Controls.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

iglobal
  xGrid 	  dd 8
  yGrid 	  dd 8
  fGridVisible	  dd TRUE
  fSnapToGrid	  dd TRUE
  fPartialSelect  dd TRUE
endg


;-----------------------------------------------------------------------
; Window procedure of the subclassed designtime window.
; It make window to behave properly in visual editor - selecting, moving
; resize etc.
; Also, it inhibits the main functionality of the controls.
;------------------------------------------------------------------------
winproc procDesignControl
locals
.rect RECT
.rect0 RECT
.pnt	POINT
.pnt0	POINT
endl
	invoke	GetProp, [hwnd], [propTemplateDT]
	mov	edi, eax
	test	eax, eax
	jz	.ondefault

ondefault
	stc
	ret
;-----------------------------------------------------------------
onmessage WM_NCHITTEST

	invoke	GetProp, [hwnd], [propOldWinProc]
	test	eax, eax
	jz	@f

	invoke	CallWindowProc, eax, [hwnd], [wmsg], [wparam], [lparam]
	cmp	eax, -1

	jne	@f
	mov	eax, HTCLIENT
@@:
	clc
	ret

;-----------------------------------------------------------------
onmessage WM_MOUSEACTIVATE
	mov	eax, MA_NOACTIVATE
	clc
	ret

;-----------------------------------------------------------------
onmessage WM_ACTIVATE
	mov	ebx, [edi+TWinTemplateDT.ptrFile]
	test	ebx, ebx
	jz	.endactivate
	stdcall SetCurrentFile, ebx

	mov	ebx, [ebx+TOpenFile.hEditor]
	test	ebx, ebx
	jz	.endactivate

	invoke	SetProp, ebx, [propVisualMode], 1

.endactivate:
	mov	eax, edi
	stdcall GetSizer
	invoke	SetFocus, eax
	xor	eax, eax
	clc
	ret

;------------------------------------------------------------------
onmessage WM_SETFOCUS
	mov	eax, edi
	stdcall GetSizer
	invoke	SetFocus, eax
	xor	eax,eax
	clc
	ret

;-------------------------------------------------------------------
onmessage WM_ERASEBKGND
	lea	ebx, [.rect]
	invoke	GetClientRect, [hwnd], ebx

	invoke	GetClassLong, [hwnd], GCL_HBRBACKGROUND
	test	eax,eax
	jnz	.brushok

	invoke	GetSysColorBrush, COLOR_BTNFACE

.brushok:
	invoke	FillRect, [wparam], ebx, eax

	invoke	GetWindowLong, [hwnd], GWL_STYLE
	test	eax,WS_CHILD
	jnz	.ondefault

	cmp	[fGridVisible], FALSE
	je	.enderase

	invoke	CreatePen, PS_SOLID, 0, $00a0a0a0
	invoke	SelectObject, [wparam], eax
	push	eax

	xor	edi, edi
.loopx:
	invoke	MoveToEx, [wparam], edi, 0, NULL
	invoke	LineTo,   [wparam], edi, [.rect.bottom]

	add	edi, [xGrid]
	cmp	edi, [.rect.right]
	jbe	.loopx

	xor	edi, edi
.loopy:
	invoke	MoveToEx, [wparam], 0, edi, NULL
	invoke	LineTo,   [wparam], [.rect.right], edi

	add	edi, [yGrid]
	cmp	edi, [.rect.bottom]
	jbe	.loopy

	invoke	SelectObject, [wparam]
	invoke	DeleteObject, eax

.enderase:
	xor	eax,eax
	clc
	ret


;-------------------------------------------------------------------
onmessage WM_SETCURSOR

	invoke	GetWindowLong, [hwnd], GWL_HWNDPARENT
	cmp	eax, [hApplication]			    ; ????
	je	.ondefault

	invoke	LoadCursor,NULL,IDC_ARROW
	invoke	SetCursor,eax
	xor	eax,eax
	clc
	ret

;---------------------------------------------------------------------------
onmessage WM_WINDOWPOSCHANGED

	mov	ebx, [lparam]
	mov	eax, [ebx+WINDOWPOS.flags]
	and	eax, SWP_NOSIZE or SWP_NOMOVE
	cmp	eax, SWP_NOSIZE or SWP_NOMOVE
	je	.endposchanged

	xor	ecx, ecx
	test	eax, SWP_NOSIZE
	jnz	.sizeok

	mov	eax, [ebx+WINDOWPOS.cx]
	mov	edx, [ebx+WINDOWPOS.cy]
	mov	[edi+TWinTemplateDT.width], ax
	mov	[edi+TWinTemplateDT.height], dx
	or	ecx, upSize

.sizeok:
	test	eax, SWP_NOMOVE
	jnz	.posok

	mov	eax, [ebx+WINDOWPOS.x]
	mov	edx, [ebx+WINDOWPOS.y]
	mov	[edi+TWinTemplateDT.left], ax
	mov	[edi+TWinTemplateDT.top], dx
	or	ecx, upPosition

.posok:
	invoke	PostMessage, [hPropEditor], PRM_UPDATEPROP, edi, ecx

	cmp	[edi+TWinTemplateDT.parent], 0
	je	.updatesizer

	cmp	[edi+TWinTemplateDT.Align], waNone
	je	.updatesizerok

.updatesizer:
	mov	eax, edi
	stdcall GetSizer
	invoke	SendMessage, eax, SZM_UPDATESIZE, 0, 0

.updatesizerok:
; Mark control as modified...
	mov    eax, edi
.search:
	cmp	[eax+TWinTemplateDT.parent], 0
	je	.found
	mov	eax, [eax+TWinTemplateDT.parent]
	jmp	.search

.found:
	mov	eax, [eax+TWinTemplateDT.ptrFile]
	invoke	SendMessage, [eax+TOpenFile.hEditor], _CEM_SETMODIFIED, TRUE, 0

.endposchanged:
	stdcall AlignChildren, [hwnd]
	xor	eax, eax
	clc
	ret

	cmp	[edi+TWinTemplateDT.Align], waNone
	jne	.quitsize

	cmp	[edi+TWinTemplateDT.parent], 0
	jne	.quitsize

	stc
	ret

.quitsize:
	xor	eax, eax
	clc
	ret

;-------------------------------------------------------------------
onmessage WM_CLOSE
	invoke	SetFocus, [hEditorsHost]
	invoke	ShowWindow, [hwnd], SW_HIDE

	xor	eax, eax
	clc
	ret

;-------------------------------------------------------------------
onmessage WM_LBUTTONDOWN
  locals
    .cursorpos POINT
    .tool      dd ?
  endl
	stdcall GetCurrentTool
	mov	[.tool], eax
	test	eax, eax
	jnz	.selectrect

	test	[wparam], MK_SHIFT
	jnz	.selectrect

	mov	esi, [edi+TWinTemplateDT.parent]
	test	esi, esi
	jz	.topselectrect

	mov	ecx, 1
	test	[wparam], MK_CONTROL
	jnz	@f
	dec	ecx
@@:
; select one control
	mov	eax, esi
	stdcall GetSizer
	mov	esi, eax
	invoke	SendMessage, esi, SZM_SELECTCONTROL, edi, ecx

	test	[wparam], MK_CONTROL
	jnz	.endsingleselect

	lea	ebx, [.cursorpos]
	invoke	GetCursorPos, ebx
	invoke	ScreenToClient, esi, ebx
	mov	ax, word [.cursorpos.y]
	shl	eax, 16
	mov	ax, word [.cursorpos.x]

	invoke	SendMessage, esi, WM_LBUTTONDOWN, [wparam], eax

.endsingleselect:
	xor	eax, eax
	clc
	ret

.topselectrect:
	invoke	SendDlgItemMessage, [hPropEditor], 101, PEM_SETCONTROL, edi, 0

.selectrect:
	test	[wparam], MK_CONTROL
	jnz	@f
	mov	eax, edi
	stdcall GetSizer
	invoke	SendMessage, eax, SZM_UNSELECTALL, 0, 0
@@:
; search window to get capture...
.parentloop:
	test	[edi+TWinTemplateDT.styleEx], WS_EX_CONTROLPARENT
	jnz	.parentok

	cmp	[edi+TWinTemplateDT.parent], 0
	je	.parentok

	mov	edi, [edi+TWinTemplateDT.parent]
	jmp	.parentloop

.parentok:
	mov	eax, [edi+TWinTemplateDT.hwnd]
	mov	[hwnd], eax
	invoke	SetCapture, [hwnd]

	lea	esi,[.rect]
	invoke	GetClientRect, [hwnd], esi
	invoke	ClientToScreen, [hwnd], esi
	add	esi,8
	invoke	ClientToScreen, [hwnd], esi
	sub	esi,8
	invoke	ClipCursor, esi

	invoke	GetCursorPos, esi
	invoke	ScreenToClient, [hwnd], esi

	mov	ebx, [esi+POINT.x]
	mov	ecx, [esi+POINT.y]

	cmp	[.tool], 0
	je	.snapok

	stdcall RoundToGrid, ebx, [xGrid]
	mov	ebx, eax
	stdcall RoundToGrid, ecx, [yGrid]
	mov	ecx, eax

.snapok:
	mov	[edi+TWinTemplateDT.DragRect.left],ebx
	mov	[edi+TWinTemplateDT.DragRect.top],ecx
	inc	ebx
	inc	ecx
	mov	[edi+TWinTemplateDT.DragRect.right],ebx
	mov	[edi+TWinTemplateDT.DragRect.bottom],ecx

	xor	eax, eax
	clc
	ret


;-------------------------------------------------------------------
onmessage WM_MOUSEMOVE

	invoke	GetCapture
	cmp	eax,[hwnd]
	jne	.endmove

; Draw select rect
	invoke	GetDCEx, [hwnd], NULL, DCX_PARENTCLIP
	mov	ebx, eax

	lea	esi, [edi+TWinTemplateDT.DragRect]
	stdcall DrawSortedFocusRect, ebx, esi

	stdcall GetCurrentTool

	movsx	ecx, word [lparam]
	movsx	edx, word [lparam+2]

	test	eax, eax
	jz	.movesnapok

	stdcall RoundToGrid, ecx, [xGrid]
	mov	ecx, eax
	stdcall RoundToGrid, edx, [yGrid]
	mov	edx, eax

.movesnapok:
	mov	[edi+TWinTemplateDT.DragRect.right], ecx
	mov	[edi+TWinTemplateDT.DragRect.bottom], edx
	stdcall DrawSortedFocusRect, ebx, esi

	invoke	ReleaseDC, [hwnd], ebx

.endmove:
	xor	eax, eax
	clc
	ret

;-------------------------------------------------------------------
onmessage WM_LBUTTONUP

	invoke	GetCapture
	cmp	eax,[hwnd]
	jne	.endbuttonup

	invoke	ReleaseCapture
	invoke	ClipCursor,NULL

; select rect or create rectangle.
	invoke	GetDCEx, [hwnd], NULL, DCX_PARENTCLIP
	push	eax
	lea	ebx, [edi+TWinTemplateDT.DragRect]
	stdcall DrawSortedFocusRect, eax, ebx				; remove the last select rect.
	invoke	ReleaseDC, [hwnd] ;, from the stack.

	stdcall GetCurrentTool
	test	eax, eax
	jz	.select

	mov	esi, eax

	invoke	SendMessage, edx, TB_CHECKBUTTON, 0, TRUE

	stdcall CreateControlFromTool, esi, edi, ebx	      ;CreateControlFromTool, Tool, Parent, ptrRect
	test	eax,eax
	jnz	.endbuttonup

.select:
	xor	ecx, ecx
	test	[wparam], MK_CONTROL
	jz	@f
	inc	ecx
@@:
	stdcall SelectInDragRect, edi, ecx

.endbuttonup:
	xor	eax,eax
	clc
	ret
endwp



;***************************************************
proc SelectInDragRect .ptrParent, .fDontClear
locals
.select RECT
.rect	RECT
.inter	RECT
.hSizer  dd ?
endl
	push	edi ebx esi

	mov	edi, [.ptrParent]
	test	edi, edi
	jz	.endchildren

	mov	eax, edi
	stdcall GetSizer
	mov	[.hSizer], eax

	lea	ecx, [edi+TWinTemplateDT.DragRect]
	lea	esi, [.select]
	invoke	CopyRect, esi, ecx
	stdcall SortRect

	mov	ebx, [edi+TWinTemplateDT.children.Count]
	mov	esi, [edi+TWinTemplateDT.children.ptrItems]

.searchchildren:
	dec	ebx
	js	.endchildren

	mov	edi, [esi+4*ebx]
	movsx	ecx, [edi+TWinTemplateDT.left]
	movsx	edx, [edi+TWinTemplateDT.top]
	mov	[.rect.left], ecx
	mov	[.rect.top], edx
	movsx	ecx, [edi+TWinTemplateDT.width]
	movsx	edx, [edi+TWinTemplateDT.height]
	add	ecx, [.rect.left]
	add	edx, [.rect.top]
	mov	[.rect.right], ecx
	mov	[.rect.bottom], edx

	lea	ecx, [.rect]
	lea	edx, [.inter]
	lea	eax, [.select]
	invoke	IntersectRect, edx, ecx, eax

	cmp	[fPartialSelect], FALSE
	jne	.partial

	lea	edx, [.inter]
	lea	ecx, [.rect]
	invoke	EqualRect, ecx, edx
	test	eax,eax
	jnz	.selectit
	jz	.searchchildren

.partial:
	lea	edx, [.inter]
	invoke	IsRectEmpty, edx
	test	eax,eax
	jnz	.searchchildren

.selectit:
	invoke	SendMessage, [.hSizer], SZM_SELECTCONTROL, edi, [.fDontClear]
	mov	[.fDontClear], 1

	jmp	.searchchildren

.endchildren:
	pop	esi ebx edi
	ret
endp


;***************************************************
; Draws focus rectangle on the given DC
; even if the rectangle is not sorted.
;***************************************************
proc DrawSortedFocusRect .hDC, .ptrRect

local .rect:RECT

	push	esi
	lea	esi, [.rect]
	invoke	CopyRect, esi, [.ptrRect]
	call	SortRect
	invoke	DrawFocusRect, [.hDC], esi
	pop	esi
	ret
endp


;***************************************************
; Creates new control depending of the current
; selected tool.
;***************************************************
proc CreateControlFromTool .Tool, .Parent, .ptrRect
	push	esi edi ebx

; Creates empty TWinTemplate and attaches it to the parents window tree.
	invoke	HeapAlloc, [hHeap], HEAP_ZERO_MEMORY, sizeof.TWinTemplateDT
	mov	edi, eax
	lea	eax, [edi+TWinTemplateDT.children]
	stdcall ListCreate, eax
	mov	eax, [.Parent]
	mov	[edi+TWinTemplateDT.parent], eax
	lea	eax, [eax+TWinTemplateDT.children]
	stdcall ListInsert, eax, -1
	mov	[eax], edi

	mov	ebx, [.Tool]
	mov	esi, [.ptrRect]
	call	SortRect

	mov	eax, [esi+RECT.right]
	mov	ecx, [esi+RECT.bottom]
	sub	eax, [esi+RECT.left]
	sub	ecx, [esi+RECT.top]

	cmp	eax, 8
	jge	@f
	mov	eax, [ebx+TDesignTimeInfo.DefaultWidth]
@@:
	cmp	ecx, 8
	jge	@f
	mov	ecx, [ebx+TDesignTimeInfo.DefaultHeight]
@@:
	mov	[edi+TWinTemplateDT.width], ax
	mov	[edi+TWinTemplateDT.height], cx

	mov	eax, [esi+RECT.left]
	mov	ecx, [esi+RECT.top]
	mov	[edi+TWinTemplateDT.left], ax
	mov	[edi+TWinTemplateDT.top], cx

	mov	eax, [ebx+TDesignTimeInfo.DefaultStyle]
	mov	ecx, [ebx+TDesignTimeInfo.DefaultStyleEx]
	or	eax, WS_VISIBLE
	mov	[edi+TWinTemplateDT.style], eax
	mov	[edi+TWinTemplateDT.styleEx], ecx

	stdcall StrDup, [ebx+TDesignTimeInfo.ClassName]
	mov	[edi+TWinTemplateDT.ptrClass], eax

	stdcall StrDup, [ebx+TDesignTimeInfo.DefaultText]
	mov	[edi+TWinTemplateDT.ptrText], eax

	stdcall StrDup, cFormNameNone
	mov	[edi+TWinTemplateDT.hName], eax

	stdcall StrNew
	mov	[edi+TWinTemplateDT.WinProc], eax

	stdcall CreateDesignWindow, edi

.qtrue:
	xor	eax,eax
	dec	eax
.finish:
	pop	ebx edi esi
	ret
endp


cDefaultFormStyleEx = 0
cDefaultFormStyle = WS_VISIBLE or WS_SYSMENU or WS_CLIPSIBLINGS or WS_CLIPCHILDREN
cDefaultX	  = 220
cDefaultY	  = 220
cDefaultWidth	  = 320
cDefaultHeight	  = 240
cDefaultFontSize  = 8
cDefaultFontWeight  = FW_NORMAL
cDefaultFontItalic  = FALSE
cFormDefaultFont db 'MS Sans Serif', 0



;---------------------------------------------------------------------
; Fully destroys control and frees all allocated
; memory.
; Arguments:
;   ptrWinTemplateDT - pointer to the TWinTemplateDT structure of the
; control.
;---------------------------------------------------------------------
proc DestroyDesignWindow .ptrWinTemplateDT, .detach
	push	esi edi ebx

	mov	esi, [.ptrWinTemplateDT]
	test	esi, esi
	jz	.finish

	mov	ebx, [esi+TWinTemplateDT.children.Count]
	mov	edi, [esi+TWinTemplateDT.children.ptrItems]

; Loop to destroy all children.
.delchildren:
	dec	ebx
	js	.endchildren

	stdcall DestroyDesignWindow, [edi+4*ebx], FALSE
	jmp	.delchildren

.endchildren:
	invoke	HeapFree, [hHeap], 0, edi

	cmp	[.detach], FALSE
	je	.parentok

; detach from parent window
	mov	edi, [esi+TWinTemplateDT.parent]
	test	edi, edi
	jz	.parentok

	lea	ebx, [edi+TWinTemplateDT.children]
	stdcall ListIndexOf, ebx, esi
	cmp	eax, -1
	je	.parentok

	stdcall ListDelete, ebx, eax

.parentok:
; Remove the control from property editor.
	invoke	SendDlgItemMessage, [hPropEditor], 101, PEM_GETCONTROL, 0, 0
	cmp	eax, esi
	jne	.propeditok
	invoke	SendDlgItemMessage, [hPropEditor], 101, PEM_SETCONTROL, [esi+TWinTemplateDT.parent], 0

.propeditok:
; Destroy strings used in design time.
	stdcall StrDel, [esi+TWinTemplateDT.hName]
	stdcall StrDel, [esi+TWinTemplateDT.ptrClass]
	stdcall StrDel, [esi+TWinTemplateDT.ptrText]
	stdcall StrDel, [esi+TWinTemplateDT.WinProc]

; Destroy windows instances.
	invoke	DestroyWindow, [esi+TWinTemplateDT.hSizer]
	invoke	DestroyWindow, [esi+TWinTemplateDT.hwnd]

; Destroy TWinTemplateDT structure.
	invoke	HeapFree, [hHeap], 0, esi

.finish:
	pop	ebx edi esi
	ret
endp


proc SortRect
	mov	eax, [esi+RECT.left]
	mov	ecx, [esi+RECT.right]
	cmp	ecx, eax
	jge	@f
	xchg	eax,ecx
@@:
	mov	[esi+RECT.left],eax
	mov	[esi+RECT.right], ecx

	mov	eax, [esi+RECT.top]
	mov	ecx, [esi+RECT.bottom]
	cmp	ecx, eax
	jge	@f
	xchg	eax,ecx
@@:
	mov	[esi+RECT.top],eax
	mov	[esi+RECT.bottom], ecx
	ret
endp



proc RoundToGrid .coordinate, .step
	push	ecx edx

	mov	eax, [.coordinate]

	cmp	[fSnapToGrid], FALSE
	je	.quit

	cdq
	mov	ecx, [.step]
	idiv	ecx

	sar	ecx,1
	cmp	edx, ecx
	jl	@f
	inc	eax
@@:
	imul	eax, [.step]

.quit:
	pop	edx ecx
	ret
endp

