; DialogBox example
format PE GUI 4.0
entry WINMAIN

include '%fasminc%\win32a.inc'

ID_CAPTION	   = 101
ID_MESSAGE	   = 102
ID_ICONERROR	   = 201
ID_ICONINFORMATION = 202
ID_ICONQUESTION    = 203
ID_ICONWARNING	   = 204
ID_TOPMOST	   = 301

section '.data' data readable writeable

  flags dd ?
  caption db $40 dup(?)
  message db $100 dup(?)

section '.code' code readable executable

proc WINMAIN  hinstance, hprevinstance, lpcmdline, ncmdshow
	invoke	GetModuleHandle, 0
	invoke	DialogBoxParam, eax, 37, HWND_DESKTOP, DialogProc, 0
	.if	eax, e, 0
		invoke	ExitProcess, 0
	.else
		invoke	MessageBox, HWND_DESKTOP, message, caption, [flags]
		invoke	ExitProcess, 0
	.endif
endp

proc DialogProc hwnddlg, msg, wparam, lparam
     .if     [msg], e, WM_INITDIALOG
	     invoke  CheckRadioButton, [hwnddlg], ID_ICONERROR, ID_ICONWARNING, ID_ICONINFORMATION
	     return  0

     .elseif [msg], e, WM_COMMAND
	     .if     [wparam], e, BN_CLICKED shl 16 + IDCANCEL
		     jmp     wmclose
	     .elseif [wparam], ne, BN_CLICKED shl 16 + IDOK
		     return  0
	     .endif

	     invoke  GetDlgItemText, [hwnddlg], ID_CAPTION, caption, $40
	     invoke  GetDlgItemText, [hwnddlg], ID_MESSAGE, message, $100
	     mov     [flags],MB_OK

	     invoke  IsDlgButtonChecked, [hwnddlg], ID_ICONERROR
	     .if     eax, e, BST_CHECKED
		     or      [flags], MB_ICONERROR
	     .endif
	     invoke  IsDlgButtonChecked, [hwnddlg], ID_ICONINFORMATION
	     .if     eax, e, BST_CHECKED
		     or      [flags], MB_ICONINFORMATION
	     .endif
	     invoke  IsDlgButtonChecked, [hwnddlg], ID_ICONQUESTION
	     .if     eax, e, BST_CHECKED
		     or      [flags], MB_ICONQUESTION
	     .endif
	     invoke  IsDlgButtonChecked, [hwnddlg], ID_ICONWARNING
	     .if     eax, e, BST_CHECKED
		     or      [flags], MB_ICONWARNING
	     .endif
	     invoke  IsDlgButtonChecked, [hwnddlg], ID_TOPMOST
	     .if     eax, e, BST_CHECKED
		     or      [flags],MB_TOPMOST
	     .endif

	     invoke  EndDialog,[hwnddlg],1
	     return  0

    .elseif [msg], e, WM_CLOSE
	wmclose:
	    invoke  EndDialog,[hwnddlg],0
	    return 0
    .endif

    return  0
endp

section '.idata' import data readable writeable

  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL'

  import kernel,\
	 GetModuleHandle,'GetModuleHandleA',\
	 ExitProcess,'ExitProcess'

  import user,\
	 DialogBoxParam,'DialogBoxParamA',\
	 CheckRadioButton,'CheckRadioButton',\
	 GetDlgItemText,'GetDlgItemTextA',\
	 IsDlgButtonChecked,'IsDlgButtonChecked',\
	 MessageBox,'MessageBoxA',\
	 EndDialog,'EndDialog'

section '.rsrc' resource data readable


  directory RT_DIALOG, dialogs, 24, manifest

  resource dialogs,\
	   37,LANG_ENGLISH+SUBLANG_DEFAULT,demonstration

  resource  manifest, 1, LANG_NEUTRAL, xpstyle

  dialog demonstration,'Create message box',70,70,190,175,WS_CAPTION+WS_POPUP+WS_SYSMENU+DS_MODALFRAME
    dialogitem 'STATIC','&Caption:',-1,10,10,70,8,WS_VISIBLE
    dialogitem 'EDIT','',ID_CAPTION,10,20,170,13,WS_VISIBLE+WS_BORDER+WS_TABSTOP
    dialogitem 'STATIC','&Message:',-1,10,40,70,8,WS_VISIBLE
    dialogitem 'EDIT','',ID_MESSAGE,10,50,170,13,WS_VISIBLE+WS_BORDER+WS_TABSTOP+ES_AUTOHSCROLL
    dialogitem 'BUTTON','&Icon',-1,10,70,80,70,WS_VISIBLE+BS_GROUPBOX
    dialogitem 'BUTTON','&Error',ID_ICONERROR,20,82,60,13,WS_VISIBLE+BS_AUTORADIOBUTTON+WS_TABSTOP+WS_GROUP
    dialogitem 'BUTTON','I&nformation',ID_ICONINFORMATION,20,95,60,13,WS_VISIBLE+BS_AUTORADIOBUTTON
    dialogitem 'BUTTON','&Question',ID_ICONQUESTION,20,108,60,13,WS_VISIBLE+BS_AUTORADIOBUTTON
    dialogitem 'BUTTON','&Warning',ID_ICONWARNING,20,121,60,13,WS_VISIBLE+BS_AUTORADIOBUTTON
    dialogitem 'BUTTON','&Style',-1,100,70,80,70,WS_VISIBLE+BS_GROUPBOX
    dialogitem 'BUTTON','&Top most',ID_TOPMOST,110,82,60,13,WS_VISIBLE+WS_TABSTOP+BS_AUTOCHECKBOX
    dialogitem 'BUTTON','OK',IDOK,85,150,45,15,WS_VISIBLE+WS_TABSTOP+BS_DEFPUSHBUTTON
    dialogitem 'BUTTON','C&ancel',IDCANCEL,135,150,45,15,WS_VISIBLE+WS_TABSTOP+BS_PUSHBUTTON
  enddialog

  resdata xpstyle
    file 'winxpstyle2.xml'
  endres
