;
;  LabelsExplorer.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

iglobal
  cExplorerRoot db 'Root', 0
endg

proc OnExplorer .wparam, .lparam
	cmp	[ptrLabels], 0
	je	.finish
	stdcall CreateForm, frmBrowser, [hApplication]
	invoke	ShowWindow, ebx, SW_SHOWNORMAL

;        stdcall ShowModal, ebx, MSF_CENTER
;        invoke  DestroyWindow, ebx
.finish:
	ret
endp


; Filter:
lblValueZero = 1
lblCanRedefine = 2
lblDataSizeZero = 4


proc AddLabelsToTree .tree, .parent, .ptrVarArray, .filterAnd, .filterCmp
local .tvi:TVINSERTSTRUCT
	push	esi ebx

	mov	eax, [.ptrVarArray]
	mov	esi, [eax]		; pointer to TArray
	test	esi, esi
	jz	.finish

	mov	ebx, [esi+TArray.Count]
	lea	esi, [esi+TArray.Items]

.iteratelist:
	cmp	[.filterCmp], -1
	je	.addit

	movzx	eax, [esi+TLabel.flags]
	test	eax, lfDefined
	jz	.next

	test	eax, lfUsed
	jz	.next

	and	eax, lfCanRedefine

	mov	ecx, [esi+TLabel.ValueLo]
	test	ecx, ecx
	setz	cl
	and	ecx, 1
	or	eax, ecx

	movzx	ecx, [esi+TLabel.DataSize]
	test	ecx, ecx
	setz	cl
	and	ecx, 1
	shl	ecx, 2
	or	eax, ecx

	and	eax, [.filterAnd]
	cmp	eax, [.filterCmp]
	jne	.next
.addit:
	mov	eax, [.parent]
	mov	[.tvi.hParent], eax
	mov	ecx, TVI_LAST
	cmp	eax, TVI_ROOT
	jne	@f
	mov	ecx, TVI_SORT
@@:
	mov	[.tvi.hInsertAfter], ecx
	mov	[.tvi.item.mask], TVIF_TEXT or TVIF_PARAM

	mov	eax, [esi+TLabel.iName]
	add	eax, [ptrNames]
	mov	[.tvi.item.pszText], eax
	mov	[.tvi.item.lParam], esi

	lea	eax, [.tvi]
	invoke	SendMessage, [.tree], TVM_INSERTITEM, 0, eax

	cmp	dword [esi], 0
	je	.next
	stdcall AddLabelsToTree, [.tree], eax, esi, 0, -1  ; for .Children field of the TLabel
.next:
	add	esi, sizeof.TLabel
	dec	ebx
	jnz	.iteratelist

.finish:
	pop	ebx esi
	ret
endp





;**************************************************************************
; frmBrowser message handling procedure.
;
;   hwnd - handle of the form window
;   wmsg     - message code
;   wparam, lparam - parameters of the message
;**************************************************************************
proc frmBrowserWinProc .hwnd, .wmsg, .wparam, .lparam
	mov	ebx, [.wmsg]
	call	JumpTo
	MessageList						\
	FM_AFTERCREATE, .fmaftercreate, 			\
	WM_NOTIFY,	.wmnotify,				\
	WM_CLOSE,	.wmclose

.default:
	stc
	ret

.wmclose:
	invoke	DestroyWindow, [.hwnd]
	clc
	ret

.fmaftercreate:
	invoke	GetDlgItem, [.hwnd], 1	 ; static panel
	invoke	GetDlgItem, eax, 3	; group box
	mov	ebx, eax
	invoke	SendDlgItemMessage, ebx, 100, BM_SETCHECK, 1, 0
	invoke	SendMessage, ebx, WM_COMMAND, 100, 0

	clc
	ret

.wmnotify:
	mov	esi, [.lparam]
	cmp	[esi+NMHDR.code], TVN_SELCHANGED
	je	.selchanged

	jmp	.default

; selection of the treeview changed.
.selchanged:
; Pointer to TLabel structure of given label.
	invoke	GetDlgItem, [.hwnd], 1
	mov	ebx, eax

	mov	edi, [esi+NMTREEVIEW.itemNew.lParam]
	test	edi, edi
	jz	.finish


	stdcall NumToStr, [edi+TLabel.ValueLo], 0, 0, ntsUnsigned or ntsHex or ntsZeroTerminated
	push	eax
	push	eax

	stdcall NumToStr, [edi+TLabel.ValueHi], 0, 0, ntsUnsigned or ntsHex or ntsZeroTerminated
	stdcall StrInsertChar, eax, '$', 0
	stdcall StrCharCat, eax, ':'

	stdcall StrCat, eax	; second from the stack
	stdcall StrDel
	push	eax

	stdcall StrPtr, eax

	invoke	SendDlgItemMessage, ebx, 10, WM_SETTEXT, 0, eax
	stdcall StrDel

	movzx	eax, [edi+TLabel.DataSize]

	mov	ecx, cSizeConst
	cmp	eax, 0
	je	.setsizeinfo

	mov	ecx, cSizeByte
	cmp	eax, 1
	je	.setsizeinfo

	mov	ecx, cSizeWord
	cmp	eax, 2
	je	.setsizeinfo

	mov	ecx, cSizeDword
	cmp	eax, 4
	je	.setsizeinfo

	mov	ecx, cSizeQword
	cmp	eax, 8
	je	.setsizeinfo

	invoke	SetDlgItemInt, ebx, 11, eax, FALSE
.finish:
	clc
	ret

iglobal
  cSizeConst db 'const',0
  cSizeByte db 'byte', 0
  cSizeWord db 'word', 0
  cSizeDword db 'dword', 0
  cSizeQword db 'qword', 0
endg

.setsizeinfo:
	invoke	SetDlgItemText, ebx, 11, ecx
	clc
	ret
endp




proc GroupboxProc .hwnd, .wmsg, .wparam, .lparam
	cmp	[.wmsg], WM_COMMAND
	je	.wmcommand
.default:
	stc
	ret

.wmcommand:
	movzx	eax, word [.wparam]
	cmp	eax, 100
	jl	.default
	cmp	eax, 103
	jg	.default

.update:
; Update tree-view control
	invoke	GetParent, [.hwnd]
	invoke	GetParent, eax
	invoke	GetDlgItem, eax, 2
	mov	edi, eax
	invoke	LockWindowUpdate, edi
	invoke	SendMessage, edi, TVM_DELETEITEM, 0, TVI_ROOT

	movzx	eax, word [.wparam]
	mov	ecx, lblDataSizeZero	; Label type symbol
	mov	edx, lblDataSizeZero or lblCanRedefine
	cmp	eax, 100
	je	.filterok

	mov	ecx, lblDataSizeZero or lblValueZero	; struct type symbol
	mov	edx, lblDataSizeZero or lblValueZero or lblCanRedefine
	cmp	eax, 101
	je	.filterok

	mov	ecx, 0		; Data
	mov	edx, lblDataSizeZero or lblCanRedefine
	cmp	eax, 102
	je	.filterok

				; Const
	mov	ecx, lblCanRedefine or lblDataSizeZero
	mov	edx, lblCanRedefine or lblDataSizeZero

.filterok:
	stdcall AddLabelsToTree, edi, TVI_ROOT, ptrLabels, edx, ecx
	invoke	LockWindowUpdate, NULL
	clc
	ret
endp




iglobal
  Window  frmBrowser, wtParent or wtEnd, waNone, 'TForm', 'Labels explorer', ComDlgStyle or WS_SIZEBOX, 0, NULL, 0, 0, 480, 290, frmBrowserWinProc
  Window  NONE, wtChild or wtParent , waRight, 'TForm', '', WS_VISIBLE or WS_CHILD, WS_EX_CLIENTEDGE, 1, 192, 0, 200, 215, NULL
  Window  NONE, wtChild or wtParent, waNone, 'Button', 'Symbol kind', WS_VISIBLE or WS_CHILD or BS_GROUPBOX, 0, 3, 8, 96, 180, 90, GroupboxProc
  Window  NONE, wtChild, waNone, 'Button', 'Labels', WS_VISIBLE or WS_CHILD or BS_AUTORADIOBUTTON, 0, 100,	   8, 16, 100, 17, NULL
  Window  NONE, wtChild, waNone, 'Button', 'Structures', WS_VISIBLE or WS_CHILD or BS_AUTORADIOBUTTON, 0, 101,	      8, 33, 100, 17, NULL
  Window  NONE, wtChild, waNone, 'Button', 'Data', WS_VISIBLE or WS_CHILD or BS_AUTORADIOBUTTON, 0, 102,	  8, 50, 100, 17, NULL
  Window  NONE, wtChild or wtEnd, waNone, 'Button', 'Constants', WS_VISIBLE or WS_CHILD or BS_AUTORADIOBUTTON, 0, 103,8, 67,  100, 17, NULL
  Window  NONE, wtChild, waNone, 'Static', 'Value:', WS_VISIBLE or WS_CHILD or SS_SIMPLE, 0, 0, 8, 8, 64, 19, NULL
  Window  NONE, wtChild, waNone, 'Edit', '', WS_VISIBLE or WS_CHILD or WS_BORDER or ES_READONLY, 0, 10, 8, 28, 180, 17, NULL
  Window  NONE, wtChild, waNone, 'Static', 'Data type:',  WS_VISIBLE or WS_CHILD or SS_SIMPLE, 0, 0, 8, 50, 64, 19, NULL
  Window  NONE, wtChild or wtEnd, waNone, 'Edit', '', WS_VISIBLE or WS_CHILD or WS_BORDER or ES_READONLY, 0, 11, 8, 70, 180, 17, NULL
  Window  NONE, wtChild or wtEnd, waClient, TREEVIEW_CLASS, '', WS_VISIBLE or WS_CHILD or TVS_HASBUTTONS or TVS_HASLINES or TVS_LINESATROOT or TVS_DISABLEDRAGDROP or TVS_SHOWSELALWAYS, $200, 2, 0, 0, 192, 215, NULL
endg
