;
;  SilentCompilation.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;
;  This file contains routine responsible for generating
;  symbol list when Fresh starts. It simply compiles
;  predefined file that contains only equates and constants.
;


uglobal
  fSilentMode dd ?     ; if 1 then right now compiler is working in silent mode.
endg


align 16
proc flat_assembler_silent, dummy
        mov     [save_stack_pointer],esp
        pushad
        call    preprocessor
        call    parser
        call    assembler
        stdcall CaptureSymbols, [labels_list],[memory_end]
    .finish:
        stdcall CleanupAfterCompilation
        mov     [fSilentMode],0
        invoke  SendMessage, [hStatus],SB_SETTEXT,5,0
        invoke  SetCurrentDirectory,szSaveDirectory
        popad
        mov     esp,[save_stack_pointer]
        mov     eax, [exit_code]
        invoke  ExitThread, 0
        ret
endp

uglobal
   szSaveDirectory rb MAX_PATH
iglobal
   cSilentCompiling db 'Generating symbol list in progress...', 0
endg



proc SilentCompilation, hFileName
        ; go to silent mode
        mov     [fSilentMode],1
        invoke  GetCurrentDirectory,MAX_PATH,szSaveDirectory
        stdcall PrepareForCompilation, [hFileName]
        test    eax, eax
        jz      .outofmemory
        invoke  SendMessage, [hStatus],SB_SETTEXT,5,cSilentCompiling
        invoke  CreateThread, NULL, $4000, flat_assembler_silent, NULL, NULL, comp_handle
        mov     [comp_handle], eax
        ret
  .outofmemory:
        invoke  MessageBox, [hApplication], cOutOfMemory, NULL, MB_ICONERROR or MB_OK
        ret
endp