;
;  FormUtils.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

proc PseudoAlign .hwnd, .ptrRect, .winalign
local .bounds:TBounds
        lea     eax, [.bounds]
        stdcall AlignWindow, [.hwnd], [.ptrRect], eax, [.winalign]
        test    eax, eax
        jz      .finish
        invoke  SetWindowPos, [.hwnd], NULL,                                                     \
                              [.bounds.x], [.bounds.y], [.bounds.width], [.bounds.height],      \
                              SWP_NOZORDER or SWP_NOCOPYBITS
.finish:
        ret
endp

; places Fresh child windows in given rectangle
proc RealignWindows uses ebx ecx edx esi, pRect
local .rect1   :RECT
local .rect2   :RECT
        mov     ebx,[pRect]
        invoke  IsWindowVisible, [hProjManager]
        mov     esi, eax
        invoke  IsWindowVisible, [hPropEditor]
        test    esi, eax
        jnz     .both
        mov     ecx, [hProjManager]
        test    esi, esi
        jnz     .leftpane
        mov     ecx, [hPropEditor]
        test    eax, eax
        jz      .client
   .leftpane:
        stdcall PseudoAlign, ecx, ebx, waLeft
        jmp     .client
   .both:
        stdcall PseudoAlign, [hPropEditor], ebx, waLeft
        lea     eax, [.rect1]
        invoke  GetWindowRect, [hPropEditor], eax
        mov     eax, [.rect1.left]
        mov     ecx, [.rect1.right]
        sub     ecx, eax
        mov     [.rect2.left], eax
        mov     [.rect2.right], ecx
        mov     [.rect1.right], ecx
        mov     eax, [.rect1.top]
        mov     ecx, [.rect1.bottom]
        sub     ecx, eax
        sar     ecx, 1
        add     eax, ecx
        mov     [.rect2.top], eax
        mov     [.rect2.bottom], ecx
        mov     [.rect1.bottom], ecx
        invoke  SetWindowPos, [hPropEditor], NULL, [.rect1.left], [.rect1.top], [.rect1.right], [.rect1.bottom], SWP_NOZORDER or SWP_NOACTIVATE
        invoke  SetWindowPos, [hProjManager], NULL, [.rect2.left], [.rect2.top], [.rect2.right], [.rect2.bottom], SWP_NOZORDER or SWP_NOACTIVATE
   .client:
        stdcall PseudoAlign, [hEditorsHost], ebx, waClient
        ret
endp


proc RearrangeWindows
local .workrect:RECT
local .rect1   :RECT
local .rect2   :RECT
        push    ebx

        stdcall GetPref, prefFloatingWindows,0
        test    eax,eax
        jnz     @f
        invoke  SendMessage, [hMainWindow],WM_SIZE,0,0
        pop     ebx
        ret
     @@:

        lea     ebx, [.workrect]
        invoke  GetClientRect, [hMainWindow], ebx
        mov     [.workrect.bottom], 80
        stdcall GetPref, prefViewPalette,0
        test    eax,eax
        jnz     @f
        mov     [.workrect.bottom], 27
    @@:
        invoke  AdjustWindowRectEx, ebx, [MainForm+TWinTemplate.style], TRUE, [MainForm+TWinTemplate.styleEx]
        mov     eax, [.workrect.bottom]
        mov     ecx, [.workrect.right]
        sub     eax, [.workrect.top]
        sub     ecx, [.workrect.left]
        invoke  SetWindowPos, [hMainWindow], 0, 0, 0, ecx, eax, SWP_NOMOVE or SWP_NOZORDER
        lea     ebx, [.workrect]
        invoke  SystemParametersInfo, SPI_GETWORKAREA,0,ebx,0
        stdcall PseudoAlign, [hMainWindow], ebx, waTop
     .main_window_placed:
        stdcall RealignWindows, ebx
        invoke  SetFocus, [hEditorsHost]
        pop     ebx
        ret
endp


winproc DockFormProc
local ps:PAINTSTRUCT, hdc:DWORD, hFont:DWORD, hBrush:DWORD
local ncm:NONCLIENTMETRICS
local rect:RECT
local buf[128]:BYTE

ondefault
        stc
        ret

onmessage WM_NCCALCSIZE
        stdcall GetPref, prefFloatingWindows,0
        test    eax,eax
        jnz     .ondefault
        mov     ebx,[lparam]
        lea     eax,[ncm]
        mov     [ncm.cbSize],sizeof.NONCLIENTMETRICS
        invoke  SystemParametersInfo, SPI_GETNONCLIENTMETRICS,sizeof.NONCLIENTMETRICS,eax,0
        mov     eax,[ncm.iSmCaptionHeight]
        add     [ebx+NCCALCSIZE_PARAMS.rgrc1.top],eax
        mov     eax,TRUE
        clc
        ret

onmessage WM_NCPAINT
        stdcall GetPref, prefFloatingWindows,0
        test    eax,eax
        jnz     .ondefault
        invoke  GetWindowDC, [hwnd]
        mov     [hdc],eax
        lea     eax,[ncm]
        mov     [ncm.cbSize],sizeof.NONCLIENTMETRICS
        invoke  SystemParametersInfo, SPI_GETNONCLIENTMETRICS,sizeof.NONCLIENTMETRICS,eax,0
        lea     eax,[rect]
        invoke  GetWindowRect, [hwnd],eax
        mov     eax,[rect.left]
        mov     [rect.left],0
        sub     [rect.right],eax
        mov     eax,[rect.top]
        mov     [rect.top],0
        sub     [rect.bottom],eax
        mov     eax,[ncm.iSmCaptionHeight]
        mov     [rect.bottom],eax
        lea     eax,[rect]
        invoke  FillRect, [hdc],eax,COLOR_HOTLIGHT
        invoke  SetBkMode, [hdc],TRANSPARENT
        lea     eax,[ncm.lfSmCaptionFont]
        invoke  CreateFontIndirect, eax
        mov     [hFont],eax
        invoke  SelectObject, [hdc],[hFont]
        lea     eax,[buf]
        invoke  SendMessage, [hwnd],WM_GETTEXT,128,eax
        lea     ebx,[buf]
        invoke  lstrlen,ebx
        lea     edx,[rect]
        invoke  DrawText, [hdc],ebx,eax,edx,DT_CENTER+DT_VCENTER+DT_SINGLELINE
        invoke  DeleteObject, [hFont]
        invoke  ReleaseDC, [hwnd],[hdc]
  .qfalse:
        xor     eax,eax
        clc
        ret
endwp