;
;  PropEditor.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

uglobal
  hPropEditor     dd 0    ; handle of property editor
endg

iglobal
  cPropWindowTitle db 'Properties',0
endg


;----------------------------------------
; Creates property editor.
; Call this only once.
;----------------------------------------

proc InitPropEditor .owner

        mov     ebx,12CC0000h
        stdcall GetPref, prefFloatingWindows,0
        test    eax,eax
        jnz     @f
        mov     ebx,WS_CHILD+WS_VISIBLE
    @@:
        invoke  CreateWindowEx, 10080h,cFormClassName,cPropWindowTitle,\
                                ebx,0,0,180,170,[.owner],0,\
                                [hInstance],0
        mov     [hPropEditor], eax
        stdcall SubclassWindow, eax,PropEditorProc
        stdcall GetPref, prefPropWndVisible,0
        test    eax,eax
        jnz     .finish
        invoke  ShowWindow, [hPropEditor],SW_HIDE
    .finish:
        ret
endp


proc PropEditorProc .hwnd, .wmsg, .wparam, .lparam

local .buff[256]:BYTE
        call    JumpTo
        MessageList                     \
          WM_COMMAND,     .command,     \
          PRM_UPDATEPROP, .updateprop,  \
          WM_CLOSE,       .close,       \
          WM_ERASEBKGND,  .erasebkgnd,  \
          WM_SETFOCUS,    .wmsetfocus,  \
          WM_NEXTDLGCTL,  .wmnext,      \
          AM_INITWINDOW,  .init

.default:
        stdcall DockFormProc, [.hwnd],[.wmsg],[.wparam],[.lparam]
        stc
        ret

.init:
        invoke  CreateWindowEx, 10200h,ccPropGridClassName,NULL,\
                                56200000h,0,0,100,100,\
                                [.hwnd],101,[hInstance],0
        stdcall SetAlign,eax,waClient
        jmp     .qfalse

.qtrue:
        stc
        jmp     .finish

.wmnext:
        invoke  SendDlgItemMessage, [.hwnd], 101, [.wmsg], [.wparam], [.lparam]
        clc
        ret

;-------- WM_SETFOCUS ---------------------------------------
.wmsetfocus:

        invoke  GetDlgItem, [.hwnd], 101
        mov     ebx, eax

        invoke  SendMessage, ebx, PEM_GETCONTROL, 0, 0
        test    eax, eax
        jz      .setfocus

        invoke  SetWindowPos, [eax+TWinTemplateDT.hwnd], HWND_TOP, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE or SWP_SHOWWINDOW

.setfocus:
        invoke  SetFocus, ebx
        jmp     .qfalse

;-------- WM_ERASEBKGND -------------------------------------
.erasebkgnd:
        invoke  GetDlgItem, [.hwnd], 101
        invoke  IsWindowVisible, eax
        test    eax, eax
        jz      .qtrue

        xor     eax, eax
        inc     eax
        clc
        ret

;-------- WM_CLOSE ------------------------------------------
.close:
        stdcall OnViewPropEditor, actViewPropEditor, 0
        jmp     .qfalse

;-------- PRM_UPDATEPROP ------------------------------------
.updateprop:
        invoke  GetDlgItem, [.hwnd], 101
        mov     ebx, eax
        invoke  InvalidateRect, ebx, NULL, FALSE
        jmp     .qfalse

;---------WM_COMMAND-----------------------------
.command:
        cmp     word [.wparam], MR_OK   ; enter pressed.
        jne     .tomain

        invoke  SendDlgItemMessage, [.hwnd], 101, PEM_UPDATECONTROL, 0, 0
        jmp     .qfalse


.tomain:
        invoke  SendMessage, [hMainWindow], [.wmsg], [.wparam], [.lparam]
        jmp     .qtrue

.qfalse:
        xor     eax,eax
        clc
.finish:
        ret
endp


