;
;  TProject.asm
;  Fresh IDE
;  Copyright (c) 2003-2006, Fresh Developement Team
;

; moves category up (direction=TRUE) or down (direction=FALSE)
proc MoveCategory uses ebx ecx edx esi edi, hProject, hCategory, direction
        cmp     [hProject],0
        jz      .qfalse
        cmp     [hCategory],0
        je      .qfalse
        stdcall GetCategoryParent,[hProject],[hCategory]
        test    eax,eax
        jz      .finish
        mov     ebx,eax
        mov     eax,[hCategory]
        mov     esi,[eax+TProjectCategory.pPrev]  ; now: esi - prev, eax - current, edi - next
        mov     edi,[eax+TProjectCategory.pNext]  ;
        cmp     [direction],FALSE
        je      .down
.up:    or      esi,esi
        jz      .qfalse   ; can't move category up when it is first
        test    edi,edi
        jz      .no_next_category
        mov     [edi+TProjectCategory.pPrev],esi
  .no_next_category:
        mov     edx,[esi+TProjectCategory.pPrev]
        mov     [eax+TProjectCategory.pPrev],edx
        mov     [eax+TProjectCategory.pNext],esi
        mov     [esi+TProjectCategory.pNext],edi
        mov     [esi+TProjectCategory.pPrev],eax
        or      edx,edx
        jz      .first_category
        mov     [edx+TProjectCategory.pNext],eax
        jmp     .finish
  .first_category:
        mov     [ebx+TProjectCategory.pSubCategory],eax
        jmp     .finish
.down:  or      edi,edi   ; can't move last category down
        jz      .qfalse
        cmp     [ebx+TProjectCategory.pSubCategory],eax
        jne     .not_first_category
        mov     edx,[eax+TProjectCategory.pNext]
        mov     [ebx+TProjectCategory.pSubCategory],edx
  .not_first_category:
        or      esi,esi
        jz      .no_prev_category
        mov     [esi+TProjectCategory.pNext],edi
  .no_prev_category:
        mov     edx,[edi+TProjectCategory.pNext]
        or      edx,edx
        jz      .last_category
        mov     [edx+TProjectCategory.pPrev],eax
   .last_category:
        mov     [edi+TProjectCategory.pPrev],esi
        mov     [edi+TProjectCategory.pNext],eax
        mov     [eax+TProjectCategory.pPrev],edi
        mov     [eax+TProjectCategory.pNext],edx
.finish:
        ret
.qfalse:
        xor     eax,eax
        ret
endp

proc RemoveFileFromProject uses ecx edx, hProject,pFile
        mov     eax,[hProject]
        or      eax,eax
        jz      .finish
        mov     eax,[pFile]
        or      eax,eax
        jz      .finish
        stdcall GetFileParent, [hProject],eax
        or      eax,eax
        jz      .finish
        mov     edx,[pFile]
        cmp     edx,[eax+TProjectCategory.pFileList]
        jne     .parent_ok
        push    [edx+TOpenFile.pNext]
        pop     [eax+TProjectCategory.pFileList]
        mov     [edx+TOpenFile.pNext],0
        jmp     .finish
.parent_ok:
        ; now scan file list
        mov     edx,[eax+TProjectCategory.pFileList]
        mov     eax,[pFile]
    .find_file:
        or      edx,edx
        jz      .finish
        cmp     [edx+TOpenFile.pNext],eax
        je      .got_it
        mov     edx,[edx+TOpenFile.pNext]
        jmp     .find_file
    .got_it:
        mov     ecx,[eax+TOpenFile.pNext]
        mov     [edx+TOpenFile.pNext],ecx

.finish:
        ret
endp


proc RemoveCategoryFromProject uses ecx edx, hProject,hCategory
        mov     eax,[hProject]
        or      eax,eax
        jz      .finish
        mov     eax,[hCategory]
        or      eax,eax
        jz      .finish
        stdcall GetCategoryParent, [hProject],eax
        or      eax,eax
        jz      .finish
        mov     edx,[hCategory]
        cmp     edx,[eax+TProjectCategory.pSubCategory]
        jne     .parent_ok
        push    [edx+TProjectCategory.pNext]
        pop     [eax+TProjectCategory.pSubCategory]
.parent_ok:
        mov     eax,[edx+TProjectCategory.pPrev]
        mov     ecx,[edx+TProjectCategory.pNext]
        or      eax,eax
        jz      @f
        mov     [eax+TProjectCategory.pNext],ecx
    @@: or      ecx,ecx
        jz      @f
        mov     [ecx+TProjectCategory.pPrev],eax
    @@: mov     [edx+TProjectCategory.pNext],0
        mov     [edx+TProjectCategory.pPrev],0
.finish:
        ret
endp

; returns parent of given file or NULL
; (when category isn't in project).
proc GetFileParent hProject, pFile
local param:DWORD
        mov     eax,[pFile]
        mov     [param],eax
        lea     eax,[param]
        stdcall EnumProjectFiles, [hProject],FALSE,cbCheckProjectItem,eax,0,0
        mov     eax,[pFile]
        cmp     eax,[param]
        je      .not_found
        mov     eax,[param]
        ret
.not_found:
        xor     eax,eax
        ret
endp

; returns parent of given category or NULL
; (when category isn't in project).
proc GetCategoryParent hProject, hCategory
local param:DWORD
        mov     eax,[hCategory]
        mov     [param],eax
        lea     eax,[param]
        stdcall EnumProjectFiles, [hProject],FALSE,0,0,cbCheckProjectItem,eax
        mov     eax,[hCategory]
        cmp     eax,[param]
        je      .not_found
        mov     eax,[param]
        ret
.not_found:
        xor     eax,eax
        ret
endp

proc cbCheckProjectItem uses edx, hProject, pItem, pParentCategory, lParam
        mov     edx,[pItem]
        mov     eax,[lParam]
        cmp     [eax],edx
        je      .found
        ret
  .found:
        mov     edx,[pParentCategory]
        mov     [eax],edx
        ret
endp

; adds specified file to given project category (files are added in alphabetical order)
proc AddFileToCategory uses ebx edx, hFile,hCategory
        mov     eax,[hFile]
        test    eax,eax
        jz      .finish
        mov     edx,eax
        mov     eax,[hCategory]
        test    eax,eax
        jz      .finish
        mov     ebx,eax
        cmp     [ebx+TProjectCategory.pFileList],0
        je      .first_file

        mov     eax,[ebx+TProjectCategory.pFileList]
        stdcall StrCompNoCase, [eax+TOpenFile.hFileName],[edx+TOpenFile.hFileName]
        test    eax,eax
        js      .place_file
  .first_file:
        ; file is first
        push    [ebx+TProjectCategory.pFileList]
        pop     [edx+TOpenFile.pNext]
        mov     [ebx+TProjectCategory.pFileList],edx
        jmp     .finish
.place_file:
        mov     ebx,[ebx+TProjectCategory.pFileList]
        mov     ecx,[ebx+TOpenFile.pNext]
.find_file:
        test    ecx,ecx
        jz      .found_last_file
        stdcall StrCompNoCase, [edx+TOpenFile.hFileName],[ecx+TOpenFile.hFileName]
        test    eax,eax
        js      .insert_file
        mov     ebx,ecx
        mov     ecx,[ebx+TOpenFile.pNext]
        jmp     .find_file
.insert_file:
        mov     [edx+TOpenFile.pNext],ecx
.found_last_file:
        mov     [ebx+TOpenFile.pNext],edx
.finish:
        ret
endp

; Creates new project and its main category.
; returns project handle on success, NULL on fail.
proc CreateProject uses ebx ecx edx esi
        invoke  GetProcessHeap
        mov     ebx,eax
        invoke  HeapAlloc, eax,HEAP_ZERO_MEMORY,sizeof.TProject
        or      eax,eax
        jz      .finish
        mov     esi,eax
        invoke  HeapAlloc, ebx,HEAP_ZERO_MEMORY,sizeof.TProjectCategory
        or      eax,eax
        jz      .finish
        mov     [esi+TProject.pMainCategory],eax
        mov     eax,esi
.finish:
        ret
endp

; creates new category
proc CreateProjectCategory uses ebx ecx edx, hName, iIcon
        invoke  GetProcessHeap
        invoke  HeapAlloc, eax,HEAP_ZERO_MEMORY,sizeof.TProjectCategory
        mov     ebx,eax
        stdcall StrDup, [hName]
        mov     [ebx+TProjectCategory.hName],eax
        mov     eax,[iIcon]
        mov     [ebx+TProjectCategory.iIcon],eax
        mov     eax,ebx
        ret
endp

; adds category to a project
proc InsertProjectCategory uses ecx edx, hProject, hParentCategory, pCategory
        cmp     [pCategory],0
        je      .finish
        mov     eax,[pCategory]
        mov     edx,[hParentCategory]
        or      edx,edx
        jnz     .parent_ok
        mov     edx,[hProject]
        mov     edx,[edx+TProject.pMainCategory]
.parent_ok:
        mov     ecx,[edx+TProjectCategory.pSubCategory]
        or      ecx,ecx
        jz      .no_next_category
        mov     [ecx+TProjectCategory.pPrev],eax
.no_next_category:
        mov     [edx+TProjectCategory.pSubCategory],eax
        mov     [eax+TProjectCategory.pNext],ecx
.finish:
        ret
endp


; frees data occupied by project
proc DestroyProject uses ecx edx, hProject
        stdcall EnumProjectFiles, [hProject],TRUE,dp_FreeFileData,0,dp_FreeCategoryData,0
        invoke  GetProcessHeap
        stdcall FreeFStruct, [hProject]
        ret
endp

proc DestroyProjectCategory, hProject,hCategory
        stdcall epf_EnumCategory,[hProject],TRUE,[hCategory],0,dp_FreeFileData,0,dp_FreeCategoryData,0
        ret
endp

proc dp_FreeCategoryData uses ecx edx, hProject,pCategory,pParentCategory,lParam
        mov     eax,[pCategory]
        cmp     [eax+TProjectCategory.hName],0
        je      .finish
        stdcall StrDel, [eax+TProjectCategory.hName]
        push    eax
        invoke  GetProcessHeap
        invoke  HeapFree, eax, 0   ; last arg from stack
.finish:
        ret
endp

proc dp_FreeFileData hProject,pFile,pParentCategory,lParam
        mov     eax,[pFile]
        cmp     [eax+TProjectCategory.hName],0
        je      .finish
        stdcall FreeFStruct, eax
.finish:
        ret
endp


; Calls pfnEnumFile for each file in a project, and pfnEnumCategory
; for each category.
; if fReverse is set then procedure enums project items in reversed order
proc EnumProjectFiles hProject, fReverse, pfnEnumFile, lParam1, pfnEnumCategory, lParam2
        mov     eax,[hProject]
        or      eax,eax
        jz      .finish
        stdcall epf_EnumCategory, [hProject],[fReverse],\
                                  [eax+TProject.pMainCategory],0,\
                                  [pfnEnumFile],[lParam1],[pfnEnumCategory],[lParam2]
.finish:
        ret
endp

proc epf_EnumCategory uses ebx, hProject,fReverse,pCategory,pParentCategory,pfnEnumFile,lParam1,pfnEnumCategory,lParam2
        mov     ebx,[pCategory]
        cmp     [pfnEnumCategory],0
        jz      @f
        cmp     [fReverse],0
        jne     @f
        stdcall [pfnEnumCategory],[hProject],ebx,[pParentCategory],[lParam2]
   @@:  mov     eax,[ebx+TProjectCategory.pSubCategory]
        or      eax,eax
        jz      .no_subcategory
        stdcall epf_EnumCategory, [hProject],[fReverse],eax,ebx,[pfnEnumFile],[lParam1],[pfnEnumCategory],[lParam2]
.no_subcategory:
        mov     eax,[ebx+TProjectCategory.pNext]
        or      eax,eax
        jz      .no_next_category
        stdcall epf_EnumCategory, [hProject],[fReverse],eax,[pParentCategory],[pfnEnumFile],[lParam1],[pfnEnumCategory],[lParam2]
.no_next_category:
        mov     eax,[ebx+TProjectCategory.pFileList]
        or      eax,eax
        jz      .no_files
        stdcall epf_EnumFile, [hProject],[fReverse],eax,ebx,[pfnEnumFile],[lParam1]
.no_files:
        cmp     [fReverse],0
        je      .finish
        stdcall [pfnEnumCategory],[hProject],ebx,[pParentCategory],[lParam2]
.finish:
        ret
endp


proc epf_EnumFile uses ebx, hProject,fReverse, pFile,pParentCategory,pfnEnumFile,lParam
        mov     ebx,[pFile]
        cmp     [pfnEnumFile],0     ; no need to enum files if pfnEnumFile is NULL
        jz      .finish

        cmp     [fReverse],0
        jne     .reversed_order
        stdcall [pfnEnumFile], [hProject],ebx,[pParentCategory],[lParam]
    .reversed_order:
        mov     eax,[ebx+TOpenFile.pNext]
        or      eax,eax
        jz      .no_next_file
        stdcall epf_EnumFile, [hProject],[fReverse],eax,[pParentCategory],[pfnEnumFile],[lParam]
    .no_next_file:
        cmp     [fReverse],0
        je      .finish
        stdcall [pfnEnumFile], [hProject],ebx,[pParentCategory],[lParam]
.finish:
        ret
endp

; load project into TreeView conrol
proc ProjectToTreeView uses esi ebx ecx edx, hProject,hTreeView
local tvis:TVINSERTSTRUCT
        cmp     [hTreeView],0
        je      .finish
        invoke  SendMessage, [hTreeView],TVM_DELETEITEM,0,TVI_ROOT   ; clear TreeView control
        mov     esi,[hProject]
        or      esi,esi
        jz      .finish
        mov     [tvis.hParent],0
        mov     [tvis.hInsertAfter],TVI_LAST
        mov     [tvis.item.mask],TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE+TVIF_STATE
        mov     [tvis.item.iImage],3
        mov     [tvis.item.iSelectedImage],3
        stdcall ExtractFileName, [esi+TProject.hFileName]
        mov     [tvis.item.pszText],eax
        mov     [tvis.item.state],TVIS_EXPANDED
        mov     [tvis.item.stateMask],TVIS_EXPANDED
        lea     eax,[tvis]
        invoke  SendMessage, [hTreeView],TVM_INSERTITEM,0,eax
        mov     ebx,eax
        mov     eax,[esi+TProject.pMainCategory]
        stdcall pttv_InsertCategory, [hProject],[hTreeView],[eax+TProjectCategory.pSubCategory],ebx
        mov     eax,[esi+TProject.pMainCategory]
        stdcall pttv_InsertFile, [hProject],[hTreeView],[eax+TProjectCategory.pFileList],ebx
        mov     eax,ebx
.finish:
        ret
endp

; inserts category into TreeView control
;  hProject - project handle
;  pCategory - pointer to TProjectCategory structure
;  hParentItem - parent category ID
; return
;  new category handle or NULL
proc pttv_InsertCategory uses esi ebx, hProject,hTreeView,pCategory,hParentItem
local tvis:TVINSERTSTRUCT
        mov     eax,[pCategory]
        or      eax,eax
        jz      .finish
        mov     esi,eax
        mov     eax,[hParentItem]
        mov     [tvis.hParent],eax
        mov     [tvis.hInsertAfter],TVI_LAST
        mov     [tvis.item.mask],TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE+TVIF_PARAM+TVIF_STATE
        mov     eax,[esi+TProjectCategory.iIcon]
        mov     [tvis.item.iImage],eax
        mov     [tvis.item.iSelectedImage],eax
        stdcall StrPtr, [esi+TProjectCategory.hName]
        mov     [tvis.item.pszText],eax
        xor     edx,edx
        test    [esi+TProjectCategory.iFlags],PCF_EXPANDED
        jz      @f
        mov     edx,TVIS_EXPANDED
     @@:
        mov     [tvis.item.state],edx
        mov     [tvis.item.stateMask],edx
        mov     eax,[pCategory]
        or      eax,1             ; set first bit
        mov     [tvis.item.lParam],eax
        lea     eax,[tvis]
        invoke  SendMessage, [hTreeView],TVM_INSERTITEM,0,eax
        mov     ebx,eax

        mov     eax,[esi+TProjectCategory.pSubCategory]
        or      eax,eax
        jz      .no_subcategory
        stdcall pttv_InsertCategory, [hProject],[hTreeView],eax,ebx
.no_subcategory:
        mov     eax,[esi+TProjectCategory.pNext]
        or      eax,eax
        jz      .no_next_category
        stdcall pttv_InsertCategory, [hProject],[hTreeView],eax,[hParentItem]
.no_next_category:
        mov     eax,[esi+TProjectCategory.pFileList]
        or      eax,eax
        jz      .no_files
        stdcall pttv_InsertFile, [hProject],[hTreeView],eax,ebx
.no_files:
        mov     eax,ebx
.finish:
        ret
endp

PM_FILEICONOFFSET = 10

proc pttv_InsertFile uses esi ebx, hProject,hTreeView,pFile,hParentItem
local tvis:TVINSERTSTRUCT
        mov     eax,[pFile]
        or      eax,eax
        jz      .finish
        mov     esi,eax
        mov     eax,[hParentItem]
        mov     [tvis.hParent],eax
        mov     [tvis.hInsertAfter],TVI_LAST
        mov     [tvis.item.mask],TVIF_TEXT+TVIF_IMAGE+TVIF_SELECTEDIMAGE+TVIF_PARAM
        stdcall ExtractFileName, [esi+TOpenFile.hFileName]
        mov     [tvis.item.pszText],eax
        mov     edx, [esi+TOpenFile.ptrType]
        mov     edx, [edx+TFileType.iFileIcon]
        add     edx,PM_FILEICONOFFSET
        mov     [tvis.item.iImage],edx
        mov     [tvis.item.iSelectedImage],edx
        mov     [tvis.item.lParam],esi
        lea     eax,[tvis]
        invoke  SendMessage, [hTreeView],TVM_INSERTITEM,0,eax
        mov     ebx,eax
        mov     eax,[esi+TOpenFile.pNext]
        or      eax,eax
        jz      .no_next_file
        stdcall pttv_InsertFile, [hProject],[hTreeView],eax,[hParentItem]
.no_next_file:
        mov     eax,ebx
.finish:
        ret
endp