;<ff
Window frmMain, 3, 0, 'TForm', 'Tiny GUI application using TForm', $16080000, $0, 0, 409, 88, 320, 253, MainFormWinProc;
Window NONE, 0, 0, 'BUTTON', 'Save as', $50000000, $0, 101, 240, 104, 64, 21, 0;
Window NONE, 0, 0, 'BUTTON', 'Convert', $50000000, $0, 300, 240, 200, 64, 25, 0;
Window NONE, 0, 0, 'STATIC', 'This program converts Fresh project files from the old format (Fresh 1.x) to the new format (Fresh 2.x). ', $50001080, $0, 0, 8, 176, 224, 48, 0;
Window NONE, 0, 0, 'STATIC', 'New format project file:', $50000000, $0, 0, 8, 88, 112, 16, 0;
Window NONE, 0, 0, 'STATIC', 'Old format project file:', $50000000, $0, 0, 8, 8, 112, 16, 0;
Window NONE, 0, 0, 'BUTTON', 'Open file', $50000000, $0, 100, 240, 24, 64, 21, 0;
Window NONE, 0, 0, 'EDIT', '', $50001804, $200, 201, 8, 104, 224, 56, 0;
Window NONE, 2, 0, 'EDIT', '', $50001804, $200, 200, 8, 24, 224, 56, 0;
;ff>
winproc MainFormWinProc
  .opfn OPENFILENAME
begin


ondefault
        stc
        return


onmessage WM_COMMAND

        mov     eax, [.wparam]

        cmp     eax,  100
        je      .select_open_file

        cmp     eax,  101
        je      .select_save_file

        cmp     eax,  300
        je      .convert

        jmp     .ondefault

.select_open_file:
        lea     edi, [.opfn]
        mov     ecx, sizeof.OPENFILENAME
        xor     eax, eax
        rep stosb

        lea     ebx, [.opfn]
        mov     [ebx+OPENFILENAME.lStructSize], sizeof.OPENFILENAME
        mov     eax, [.hwnd]
        mov     [ebx+OPENFILENAME.hwndOwner], eax
        mov     eax, [hInstance]
        mov     [ebx+OPENFILENAME.hInstance], eax
        mov     [ebx+OPENFILENAME.lpstrFilter], cProjectFilter
        mov     [ebx+OPENFILENAME.lpstrFile], bufferOpenFilename
        mov     [ebx+OPENFILENAME.nMaxFile], 1024
        mov     [ebx+OPENFILENAME.Flags], OFN_FILEMUSTEXIST or OFN_HIDEREADONLY

        mov     dword [bufferOpenFilename], 0
        invoke  GetOpenFileName, ebx

        invoke  SendDlgItemMessage, [.hwnd], 200, WM_SETTEXT, 0, bufferOpenFilename
        clc
        return

.select_save_file:
        lea     edi, [.opfn]
        mov     ecx, sizeof.OPENFILENAME
        xor     eax, eax
        rep stosb

        lea     ebx, [.opfn]
        mov     [ebx+OPENFILENAME.lStructSize], sizeof.OPENFILENAME
        mov     eax, [.hwnd]
        mov     [ebx+OPENFILENAME.hwndOwner], eax
        mov     eax, [hInstance]
        mov     [ebx+OPENFILENAME.hInstance], eax
        mov     [ebx+OPENFILENAME.lpstrFilter], cProjectFilter
        mov     [ebx+OPENFILENAME.lpstrFile], bufferSaveFilename
        mov     [ebx+OPENFILENAME.nMaxFile], 1024
        mov     [ebx+OPENFILENAME.Flags], OFN_HIDEREADONLY or OFN_OVERWRITEPROMPT or OFN_NOCHANGEDIR or OFN_PATHMUSTEXIST

        mov     dword [bufferSaveFilename], 0
        invoke  GetSaveFileName, ebx

        invoke  SendDlgItemMessage, [.hwnd], 201, WM_SETTEXT, 0, bufferSaveFilename
        clc
        return

.convert:
        stdcall LoadBinaryFile, bufferOpenFilename
        jc      .error_open

        stdcall ConvertProject
        jc      .convertion_error

        stdcall SaveBinaryFile, bufferSaveFilename, ecx
        clc
        return

.error_open:
        invoke  MessageBox, [.hwnd], cErrorOpen, 0, MB_OK or MB_ICONERROR
        clc
        return

.convertion_error:
        invoke  MessageBox, [.hwnd], cErrorConvertion, 0, MB_OK or MB_ICONERROR
        clc
        return


endwp



iglobal
  cProjectFilter db 'Fresh project files (*.fpr)', 0, '*.fpr', 0
                 db 'All files (*.*)', 0, '*.*', 0
                 db 0

  cErrorOpen db 'Error open file.', 0
  cErrorConvertion db 'Error converting file. Probably the file is not a valid project file.', 0
endg


uglobal
  bufferOpenFilename rb 1024
  bufferSaveFilename rb 1024

  inBin rb 65536
  outBin rb 65536
endg




proc ConvertProject
.poMemory dd ?
begin
        mov     esi, inBin
        mov     edi, outBin

        lodsd
        cmp     eax, 'FRPR'
        jne     .error

; magic header.
        mov     eax, 'FNPr'
        stosd
        mov     eax, $0a1a0a0d  ;) magic number. 'CR, LF, EOF, LF'
        stosd

; read options.
        lodsd
        cmp     eax, 0
        jl      .newformat

        mov     [.poMemory], eax
        jmp     .savememorychunk

.newformat:
        sub     eax, 7
        neg     eax
        cmp     eax, 8
        je      .compoptionsok
;
        lea     ecx, [eax-8]
;        mov     ecx, sizeof.TCompilerOptions
        add     esi, ecx

.compoptionsok:
; New format options
        lea     esi, [inBin+eax]        ; skip compiler options

; Get memory size:
        lodsd
        mov     [.poMemory], eax

;_________________________
;
; write chunks CTNM
;_________________________

        mov     eax, 'CTNM'     ; compiler target name.
        stosd

        add     edi, 4          ; reserved for hash.
        mov     edx, edi

        movsb                   ; auto name flag.

.loopname:
        mov     al, [esi]
        lea     esi, [esi+1]
        mov     [edi], al
        lea     edi, [edi+1]
        cmp     al, 0
        jne     .loopname

        call    finalize_chunk

;_________________________
;
; write chunks CMEM
;_________________________

.savememorychunk:
        mov     eax, 'CMEM'
        stosd

        add     edi, 4
        mov     edx, edi

        mov     eax, [.poMemory]
        stosd

        call    finalize_chunk

;_________________________
;
; write chunk MAIN
;_________________________

        cmp     byte [esi], 0
        je      .main_chunk_ok

        mov     eax, 'MAIN'
        stosd

        add     edi, 4
        mov     edx, edi

.loopname2:
        mov     al, [esi]
        lea     esi, [esi+1]
        mov     [edi], al
        lea     edi, [edi+1]
        cmp     al, 0
        jne     .loopname2

        call    finalize_chunk
.main_chunk_ok:

; Main category loop:
.maincatloop:
        cmp     dword [esi], -1
        je      .endofproject

        mov     eax, 'PRTR'
        stosd

        add     edi, 4
        mov     edx, edi        ; pointer to the data.

        movsd                   ; image index
        movsd                   ; reserved dword

.loopdir:
        lodsb
        stosb
        cmp     al, 0
        jne     .loopdir

        cmp     byte [esi], 0
        jne     .loopdir

        movsb

        call    finalize_chunk

        jmp     .maincatloop

.endofproject:

        lea     ecx, [edi-outBin]
        return

.error:
        xor     ecx, ecx
        stc
        return

endp


; edx points to data.
; ecx contains data len.
;
; returns computed hash in eax

check_chunk_hash:
        push    edx ebx ecx

        mov     eax, $811C9DC5                  ; 2166136261              ; FNV offset basis
        jecxz   .endhash

.hashloop:
        movzx   ebx, byte [edx]
        inc     edx
        xor     eax, ebx
        imul    eax, $01000193                  ;   16777619              ; FNV prime
        loop    .hashloop

.endhash:
        pop     ecx ebx edx
        retn


finalize_chunk:
        mov     ecx, edi
        sub     ecx, edx
        mov     [edx-4], ecx

        call    check_chunk_hash
        stosd
        retn


;--------------------------------------------------------------------
; Allocates needed memory and loads the entire file in this memory.
; Returns pointer to memory block or NULL if there is error.
; Returns size in ecx
;--------------------------------------------------------------------
proc LoadBinaryFile, .ptrFileName
.bytes dd ?
begin
        push    edi

        invoke  CreateFile, [.ptrFileName], GENERIC_READ,FILE_SHARE_READ, 0, \
                OPEN_EXISTING, 0, 0

        cmp     eax, INVALID_HANDLE_VALUE
        je      .error

        mov     edi, eax

        lea     ecx, [.bytes]
        invoke  ReadFile, edi, inBin, 65536, ecx, NULL
        invoke  CloseHandle, edi

        mov     ecx, [.bytes]
        clc
        pop     edi
        return

.error:
        xor     ecx, ecx
        stc
        pop     edi
        return

endp



;--------------------------------------------------------------------
; Saves to the file [size] bytes from given [ptr] address.
; returns TRUE if error and FALSE if OK.
;--------------------------------------------------------------------
proc SaveBinaryFile, .ptrFileName, .size
.bytes dd ?
begin
        push    esi edi ebx

        invoke  CreateFile, [.ptrFileName], GENERIC_WRITE, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
        cmp     eax, INVALID_HANDLE_VALUE
        je      .error

        mov     edi, eax

        lea     ecx, [.bytes]
        invoke  WriteFile, edi, outBin, [.size], ecx, NULL
        push    eax
        invoke  CloseHandle, edi
        pop     eax
        test    eax, eax
        jz      .error

        mov     eax, [.size]
        cmp     [.bytes], eax
        je      .ok

.error:
        stc
        pop     ebx edi esi
        return

.ok:
        clc
        pop     ebx edi esi
        return
endp
