uglobal
  hApplication dd 0     ; Only one application window can exists.
endg

iglobal
  cApplicationClassName db 'TApplication', 0
  property propMainForm,'MainForm'
  property propOnIdle, 'OnIdle'
  property propAccelerators, 'Accelerators'
endg

;initialize CreateAppPropertyes
;begin
;        stdcall CreateProperty, propMainForm
;        stdcall CreateProperty, propOnIdle
;        stdcall CreateProperty, propAccelerators
;        return
;endp
;
;
;finalize DeleteAppProperties
;begin
;        stdcall DestroyProperty, propMainForm
;        stdcall DestroyProperty, propOnIdle
;        stdcall DestroyProperty, propAccelerators
;        return
;endp
;

initialize RegisterApplicationClass
.wc WNDCLASS
begin
        xor     eax, eax
        lea     edi, [.wc]
        mov     ecx, sizeof.WNDCLASS / 4
        rep stosd

        mov     [.wc.style], CS_OWNDC
        mov     [.wc.lpfnWndProc], ApplicationWinProc
        mov     eax,[hInstance]
        mov     [.wc.hInstance],eax
        mov     [.wc.lpszClassName], cApplicationClassName

        sub     edi, sizeof.WNDCLASS
        invoke  RegisterClass, edi
        return
endp


proc InitApplication, .idIcon, .ptrCaption
begin
        xor     eax, eax
        invoke  CreateWindowEx, 0, cApplicationClassName, [.ptrCaption],               \
                                WS_SYSMENU or WS_CAPTION or WS_POPUPWINDOW or         \
                                WS_VISIBLE or WS_CLIPSIBLINGS or WS_MINIMIZEBOX,      \
                                eax, eax, eax, eax,                                   \
                                eax, eax, [hInstance], eax
        mov     [hApplication], eax

        cmp     [.idIcon], 0
        je      .finish

        invoke  LoadImage, [hInstance], [.idIcon], IMAGE_ICON, 16, 16, 0
        invoke  SendMessage, [hApplication], WM_SETICON, ICON_SMALL, eax
        invoke  LoadImage, [hInstance], [.idIcon], IMAGE_ICON, 32, 32, 0
        invoke  SendMessage, [hApplication], WM_SETICON, ICON_BIG, eax

.finish:
        return
endp



winproc ApplicationWinProc
.rect   RECT
.str    rb 1024
begin
        push    esi edi ebx
        mov     ebx, [.wmsg]

ondefault
        invoke  DefWindowProc, [.hwnd], [.wmsg], [.wparam], [.lparam]
        jmp     .finish

;-------------------------------------------------------------------------
onmessage WM_ENABLE
        stdcall EnableAllOwnedWindows, [.hwnd], [.wparam]
        jmp     .ondefault

;;-------------------------------------------------
;.setfocus:
;        invoke  SetFocus, [hLastActive]
;        xor     eax, eax
;        jmp     .finish

;-------------------------------------------------------------------------
onmessage WM_CREATE
; hide window.
        invoke  GetSystemMetrics, SM_CXSCREEN
        mov     ebx, eax
        invoke  GetSystemMetrics, SM_CYSCREEN
        shr     ebx, 3
        shr     eax, 3

        xor     ecx,ecx
        invoke  SetWindowPos, [.hwnd], ecx, ebx, eax, ecx, ecx, SWP_NOZORDER or SWP_SHOWWINDOW
        jmp     .qfalse

;-------------------------------------------------------------------------
onmessage WM_NCDESTROY
        invoke  GetProp, [.hwnd], [propAccelerators]
        test    eax, eax
        jz      .accelok

        invoke  DestroyAcceleratorTable, eax

.accelok:
        invoke  SendMessage, [.hwnd], WM_GETICON, ICON_SMALL, 0
        invoke  DestroyIcon, eax
        invoke  SendMessage, [.hwnd], WM_GETICON, ICON_BIG, 0
        invoke  DestroyIcon, eax

        invoke  PostQuitMessage, 0
        jmp     .ondefault

;-------------------------------------------------------------------------
onmessage AM_TRANSACCEL
        invoke  GetProp, [.hwnd], [propAccelerators]
        test    eax, eax
        jz      .qfalse ; false - no accelerators table.
        mov     ebx, eax

        invoke  GetProp, [.hwnd], [propMainForm]
        test    eax, eax
        jz      .qfalse ; false - no main form.
        mov     esi, eax

        invoke  IsWindowEnabled, esi
        test    eax, eax
        jz      .qfalse  ; false - the main form is disabled

        invoke  TranslateAccelerator, esi, ebx, [.wparam]    ; Accelerators handling.
        jmp     .finish

;-------------------------------------------------------------------------
onmessage AM_ONIDLE
        invoke  GetProp, [.hwnd], [propOnIdle]
        test    eax, eax
        jz      .qfalse

        call    dword eax

;------------------------------------------

.qtrue:
        xor     eax, eax
        inc     eax
        jmp     .finish

.qfalse:
        xor     eax,eax

.finish:
        pop     ebx edi esi
        return

endwp