struct TMemoryStream
  .size    dd   ?
  .offset  dd   ?
  label .data byte
ends


;------------------------------------------------------------
; Returns: ebx - base addr
;          edi - offset to put data.
;------------------------------------------------------------
proc GetStreamRoom, .ptrVarStream, .room
begin
        push    esi

        mov     esi, [.ptrVarStream]
        mov     ebx, [esi]              ; pointer to the array

        mov     edi, [ebx+TMemoryStream.offset]
        mov     eax, [ebx+TMemoryStream.size]
        sub     eax, edi
        cmp     eax, [.room]      ; check for enough room
        jge     .sizeok

        mov     eax, [ebx+TMemoryStream.size]
        shr     eax,2
        add     eax, [ebx+TMemoryStream.size]     ; size = size * 1.25
        push    eax

        invoke  HeapReAlloc, [hHeap], 0, ebx, eax
        mov     ebx, eax
        mov     [esi], eax  ; new pointer
        popd    [ebx]   ; new size.

.sizeok:
        mov     eax, [.room]
        add     [ebx+TMemoryStream.offset], eax
        pop     esi
        return
endp




proc SetStreamOfs, .ptrVarStream, .offset
begin
        push    esi edi ebx

        mov     edi, [.ptrVarStream]
        mov     eax, [edi]
        mov     ebx, [.offset]
        mov     esi, [eax+TMemoryStream.size]

        cmp     ebx, esi
        jl      .sizeok

        lea     esi, [ebx+$1000]        ; new size
        invoke  HeapRealloc, [hHeap], 0, eax, esi
        mov     [edi], eax

.sizeok:
        mov     [eax+TMemoryStream.size], esi
        mov     [eax+TMemoryStream.offset], ebx
        pop     ebx edi esi
        return
endp





proc CreateMemoryStream, .ptrVarStream, .initsize
begin
        push    ebx esi

        mov     ebx, [.initsize]
        mov     esi, [.ptrVarStream]
        add     ebx, sizeof.TMemoryStream

        invoke  HeapAlloc, [hHeap], 0, ebx
        mov     [esi], eax
        mov     [eax+TMemoryStream.size], ebx
        mov     [eax+TMemoryStream.offset], TMemoryStream.data

        pop     esi ebx
        return
endp