iglobal
  include 'actions.inc'   ; menus, action, etc

  cAddFileTitle db 'Add file to the project', 0
  cSetMainTitle db 'Select main file', 0
endg



ActionEvents:

;----------------------------------------------------------------
; This is OnIdle handler of the application.
; When message queue is empty, this subroutine is called once.
; The idea is to provide updating of the status of the controls
; without performance decreasing.
;----------------------------------------------------------------

proc OnIdle

.changed dd ?
.buffer  rb 256

begin
        push    esi edi ebx

        mov     [.changed], 0

        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actCut, 0
        test    eax,eax
        setnz   bh

        stdcall CanAction, [ptrCurrentFile], WM_CUT
        test    eax, eax
        setnz   bl

        cmp     bh, bl
        je      .cut_action_ok

        movzx   eax, bl
        movzx   ebx, bh         ; MF_BYCOMMAND + ( MF_GRAYED | MF_ENABLED )
        inc     [.changed]

        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actCut, eax
        invoke  EnableMenuItem, [hMainMenu], actCut, ebx
        invoke  EnableMenuItem, [hEditorMenu], actCut, ebx

.cut_action_ok:

        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actCopy, 0
        test    eax,eax
        setnz   bh

        stdcall CanAction, [ptrCurrentFile], WM_COPY
        test    eax, eax
        setnz   bl

        cmp     bh, bl
        je      .copy_action_ok

        movzx   eax, bl
        movzx   ebx, bh         ; MF_BYCOMMAND + ( MF_GRAYED | MF_ENABLED )
        inc     [.changed]

        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actCopy, eax
        invoke  EnableMenuItem, [hMainMenu], actCopy, ebx
        invoke  EnableMenuItem, [hEditorMenu], actCopy, ebx

.copy_action_ok:


;----------------------------------------------------------------------
; Set actPaste state enable/disable. Only for text data in clipboard.
;----------------------------------------------------------------------
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actPaste, 0
        test    eax,eax
        setnz   bh

        stdcall CanAction, [ptrCurrentFile], WM_PASTE
        test    eax, eax
        setnz   bl

        cmp     bh, bl
        je      .paste_action_ok

        movzx   eax, bl
        movzx   ebx, bh         ; MF_BYCOMMAND + ( MF_GRAYED | MF_ENABLED )
        inc     [.changed]

        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actPaste, eax
        invoke  EnableMenuItem, [hMainMenu], actPaste, ebx
        invoke  EnableMenuItem, [hEditorMenu], actPaste, ebx

.paste_action_ok:


;----------------------------------------------------------------------
; Set actUndo state enable/disable.
;----------------------------------------------------------------------
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actUndo, 0
        xor     esi, esi
        test    eax, eax
        setnz   bh

        stdcall CanAction, [ptrCurrentFile], WM_UNDO
        test    eax, eax
        setnz   bl

        cmp     bh, bl
        je      .undo_action_ok

        movzx   eax, bl
        movzx   ebx, bh
        inc     [.changed]

        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actUndo, eax
        invoke  EnableMenuItem, [hMainMenu], actUndo, ebx
        invoke  EnableMenuItem, [hEditorMenu], actUndo, ebx

.undo_action_ok:

;----------------------------------------------------------------------
; Set actSave state enable/disable.
;----------------------------------------------------------------------
        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actSave, 0
        test    eax, eax
        setnz   bh

        stdcall GetModified, [ptrCurrentFile]
        test    eax,eax
        setnz   bl

        cmp     bh,bl
        jz      .save_action_ok

        movzx   eax, bl
        movzx   ebx, bh
        inc     [.changed]

        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actSave, eax
        invoke  EnableMenuItem,[hMainMenu], actSave, ebx
        invoke  EnableMenuItem,[hTabMenu], actSave, ebx

.save_action_ok:

;----------------------------------------------------------------------
; Set actSaveAll state enable/disable.
;----------------------------------------------------------------------

        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actSaveAll, 0
        test    eax, eax
        setnz   bh

        stdcall EnumOpenFiles, _checkfirstforsave, NULL
        test    eax, eax
        setnz   bl

        cmp     bh, bl
        je      .saveall_action_ok

        movzx   eax, bl
        movzx   ebx, bh
        inc     [.changed]

        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actSaveAll, eax
        invoke  EnableMenuItem, [hMainMenu], actSaveAll, ebx

.saveall_action_ok:

;----------------------------------------------------------------------
; Set actCompile state enable/disable.
;----------------------------------------------------------------------

        invoke  SendMessage, [hMainToolbar], TB_ISBUTTONENABLED, actCompile, 0
        test    eax, eax
        setnz   bh

        invoke  SendMessage, [hProjManager], PMM_GETMAINFILE, 0, 0
        test    eax, eax
        setnz   bl

        mov     eax, [ptrCurrentFile]
        test    eax, eax
        jz      .checkcomp

        cmp     [eax+TOpenFile.ptrType], ftCommonSource
        sete    al
        or      bl, al

.checkcomp:
        cmp     bh, bl
        je      .compile_action_ok

        movzx   edi, bl
        movzx   ebx, bh
        inc     [.changed]

        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actCompile, edi
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actRun, edi
        invoke  SendMessage, [hMainToolbar], TB_ENABLEBUTTON, actDebug, edi

        invoke  EnableMenuItem,[hMainMenu], actCompile, ebx
        invoke  EnableMenuItem,[hMainMenu], actRun, ebx
        invoke  EnableMenuItem,[hMainMenu], actDebug, ebx
        invoke  EnableMenuItem,[hMainMenu], actRunDirect, ebx

.compile_action_ok:

        cmp     [.changed], 0
        je      .quit
        invoke  InvalidateRect, [hMainToolbar], NULL, FALSE
.quit:
        pop     ebx edi esi
        return
endp


proc _checkfirstforsave, .ptrFile, .dummy
begin
        stdcall GetModified, [.ptrFile]
        bt      eax, 0
        return
endp















;---------------------------------------------------
; Opens file(s) in the Fresh
;
;---------------------------------------------------
proc OnOpen, .wparam, .lparam
begin
        stdcall OpenFilesDialog, cOpenFileTitle, TRUE, AllFilter, OpenFileByNameEdit, NULL
        return
endp




proc OnOpenFileAtCursor, .wparam, .lparam
.line rb 256
.pos  AEPOS
.directory rb 1024
.name      dd ?
begin
        mov     esi, [ptrCurrentFile]
        mov     eax, [esi+TOpenFile.ptrType]
        cmp     [eax+TFileType.CreateProc], CreateSourceEditor
        jne     .finish

        mov     ebx, [esi+TOpenFile.hEditor]
        test    ebx, ebx
        je      .finish

        lea     eax, [.pos]
        invoke  SendMessage, ebx, AEM_GETPOS, eax, 0

        lea     esi, [.line]
        invoke  SendMessage, ebx, AEM_GETLINEDATA, 0, esi

        mov     ebx, [.pos.caretPosition]
        dec     ebx
        mov     ax, $2227    ; " or '
; Search to left
.toleft:
        dec     ebx
        js      .finish

        cmp     [esi+ebx], al
        je      .found
        cmp     [esi+ebx], ah
        jne     .toleft
        mov     al,ah
.found:
        lea     edi, [esi+ebx+1]
; search to right
.toright:
        inc     ebx
        cmp     ebx, $100
        jae     .finish

        cmp     [esi+ebx], al
        jne     .toright
.foundName:
        mov     byte [esi+ebx], 0

        mov     eax, [ptrCurrentFile]
        mov     eax, [eax+TOpenFile.hFileName]
        stdcall StrPtr, eax
        lea     ebx, [.directory]
        lea     ecx, [.name]
        invoke  GetFullPathName, eax, 1024, ebx, ecx
        mov     eax, [.name]
        mov     byte [eax], 0

        invoke  SetCurrentDirectory, ebx


        stdcall ConvertPath, edi
        push    eax
        stdcall OpenFileByName, eax, NULL, TRUE
        stdcall StrDel ; from stack.

.finish:
        return
endp





;----------------------------------------------------
; Save the current project and all open files to disk.
;----------------------------------------------------
proc OnSaveAll, .wparam, .lparam
begin
        stdcall EnumOpenFiles, _dosaveonefile, 0
        stdcall EnumOpenFiles, _dosaveonefile, 0
        return
endp


proc  _dosaveonefile, .ptrFile, .dummy
begin
        stdcall SaveFile, [.ptrFile]
        return
endp



;----------------------------------------------------
; Save the current editor file to the disk.
;----------------------------------------------------
proc OnSave, .wparam, .lparam
begin
        stdcall SaveFile, [ptrCurrentFile]
        return
endp


;----------------------------------------------------------
; Save the current editor file to the disk with new name.
;----------------------------------------------------------
proc OnSaveAs, .wparam, .lparam
begin
        mov     esi, [ptrCurrentFile]
        test    esi, esi
        jz      .finish
        xor     ebx, ebx
        inc     ebx
        xchg    [esi+TOpenFile.fNeverSaved], ebx

        stdcall SaveFile, esi
        test    eax, eax
        jnz     .finish

        xchg    [esi+TOpenFile.fNeverSaved], ebx

.finish:
        return
endp



;------------------------------------------
; actExit action handler
;------------------------------------------
proc OnExit, .wparam, .lparam
        begin
        invoke  PostMessage, [hApplication], WM_CLOSE, 0, 0
        return
endp




;------------------------------------------
; actClose action handler.
; Closes the current file.
;------------------------------------------
proc OnFileClose, .wparam, .lparam
begin
        xor     eax, eax
        xchg    eax, [ptrCurrentFile]
        stdcall CloseFile, eax
        return
endp


;------------------------------------------
; actCloseAll action handler.
;------------------------------------------
proc OnCloseAll, .wparam, .lparam
begin
        mov     [ptrCurrentFile], 0
        invoke  SendMessage, [hProjManager], WM_CLOSE, 0, 0
        stdcall EnumOpenFiles, _docloseone, NULL
        return
endp



proc _docloseone, .ptrFile, .dummy
begin
        stdcall CloseFile, [.ptrFile]
        cmp     eax, cfrCanceled
        je      .stop
        clc
        return

.stop:
        stc
        return
endp



proc OnCleanupMRU, .wparam, .lparam
begin
        stdcall  ValidateMRUList, [ptrMRUFiles], _MRUCheckCallback
        stdcall  ValidateMRUList, [ptrMRUProj], _MRUCheckCallback
        return
endp


proc _MRUCheckCallback, .hMRUItem
begin
        stdcall StrPtr, [.hMRUItem]
        invoke  CreateFile, eax, 0, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
        cmp     eax, INVALID_HANDLE_VALUE
        je      .qfalse
        invoke  CloseHandle, eax
        mov     eax, TRUE
        return

.qfalse:
        xor     eax, eax
        return
endp



;------------------------------------------
; aux procedure. make simultaneous switch
; of menu item and toolbutton with the same
; action.
;------------------------------------------
proc ActionSetCheck, .ID, .check
        begin
        push    esi ebx
        movzx   ebx, word [.ID]
        mov     eax, MF_UNCHECKED
        xor     esi,esi
        cmp     [.check], FALSE
        je      @f
        mov     eax, MF_CHECKED
        inc     esi
@@:
        or      eax, MF_BYCOMMAND
        invoke  CheckMenuItem, [hMainMenu], ebx, eax
        invoke  SendMessage, [hMainToolbar], TB_CHECKBUTTON, ebx, esi
        pop     ebx esi
        return
endp

;------------------------------------------
; actGridView action handler
;------------------------------------------
proc OnGridView, .wparam, .lparam
begin
        xor     [fGridVisible],1
        stdcall ActionSetCheck, [.wparam], [fGridVisible]
;        invoke  SendMessage, [hProjManager], PMM_REFRESHFORMS, 0, 0

        stdcall EnumOpenFiles, DoRefreshForms, 0
        return
endp


proc DoRefreshForms, .ptrFile, .dummy
begin
        mov     eax, [.ptrFile]
        cmp     [eax+TOpenFile.ptrType], ftFormSource
        jne     .finish

        cmp     [eax+TOpenFile.hEditor], 0
        je      .finish

        invoke  GetProp, [eax+TOpenFile.hEditor], [propWinTemplate]
        test    eax, eax
        jz      .finish

        invoke  InvalidateRect, [eax+TWinTemplateDT.hwnd], NULL, TRUE

.finish:
        clc
        return
endp


;------------------------------------------
; actSnap action handler
;------------------------------------------
proc OnSnap, .wparam, .lparam
        begin
        xor     [fSnapToGrid],1
        stdcall ActionSetCheck, [.wparam], [fSnapToGrid]
        return
endp

;------------------------------------------
; actSnap action handler
;------------------------------------------
proc OnPartialSelect, .wparam, .lparam
        begin
        xor     [fPartialSelect],1
        stdcall ActionSetCheck, [.wparam], [fPartialSelect]
        return
endp


proc OnViewProjMan, .wparam, .lparam
        begin
        invoke  IsWindowVisible, [hProjManager]
        mov     ebx, SW_SHOWNORMAL
        xor     eax, TRUE
        jnz     @f
        mov     ebx, SW_HIDE
@@:
        stdcall ActionSetCheck, [.wparam], eax
        invoke  ShowWindow, [hProjManager], ebx
        return
endp


proc OnViewPropEditor, .wparam, .lparam
        begin
        invoke  IsWindowVisible, [hPropEditor]
        mov     ebx, SW_SHOWNORMAL
        xor     eax, TRUE
        jnz     @f
        mov     ebx, SW_HIDE
@@:
        stdcall ActionSetCheck, [.wparam], eax
        invoke  ShowWindow, [hPropEditor], ebx
        return
endp


proc OnViewSourceEditor, .wparam, .lparam
        begin
        invoke  IsWindowVisible, [hEditorsHost]
        test    eax, eax
        jnz     .setfocus

        mov     ebx, SW_SHOWNORMAL
        mov     eax, TRUE
        stdcall ActionSetCheck, [.wparam], eax
        invoke  ShowWindow, [hEditorsHost], ebx
        return

.setfocus:
        invoke  SetActiveWindow, [hEditorsHost]
        return
endp



proc OnShowForm, .wparam, .lparam
begin
        mov     eax, [ptrCurrentFile]
        test    eax, eax
        jz      .exit

        cmp     [eax+TOpenFile.ptrType], ftFormSource
        jne      .exit

        invoke  SendMessage, [eax+TOpenFile.hEditor], FEM_SWITCHMODE, 0, 0

.exit:
        return
endp



proc OnUndo, .wparam, .lparam
begin
        stdcall CommonAction2, WM_UNDO
        return
endp


proc OnPaste, .wparam, .lparam
begin
        stdcall CommonAction2, WM_PASTE
        return
endp

proc OnDelete, .wparam, .lparam
begin
        stdcall CommonAction2, WM_CLEAR
        return
endp


proc OnCut, .wparam, .lparam
begin
        stdcall CommonAction2, WM_CUT
        return
endp


proc OnCopy, .wparam, .lparam
begin
        stdcall CommonAction2, WM_COPY
        return
endp


proc CommonAction2, .cmd
begin
        invoke  GetFocus
        mov     esi, eax

        invoke  GetProp, esi, [propOpenFileStructure]
        test    eax, eax
        jnz     .toeditor

        mov     eax, esi

.loop:
        mov     ebx, eax
        invoke  GetProp, ebx, [propTemplateDT]
        test    eax, eax
        jnz     .toformeditor

        invoke  GetParent, ebx
        test    eax, eax
        jnz     .loop

.control:
        invoke  SendMessage, esi, [.cmd], 0, 0
        return

.toeditor:
        stdcall CommonAction, eax, [.cmd]
        return

.toformeditor:
        cmp     [eax+TWinTemplateDT.ptrFile], 0
        je      .next

        mov     eax, [eax+TWinTemplateDT.ptrFile]
        jmp     .toeditor

.next:
        mov     eax, [eax+TWinTemplateDT.parent]
        test    eax, eax
        jnz     .toformeditor
        return
endp

;------------------------------------------------
; Temporary action handler for functions
; not implemented on this stage.
;------------------------------------------------
proc OnNotImplemented, .wparam, .lparam
begin
        invoke  MessageBox, [hApplication], cNotImplText, cNotImplTitle, MB_OK or MB_ICONINFORMATION
        return
endp


iglobal
  cNotImplText db 'Sorry, but this feature is not implemented yet. :)', 0
  cNotImplTitle db 'Information', 0
endg



;------------------------------------------
; actAbout action handler
; using of message box is only temporary.
; this must be more fancy :)
;------------------------------------------
proc OnAbout, .wparam, .lparam
begin
        stdcall CreateForm, AboutForm, [hApplication]

        stdcall LoadGif, [hInstance], resBmpAbout
        push    eax
        invoke  SendDlgItemMessage, ebx, 101, STM_SETIMAGE, IMAGE_BITMAP, eax

        invoke  CreateFont, about_font_size, 0, 0, 0, FW_NORMAL,                                \
                            0, 0, 0, about_font_charset,                                        \
                            OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,           \
                            FIXED_PITCH or FF_DONTCARE, about_font_name
        push    eax
        invoke  SendDlgItemMessage, ebx, 102, WM_SETFONT, eax, TRUE
        invoke  SendDlgItemMessage, ebx, 102, WM_SETTEXT, 0, cAboutText

        stdcall ShowModal, ebx, MSF_CENTER

        invoke  DestroyWindow, ebx
        invoke  DeleteObject
        invoke  DeleteObject

        return
endp



iglobal
  ; About box form definition.
  Window AboutForm, wtParent or wtEnd, waNone, 'TForm', 'About "Fresh"...', WS_CAPTION or WS_CLIPCHILDREN or WS_SYSMENU or WS_DLGFRAME, 0, NULL, 0, 0, 480, 300, NULL
  Window NONE, wtChild, waBottom, 'Button', 'Close', WS_VISIBLE or WS_CHILD or WS_BORDER, 0, MR_OK, 10, 50, 64, 25, NULL
  Window NONE, wtChild, waLeft, 'Static', '', WS_VISIBLE or WS_CHILD or SS_BITMAP or SS_CENTERIMAGE or WS_BORDER, 0, 101, 0, 10, 178, 19, NULL
  Window NONE, wtChild or wtEnd, waClient, 'Static', '', WS_VISIBLE or WS_CHILD or SS_LEFT or WS_BORDER, WS_EX_CLIENTEDGE, 102, 0, 10, 180, 19, NULL

  cAboutText db $0d, ' Fresh IDE', $0d, $0d
             db ' IDE: ', FRESH_VERSION, $0d
             db ' build: '
             create_build_time DAY, MONTH, YEAR
             db $0d
             db '     John Found', $0d
             db '     Fredrik Klasson (aka scientica)', $0d
             db '     Tommy Lillehagen',$0d
             db '     Mateusz Tymek (aka decard)', $0d
             db '     Victor Loh (aka roticv)', $0d
             db '     Yunus Sina Gulsen (aka VeSCeRa)', $0d, $0d
             db '  Compiler: FASM ',VERSION_STRING, $0d
             db '     Tomasz Grysztar (aka Privalov)', 0

  about_font_size = -12
  about_font_charset = ANSI_CHARSET
  about_font_name    db 'Arial', 0
endg




;*****************************************************************************
; Bookmarks actions and some edit actions by Tommy Lillehagen.
;*****************************************************************************

proc OnToggleBM, .wparam, .lparam
begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        invoke  SendMessage, eax, AEM_TOGGLEBOOKMARK, 0, 0
.finish:
        return
endp



proc OnNextBM, .wparam, .lparam
.pos AEPOS
        begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx,eax
        invoke  SendMessage,ebx, AEM_GOTOBOOKMARK, 0, AEBM_NEXT

        mov     [.pos.caretLine],eax
        mov     [.pos.selectionLine],eax
        mov     [.pos.caretPosition],1
        mov     [.pos.selectionPosition],1
        lea     eax, [.pos]
        invoke  SendMessage, ebx, AEM_SETPOS, eax, 0
.finish:
        return
endp



proc OnPrevBM, .wparam, .lparam
.pos AEPOS
begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish

        mov     ebx,eax
        invoke  SendMessage, ebx, AEM_GOTOBOOKMARK, 0, AEBM_PREV
        mov     [.pos.caretLine], eax
        mov     [.pos.selectionLine], eax
        mov     [.pos.caretPosition],1
        mov     [.pos.selectionPosition],1
        lea     eax, [.pos]
        invoke  SendMessage, ebx, AEM_SETPOS, eax, 0
.finish:
        return
endp


proc OnClearBM, .wparam, .lparam
        begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        invoke  SendMessage, eax, AEM_CLEARBOOKMARKS, 0, 0
.finish:
        return
endp


proc OnComment, .wparam, .lparam
begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_COMMENT, 0, 1
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0

.finish:
        return
endp



proc OnUncomment, .wparam, .lparam
begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_COMMENT, 0, 0
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0
.finish:
        return
endp



proc OnIndent, .wparam, .lparam
begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_INDENT, 0, 1
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0
.finish:
        return
endp


proc OnOutdent, .wparam, .lparam
begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish
        mov     ebx, eax
        invoke  SendMessage, ebx, AEM_INDENT, 0, 0
        invoke  SendMessage, ebx, AEM_SETMODIFIED, TRUE, 0
.finish:
        return
endp



;************************************************************************
; Returns modal result from progress window.
;************************************************************************
proc OnCompile, .wparam, .lparam
.exit dd ?

begin
        mov     [comp_handle], 0

        invoke  SendMessage, [frmMsg], MWM_CLEARMESSAGES, 0, 0

; Save compiler options

; Set compiler properties...
        mov     eax, [poMemory]
        cmp     eax, 8192               ; 8MEG is smallest possible memory
        jge     @f
        mov     eax, 8192
@@:
        mov     [compiler_memory], eax

; Set output filename...

        xor     eax, eax
        cmp     [poBinNameAuto], FALSE
        jne     .setoutputname

        stdcall StrLen, [poBinName]
        test    eax, eax
        jz      .setoutputname

uglobal
  out_filename_buffer rb 256
endg
        lea     ecx, [eax+1]
        stdcall StrPtr, [poBinName]
        mov     esi, eax
        mov     edi, out_filename_buffer
        rep movsb

        mov     eax, out_filename_buffer

.setoutputname:
        mov     [output_file], eax
        mov     eax, cDumpFilename
        mov     [symbols_file], eax

        stdcall ProgressWndCreate, 4, 1, cProgressCaption,0

        invoke  SendMessage, [hProjManager], PMM_GETMAINFILE, 0, 0
        test    eax, eax
        jnz     .docompile

        mov     eax, [ptrCurrentFile]
        test    eax, eax
        jz      .finish

        cmp     [eax+TOpenFile.ptrType], ftCommonSource
        jne     .finish

.docompile:
        stdcall PrepareForCompilation, [eax+TOpenFile.hFileName]
        test    eax, eax
        jz      .outofmemory

        mov     [flagFakeCompile], 0

        invoke  CreateThread, NULL, $4000, flat_assembler, NULL, NULL, comp_handle
        mov     [comp_handle], eax

        stdcall ShowModal, [hProgressWnd], MSF_CENTER
        mov     [.exit], eax

        cmp     [.exit], MR_CANCEL
        jne     .compended

;user canceled the compilation
        invoke  TerminateThread, [comp_handle], -1

.compended:
        cmp     [.exit], MR_OK
        je      .getdebug

; try to compile with flagFakeCompile = 1 -> this should remove errors.
        invoke  CloseHandle, [comp_handle]

        stdcall  CleanupAfterCompilation
        mov     eax, [ptrCurrentFile]
        stdcall PrepareForCompilation, [eax+TOpenFile.hFileName]

        mov      [flagFakeCompile], 1
        invoke  CreateThread, NULL, $4000, flat_assembler, NULL, NULL, comp_handle
        mov     [comp_handle], eax

        stdcall ShowModal, [hProgressWnd], MSF_CENTER

        invoke  DeleteFile, [output_file]

; Capture labels info
.getdebug:
        invoke  CloseHandle, [comp_handle]

        stdcall LoadBinaryFile, cDumpFilename
        test    eax, eax
        jz      .fasok

        stdcall CopyPreprocessedSource, eax
        stdcall CreateLabelsTree, eax
        stdcall CaptureDebugInfo, eax

        invoke  HeapFree, [hHeap], 0, eax

.fasok:
        invoke  DeleteFile, cDumpFilename
        cmp     [.exit], MR_OK
        je      .finalize

; find the error message.
        invoke  SendMessage, [frmMsg], MWM_FIRSTERROR, 0, 0

.finalize:
        stdcall AddCompilationStatistics

        stdcall CleanupAfterCompilation
        mov     [flagFakeCompile], 0

        push    [.exit]
        jmp     .return

.outofmemory:
        invoke  MessageBox, [hApplication], cOutOfMemory, NULL, MB_ICONERROR or MB_OK
.finish:
        push    MR_ABORT

.return:
        stdcall ProgressWndDestroy
        pop     eax
        return
endp

uglobal
  comp_handle dd ?
endg

iglobal
    cDumpFilename db 'dump.fas',0
    cProgressCaption db 'Compiling...',0
    cOutOfMemory db "Can't allocate memory for compilator. Check settings of Fresh.", 0
endg



proc OnDebug, .wparam, .lparam
.sinfo  STARTUPINFO
.pinfo  PROCESSINFO
begin
        stdcall OnCompile, 0, 0
        cmp     eax, MR_OK
        jne     .finish         ; There are errors during compilation.

        cmp     [output_format], 5
        jne     .windebuger

        stdcall RunInLinux, TRUE
        jmp     .finish

.windebuger:
        mov     ecx, sizeof.STARTUPINFO / 4
        lea     edi,[.sinfo]
        xor     eax, eax
        rep stosd
        mov     [.sinfo.cb], sizeof.STARTUPINFO
        mov     [.sinfo.dwFlags],0

        stdcall GetParamFromINI, cDebugerKey
        jnc     .debugerok

        stdcall StrNew
        jmp     .nodebuger

.debugerok:
        push    eax
        stdcall StrCharCat, eax, ' '

.nodebuger:
        stdcall StrCat, eax, [CompiledFileName]
        stdcall StrPtr, eax

        lea     edx,[.sinfo]
        lea     ecx,[.pinfo]
        invoke  CreateProcess, NULL, eax, NULL,NULL,FALSE,NORMAL_PRIORITY_CLASS,NULL,NULL,edx,ecx
        stdcall StrDel ; from the stack
        test    eax,eax
        jnz     .ok

        stdcall LastError
.ok:
        invoke  CloseHandle,[.pinfo.hThread]
        invoke  CloseHandle,[.pinfo.hProcess]
.finish:
        return
endp



proc OnShowMessages, .wparam, .lparam
begin

        invoke  IsWindowVisible, [frmMsg]
        xor     eax, 1
        invoke  SendMessage, [frmMsg], MWM_SHOWMESSAGES, eax, 0
        return
endp



iglobal
  Window  dlgCategorySelect,  wtParent or wtEnd, waNone, 'TForm', 'Add category:', $06080000, WS_EX_DLGMODALFRAME, 0, 0, 0, 252, 208, CategorySelectProc
  Window  NONE,  wtChild, waNone, 'Static', 'Category &Name:', ComCtrlStyle, 0, 0, 4, 4, 200, 16, NULL
  Window  NONE,  wtChild, waNone, 'Edit', '', ComCtrlStyle or WS_TABSTOP or ES_AUTOHSCROLL,  WS_EX_CLIENTEDGE, 101, 4, 20, 236, 19, NULL
  Window  NONE,  wtChild, waNone, 'Static', 'Category &Icon:', ComCtrlStyle, 0, 0, 4, 42, 200, 16, NULL
  Window  NONE,  wtChild, waNone, LISTVIEW_CLASS, '', ComCtrlStyle or WS_TABSTOP or LVS_ICON or LVS_SINGLESEL or LVS_SHAREIMAGELISTS or LVS_NOLABELWRAP or LVS_AUTOARRANGE or LVS_NOSCROLL or LVS_SHOWSELALWAYS, WS_EX_CLIENTEDGE, 102, 4, 58, 236, 92, NULL
  Window  NONE,  wtChild, waNone, 'Button', 'OK', ComCtrlStyle or WS_TABSTOP or BS_DEFPUSHBUTTON, 0, MR_OK, 48, 156, 64, 24, NULL
  Window  NONE,  wtChild or wtEnd, waNone, 'Button', 'Cancel', ComCtrlStyle or WS_TABSTOP, 0, MR_CANCEL, 128, 156, 64, 24, NULL
endg


proc CategorySelectProc, .hwnd, .wmsg, .wparam, .lparam
.lvi LVITEM
.tvi TVITEM
.str rb 256
begin
        cmp     [.wmsg], FM_AFTERCREATE
        je      .aftercreate

        stc
        return

.aftercreate:
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETIMAGELIST, LVSIL_NORMAL, [imlCategories]
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETICONSPACING, 0, $00240018
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_BORDERSELECT

        invoke  ImageList_GetImageCount, [imlCategories]
        mov     ebx, eax
        xor     esi, esi

.imageadd:
        lea     eax, [.str]
        lea     ecx, [esi+1]
        stdcall NumToStr, ecx, eax, 0, ntsUnsigned or ntsZeroTerminated or ntsDec

        mov     [.lvi.mask], LVIF_IMAGE or LVIF_TEXT
        mov     [.lvi.pszText], eax
        mov     [.lvi.iItem], esi
        mov     [.lvi.iSubItem], 0
        mov     [.lvi.iImage], esi
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_INSERTITEM, 0, eax
        inc     esi
        dec     ebx
        jnz     .imageadd

        mov     [.lvi.stateMask], LVIS_FOCUSED or LVIS_SELECTED
        mov     [.lvi.state], LVIS_FOCUSED or LVIS_SELECTED
        lea     eax, [.lvi]
        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETITEMSTATE, 0, eax

        invoke  GetDlgItem, [hProjManager], ProjTreeCtrlID
        mov     ebx, eax

        invoke  SendMessage, ebx, TVM_GETNEXTITEM, TVGN_CARET, 0


        stdcall GetFullItemName, ebx, eax
        push    ecx
        push    eax

        stdcall StrPtr, eax
        invoke  SendDlgItemMessage, [.hwnd], 101, WM_SETTEXT, 0, eax
        invoke  SendDlgItemMessage, [.hwnd], 101, EM_SETSEL, 0, -1
        stdcall StrDel ; from the stack.

        pop     ecx
        lea     eax, [.lvi]
        mov     [eax+LVITEM.stateMask], LVIS_FOCUSED or LVIS_SELECTED
        mov     [eax+LVITEM.state], LVIS_FOCUSED or LVIS_SELECTED

        invoke  SendDlgItemMessage, [.hwnd], 102, LVM_SETITEMSTATE, ecx, eax

        invoke  SendMessage, [hProjManager], _CEM_SETMODIFIED, TRUE, 0

        clc
        return
endp


proc OnAddCategory, .wparam, .lparam
.res  dd ?
begin
        mov     [.res], FALSE

        stdcall CreateForm, dlgCategorySelect, [hApplication]

        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .finishadd

        invoke  SendDlgItemMessage, ebx, 102, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
        cmp     eax, -1
        jne     @f

        mov     eax, 4
@@:
        mov     edi, eax

        invoke   GetDlgItem, ebx, 101
        stdcall  GetControlText, eax, NULL
        push     eax ; for delete

        stdcall StrCharCat, eax, '\'
        stdcall GetCategoryTree, eax, TVI_ROOT, edi

        invoke  SendDlgItemMessage, [hProjManager], ProjTreeCtrlID, TVM_SELECTITEM, TVGN_CARET, eax

        stdcall StrDel ; From the stack.
        mov     [.res], TRUE

        invoke  SendMessage, [hProjManager], _CEM_SETMODIFIED, TRUE, 0

.finishadd:
        invoke  DestroyWindow, ebx
        mov     eax, [.res]
        return
endp



proc OnEditCategory, .wparam, .lparam
.tvi TVITEM
begin
        stdcall CreateForm, dlgCategorySelect, [hApplication]
        invoke  SendDlgItemMessage, ebx, 101, EM_SETREADONLY, TRUE, 0

        stdcall ShowModal, ebx, MSF_CENTER
        cmp     eax, MR_OK
        jne     .finish

        invoke  SendDlgItemMessage, ebx, 102, LVM_GETNEXTITEM, -1, LVNI_FOCUSED
        cmp     eax, -1
        jne     @f

        mov     eax, 4
@@:
        mov     edi, eax

        invoke   GetDlgItem, ebx, 101
        stdcall  GetControlText, eax, NULL
        push     eax ; for delete

        stdcall GetCategoryTree, eax, TVI_ROOT, edi

        lea     ecx, [.tvi]
        mov     [ecx+TVITEM.hItem], eax
        mov     [ecx+TVITEM.mask], TVIF_IMAGE or TVIF_SELECTEDIMAGE
        mov     [ecx+TVITEM.iImage], edi
        mov     [ecx+TVITEM.iSelectedImage], edi

        invoke  SendDlgItemMessage, [hProjManager], ProjTreeCtrlID, TVM_SETITEM, 0, ecx
        invoke  SendDlgItemMessage, [hProjManager], ProjTreeCtrlID, TVM_SELECTITEM, TVGN_CARET, eax

        stdcall StrDel ; From the stack.

.finish:
        invoke  DestroyWindow, ebx
        return
endp



proc OnAddFile, .wparam, .lparam
begin
        stdcall OpenFilesDialog, cAddFileTitle, TRUE, AllFilter, _AddFileCallback, FALSE, NULL
        return
endp

proc _AddFileCallback, .hFileName, .lParam
begin
        stdcall OpenFileByName, [.hFileName], NULL, FALSE
        test    eax, eax
        jz      .finish
        invoke  SendMessage, [hProjManager], PMM_ADDFILE, eax, -1
.finish:
        return
endp


proc OnSetMainFile, .wparam, .lparam
begin
        stdcall OpenFilesDialog, cSetMainTitle, FALSE, FileFilter, _SetMainCallback, NULL
        return
endp


proc _SetMainCallback, .hFileName, .dummy
begin
        stdcall OpenFileByName, [.hFileName], NULL, FALSE
        test    eax, eax
        jz      .finish
        invoke  SendMessage, [hProjManager], PMM_ADDFILE, eax, 0
.finish:
        return
endp




proc OnShowNotUsed, .wparam, .lparam
begin
        invoke  SendMessage, [frmMsg], MWM_CLEARMESSAGES, 0, 0
        stdcall ShowNotUsed
        return
endp


proc OnAutoArrange, .wparam, .lparam
begin
        stdcall AutoArrangeWindows
        return
endp

proc OnNextWindow, .wparam, .lparam
begin
        invoke  SendMessage, [hEditorsHost], _EHM_SETACTIVETAB, 1, TRUE
        return
endp



proc OnPrevWindow, .wparam, .lparam
begin
        invoke  SendMessage, [hEditorsHost], _EHM_SETACTIVETAB, -1, TRUE
        return
endp


iglobal
  cIncludeFilesTitle db 'Filenames as "include" statement', 0
  cIncludeRoot       db '', 0
endg

proc OnIncludeFile, .wparam, .lparam
.aepos AEPOS
.hwnd  dd ?
.IncludeGroup dd ?
begin
        xor     eax, eax
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, eax, eax
        test    eax, eax
        jz      .finish

        mov     [.hwnd], eax

        stdcall StrNew
        mov     [.IncludeGroup], eax

        stdcall ConvertPath, cIncludeRoot
        push    eax
        stdcall OpenFilesDialog, cIncludeFilesTitle, TRUE, AllFilter, _DoInsertOneFile, eax, [.IncludeGroup]
        stdcall StrDel ; from the stack

        lea     esi, [.aepos]
        invoke  SendMessage, [.hwnd], AEM_GETPOS, esi, 0
        mov     [esi+AEPOS.caretPosition], 1
        mov     [esi+AEPOS.selectionPosition], 1
        mov     eax, [esi+AEPOS.caretLine]
        mov     [esi+AEPOS.selectionLine], eax
        invoke  SendMessage, [.hwnd], AEM_SETPOS, esi, 0

        invoke  SendMessage, [.hwnd], AEM_GETMODE, 0, 0
        push    eax
        invoke  SendMessage, [.hwnd], AEM_SETMODE, 0, 0

        stdcall StrCat, [.IncludeGroup], cIncludeEnd2
        stdcall StrPtr, [.IncludeGroup]
        invoke  SendMessage, [.hwnd], EM_REPLACESEL, TRUE, eax

        stdcall StrDel, [.IncludeGroup]

        pop     eax
        invoke  SendMessage, [.hwnd], AEM_SETMODE, eax, 0

        lea     esi, [.aepos]
        invoke  SendMessage, [.hwnd], AEM_GETPOS, esi, 0
        mov     eax, [esi+AEPOS.selectionPosition]
        mov     ecx, [esi+AEPOS.selectionLine]
        mov     [esi+AEPOS.caretPosition], eax
        mov     [esi+AEPOS.caretLine], ecx
        invoke  SendMessage, [.hwnd], AEM_SETPOS, esi, 0

.finish:
        return
endp


proc _DoInsertOneFile, .hFileName, .hGroup
begin
        stdcall _RelativeToFinc, [.hFileName]
        stdcall StrCat, [.hGroup], cIncludeCommand

        stdcall StrCat, [.hGroup], eax
        stdcall StrDel, eax

        stdcall StrCat, [.hGroup], cIncludeEnd
        return
endp


proc _RelativeToFinc, .hFileName
.olddir rb 1024
begin
        lea     eax, [.olddir]
        invoke  GetCurrentDirectory, 1024, eax

        stdcall ConvertPath, cIncludeRoot
        push    eax

        stdcall StrPtr, eax
        invoke  SetCurrentDirectory, eax
        stdcall StrDel ; from the stack

        stdcall GetRelativePath, [.hFileName]
        stdcall StrInsert, eax, cIncludeRoot, 0
        push    eax

        lea     eax, [.olddir]
        invoke  SetCurrentDirectory, eax

        pop     eax
        return
endp

;************************************************************************
; ReplaceVarString - replaces some variable (actually string) in hEdit with
; the value of hString.
; hEdit - handle of AsmEdit control
; ptrVar - pointer to varname string.
; hString - handle of the string that will replace the var name.
;************************************************************************
proc ReplaceVarString, .hEdit, .ptrVar, .hString

.oldpos AEPOS
.aepos  AEPOS

        begin
        push    ebx esi

        lea     eax, [.oldpos]
        invoke  SendMessage, [.hEdit], AEM_GETPOS, eax, 0

        stdcall StrPtr, [.hString]
        mov     esi, eax
        test    esi, esi
        jz      .endofsearch

        mov     ebx, [.hEdit]

        mov     [.aepos.selectionPosition], 1
        mov     [.aepos.selectionLine], 1
        mov     [.aepos.caretPosition], 1
        mov     [.aepos.caretLine], 1
        lea     eax, [.aepos]
        invoke  SendMessage, ebx, AEM_SETPOS, eax, 0
        invoke  SendMessage, ebx, AEM_FINDFIRST, AEFIND_CASESENSITIVE, [.ptrVar]
        test    eax, eax
        jz      .endofsearch

        invoke  SendMessage, ebx, EM_REPLACESEL, FALSE, esi

.loop:
        invoke  SendMessage, ebx, AEM_FINDNEXT, 0, 0
        test    eax, eax
        jz      .endofsearch

        invoke  SendMessage, ebx, EM_REPLACESEL, FALSE, esi
        jmp     .loop

.endofsearch:
        lea     eax, [.oldpos]
        invoke  SendMessage, [.hEdit], AEM_SETPOS, eax, 0

        pop     esi ebx
        return
endp


        DispSize  'action events', ($ - ActionEvents)
