;<ff
Window frmGraphicEditor, 3, 0, 'TForm', '', $46000000, $200, 0, 215, 213, 328, 217, GraphEditorProc;
Window NONE, 2, 5, 'STATIC', 'Image', $5031000A, $0, 100, 0, 0, 316, 186, PaintBoxProc;
;ff>
clBackground = $808080
clOutOfImage = $808080
clBackgroundLines = $ffffff
clGridLines       = $606060


struct TGraphic
; edited image data
  .ImageDC   dd ?
  .Image     BITMAPINFOHEADER
  .ptrImage  dd ?
  .hImage    dd ?

; back buffer data
  .ScreenDC  dd ?
  .Shadow    BITMAPINFOHEADER
  .ptrShadow dd ?
  .hShadow   dd ?

; editor data
  .Zoom      dd ? ; zoom factor.
  .xBeg      dd ? ;
  .yBeg      dd ? ;
  .hBackground dd ? ; brush for the background.
ends


iglobal
  property propGraphic, 'Graphic'

  CoolToolbar GraphicToolbar,           \
    bfCheckGroup or bfWrap, actSelectTool,             \
    bfCheckGroup or bfWrap, actWandTool,               \
    bfCheckGroup or bfWrap, actPenTool,                \
    bfCheckGroup or bfWrap, actFillTool
endg



proc CreateGraphicEditor, .ptrOpenFile, .hTemplate
begin
        push    ebx esi edi

        mov     esi, [.ptrOpenFile]

        stdcall CreateForm, frmGraphicEditor, [hEditorsHost]
        test    ebx, ebx
        jz      .errorcreate

        mov     [esi+TOpenFile.hEditor], ebx
        invoke  SetProp, ebx, [propOpenFileStructure], esi

        invoke  SendMessage, ebx, CEM_LOADFILE, [.hTemplate], 0
        test    eax, eax
        jnz     .errorload

        invoke  SendMessage, [hEditorsHost], EHM_DOCKWINDOW, ebx, dfClient
        xor     eax, eax
        pop     edi esi ebx
        return

.errorcreate:
        invoke  GetLastError
        pop     edi esi ebx
        return

.errorload:
        push    eax
        invoke  DestroyWindow, ebx
        pop     eax
        pop     edi esi ebx
        return
endp



;*********************************************************************
; This is window procedure for paint box for image editing.
;*********************************************************************
winproc PaintBoxProc
begin
        invoke  GetProp, [.hwnd], [propGraphic]
        mov     edi, eax

ondefault
; never passes the messages to the static class procedure.
; uses DefWindowProc instead.
        invoke  DefWindowProc, [.hwnd], [.wmsg], [.wparam], [.lparam]
        clc
        return


onmessage WM_SIZE
; creates new bitmap
        movsx   eax, word [.lparam+2] ; height
        movsx   ecx, word [.lparam]   ; width
        neg     eax
        mov     [edi+TGraphic.Shadow.biWidth], ecx
        mov     [edi+TGraphic.Shadow.biHeight], eax
        mov     [edi+TGraphic.Shadow.biSize], sizeof.BITMAPINFOHEADER
        mov     [edi+TGraphic.Shadow.biPlanes], 1
        mov     [edi+TGraphic.Shadow.biBitCount], 32
        mov     [edi+TGraphic.Shadow.biCompression], BI_RGB
        mov     [edi+TGraphic.Shadow.biSizeImage], 0
        mov     [edi+TGraphic.Shadow.biClrUsed], 0
        mov     [edi+TGraphic.Shadow.biClrImportant], 0
        lea     eax, [edi+TGraphic.Shadow]
        lea     ecx, [edi+TGraphic.ptrShadow]
        invoke  CreateDIBSection, [edi+TGraphic.ScreenDC], eax, DIB_RGB_COLORS, ecx, NULL, NULL
        mov     [edi+TGraphic.hShadow], eax
        invoke  SelectObject, [edi+TGraphic.ScreenDC], [edi+TGraphic.hShadow]

; delete old bitmap
        invoke  DeleteObject, eax

; Draw shadow image (back buffer)
        stdcall DrawShadow, edi

; Set scrollbar
  locals
    .sbi  SCROLLINFO
  endl
        lea     esi, [.sbi]

        mov     eax, [edi+TGraphic.Shadow.biWidth]
        xor     edx, edx
        div     [edi+TGraphic.Zoom]
        test    edx, edx
        jz      @f
        inc     eax
@@:
        mov     [esi+SCROLLINFO.nPage], eax

        mov     eax, [edi+TGraphic.Image.biWidth]
        mov     [esi+SCROLLINFO.nMax], eax

        mov     [esi+SCROLLINFO.nMin], 0
        mov     [esi+SCROLLINFO.cbSize], sizeof.SCROLLINFO
        mov     [esi+SCROLLINFO.fMask], SIF_RANGE or SIF_PAGE

        invoke  SetScrollInfo, [.hwnd], SB_HORZ, esi, TRUE

        mov     eax, [edi+TGraphic.Shadow.biHeight]
        neg     eax
        xor     edx, edx
        div     [edi+TGraphic.Zoom]
        test    edx, edx
        jz      @f
        inc     eax
@@:
        mov     [esi+SCROLLINFO.nPage], eax

        mov     eax, [edi+TGraphic.Image.biHeight]
        neg     eax
        mov     [esi+SCROLLINFO.nMax], eax

        invoke  SetScrollInfo, [.hwnd], SB_VERT, esi, TRUE

        xor     eax, eax
        clc
        return

onmessage WM_ERASEBKGND

        xor     eax, eax
        inc     eax
        clc
        return


onmessage WM_PAINT
  locals
    .ps PAINTSTRUCT
  endl

        lea     esi, [.ps]
        invoke  BeginPaint, [.hwnd], esi

        mov     eax, [edi+TGraphic.Shadow.biHeight]
        neg     eax
        invoke  BitBlt, [esi+PAINTSTRUCT.hdc], 0, 0,            \
                        [edi+TGraphic.Shadow.biWidth], eax,     \
                        [edi+TGraphic.ScreenDC], 0, 0, SRCCOPY

        invoke  EndPaint, [.hwnd], esi
        xor     eax, eax
        clc
        return


onmessage AM_INITWINDOW
; Initialization of the editor.
        invoke  HeapAlloc, [hHeap], HEAP_ZERO_MEMORY, sizeof.TGraphic
        mov     edi, eax
        invoke  SetProp, [.hwnd], [propGraphic], edi

        invoke  CreateCompatibleDC, NULL
        mov     [edi+TGraphic.ScreenDC], eax

        mov     [edi+TGraphic.Zoom], 12  ; begin zoom factor.

        clc
        return


onmessage WM_DESTROY

        invoke  DeleteDC, [edi+TGraphic.ScreenDC]
        invoke  DeleteObject, [edi+TGraphic.hShadow]
        invoke  DeleteDC, [edi+TGraphic.ImageDC]
        invoke  DeleteObject, [edi+TGraphic.hImage]

        invoke  HeapFree, [hHeap], 0, edi

        clc
        return

onmessage WM_GETDLGCODE
        mov     eax, DLGC_WANTARROWS
        clc
        return

onmessage WM_HSCROLL
onmessage WM_VSCROLL
        stdcall ScrollBarMessage, [.hwnd], [.wmsg], [.wparam], NULL

        lea     ecx, [edi+TGraphic.xBeg]
        cmp     [.wmsg], WM_HSCROLL
        je      .kindok
        lea     ecx, [edi+TGraphic.yBeg]
.kindok:
        mov     [ecx], eax

        stdcall DrawShadow, edi
        invoke  RedrawWindow, [.hwnd], NULL, NULL, RDW_INVALIDATE or RDW_UPDATENOW

        xor     eax, eax
        clc
        return

endwp


uglobal
  imgTools     dd ?
  imgToolsGray dd ?
endg


;-----------------------------------------------------------------------
; Window procedure for the GraphicEditor window.
; Arguments:
;   .hwnd - handle of the window
;   .wmsg - code of the message
;   .wparam \ Parameters of the message
;   .lparam /
;-----------------------------------------------------------------------
winproc GraphEditorProc
begin

ondefault
        stc
        return


onmessage FM_AFTERCREATE
; init toolboxes and menues...
        stdcall  ImageList_LoadGif, [hInstance], resBmpGraphicTools, 16, FALSE
        mov      [imgTools], eax
        stdcall  ImageList_LoadGif, [hInstance], resBmpGraphicTools, 16, TRUE
        mov      [imgToolsGray], eax

        stdcall  CreateCoolToolbar, MainActionList, GraphicToolbar, [.hwnd], 101, [imgTools], [imgToolsGray]
        mov      ebx, eax
        stdcall  SetAlign, ebx, waTop

        clc
        return


onmessage WM_DESTROY
        invoke  ImageList_Destroy, [imgTools]
        invoke  ImageList_Destroy, [imgToolsGray]
        jmp     .ondefault


onmessage CEM_LOADFILE
  locals
    .bitmap BITMAP
    .newbitmap dd ?
  endl

        invoke  GetDlgItem, [.hwnd], 100
        invoke  GetProp, eax, [propGraphic]
        mov     edi, eax

        invoke  CreateCompatibleDC, NULL
        mov     [edi+TGraphic.ImageDC], eax

        invoke  GetProp, [.hwnd], [propOpenFileStructure]
        mov     ebx, eax

        mov     eax, [ebx+TOpenFile.fNeverSaved]
        mov     [.newbitmap], eax

        test    eax, eax
        jz      .trytoload

        mov     [edi+TGraphic.Image.biWidth], 640
        mov     [edi+TGraphic.Image.biHeight], -480
        jmp     .createnew

.trytoload:
        mov     eax, [.wparam]
        test    eax, eax
        jnz     .nameok

        mov     eax, [ebx+TOpenFile.hFileName]

.nameok:
        stdcall StrPtr, eax
        invoke  LoadImage, [hInstance], eax, IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION or LR_LOADFROMFILE
        test    eax, eax
        jnz     .fileloaded

        mov     eax, errLoadBmp
        clc
        return

.fileloaded:
        mov     esi, eax
        lea     eax, [.bitmap]
        invoke  GetObject, esi, sizeof.BITMAP, eax
        test    eax, eax
        jz      .errorload

        mov     eax, [.bitmap.bmWidth]
        mov     ecx, [.bitmap.bmHeight]
        test    ecx, ecx
        js      @f
        neg     ecx
@@:
        mov     [edi+TGraphic.Image.biWidth], eax
        mov     [edi+TGraphic.Image.biHeight], ecx

.createnew:
        mov     [edi+TGraphic.Image.biSize], sizeof.BITMAPINFOHEADER
        mov     [edi+TGraphic.Image.biPlanes], 1
        mov     [edi+TGraphic.Image.biCompression], BI_RGB
        mov     [edi+TGraphic.Image.biBitCount], 32
        mov     [edi+TGraphic.Image.biSizeImage], 0
        mov     [edi+TGraphic.Image.biClrUsed], 0
        mov     [edi+TGraphic.Image.biClrImportant], 0
        lea     eax, [edi+TGraphic.Image]
        lea     ecx, [edi+TGraphic.ptrImage]
        invoke  CreateDIBSection, [edi+TGraphic.ImageDC], eax, DIB_RGB_COLORS, ecx, NULL, NULL
        mov     [edi+TGraphic.hImage], eax
        test    eax, eax
        jnz     @f

.errorload:
        invoke  GetLastError
        clc
        return

@@:
        invoke  SelectObject, [edi+TGraphic.ImageDC], eax

; copy loaded image to the DIB section
        cmp     [.newbitmap], 0
        jne     .endload

        invoke  CreateCompatibleDC, NULL
        mov     ebx, eax
        invoke  SelectObject, ebx, esi

        mov     ecx, [edi+TGraphic.Image.biHeight]
        neg     ecx
        invoke  BitBlt, [edi+TGraphic.ImageDC], 0, 0,           \
                        [edi+TGraphic.Image.biWidth], ecx,      \
                        ebx, 0, 0, SRCCOPY

        invoke  DeleteDC, ebx
        invoke  DeleteObject, esi

        cmp     [.bitmap.bmBitsPixel], 32
        je      .endload

        mov     ecx, [edi+TGraphic.Image.biWidth]
        imul    ecx, [edi+TGraphic.Image.biHeight]
        neg     ecx

        mov     esi, [edi+TGraphic.ptrImage]

.clralpha:
        mov     eax, [esi]
        or      eax, $ff000000
        mov     [esi], eax
        add     esi, 4
        loop    .clralpha

.endload:
        xor     eax, eax
        clc
        return

onmessage _CEM_GETFILE
        invoke  GetProp, [.hwnd], [propOpenFileStructure]
        clc
        return
endwp





proc DrawShadow, .ptrGraphic
.time dd ?
begin
        push    edi esi

        invoke  GetTickCount
        mov     [.time], eax

        mov     esi, [.ptrGraphic]

; Draw the background
        invoke  SetBkColor, [esi+TGraphic.ScreenDC], $00c0c0c0
        invoke  CreateHatchBrush, HS_FDIAGONAL, $00808080
        invoke  SelectObject, [esi+TGraphic.ScreenDC], eax
        push    eax

        mov     ecx, [esi+TGraphic.Shadow.biWidth]
        mov     edx, [esi+TGraphic.Shadow.biHeight]
        neg     edx

        invoke  PatBlt, [esi+TGraphic.ScreenDC], 0, 0, ecx, edx, PATCOPY
        invoke  SelectObject, [esi+TGraphic.ScreenDC] ; from the stack
        invoke  DeleteObject, eax

; Draw the image above the background.

; 1. Compute the width and height of the image that to be displayed on
;    the visible surface.
locals
  .srcwidth  dd ?
  .srcheight dd ?
  .dstwidth  dd ?
  .dstheight dd ?
  .zoomx     dd ?
  .zoomy     dd ?
  .ydst      dd ?
endl

        mov     eax, [esi+TGraphic.Shadow.biWidth]
        xor     edx, edx
        div     [esi+TGraphic.Zoom]
        test    edx, edx
        jz      @f
        inc     eax
@@:
        mov     ecx, eax
        add     ecx, [esi+TGraphic.xBeg]
        sub     ecx, [esi+TGraphic.Image.biWidth]
        jle     @f
        sub     eax, ecx
@@:
        mov     [.srcwidth], eax
        imul    eax, [esi+TGraphic.Zoom]
        mov     [.dstwidth], eax

        mov     eax, [esi+TGraphic.Shadow.biHeight]
        xor     edx, edx
        neg     eax
        div     [esi+TGraphic.Zoom]
        test    edx,edx
        jz      @f
        inc     eax
@@:
        mov     ecx, eax
        add     ecx, [esi+TGraphic.yBeg]
        add     ecx, [esi+TGraphic.Image.biHeight]
        jle     @f
        sub     eax, ecx
@@:
        mov     [.srcheight], eax
        imul    eax, [esi+TGraphic.Zoom]
        mov     [.dstheight], eax

        mov     edi, [esi+TGraphic.ptrShadow]  ; pointer to the row in the dest bitmap

        mov     ebx, [esi+TGraphic.ptrImage]
        mov     eax, [esi+TGraphic.yBeg]
        dec     eax
        mov     edx, [esi+TGraphic.Image.biWidth]
        shl     edx, 2
        imul    eax, edx
        add     ebx, eax        ; pointer to the row in the source bitmap

        mov     [.zoomy], 1
        mov     [.ydst], 0

; load MMX constants
        pcmpeqd   mm3, mm3        ; 1's in mm3
        pxor      mm5, mm5        ; 0's in mm5
        punpcklbw mm3, mm5        ; 00ff00ff00ff00ff

.outer:
        inc       [.ydst]
        mov       eax, [.ydst]
        cmp       eax, [.dstheight]
        jg        .endouter
        neg       eax
        cmp       eax, [esi+TGraphic.Shadow.biHeight]
        jl        .endouter

        dec       [.zoomy]
        jnz       .srcrowok

        mov       ecx, [esi+TGraphic.Zoom]
        mov       eax, [esi+TGraphic.Image.biWidth]
        mov       [.zoomy], ecx
        lea       ebx, [ebx+4*eax]

.srcrowok:
        mov       ecx, [.dstwidth]
        mov       edx, [.srcwidth]
        add       edx, [esi+TGraphic.xBeg]
        mov       [.zoomx], 1

.inner:
        dec       ecx
        js        .nextrow

        dec       [.zoomx]
        jnz       .srcok

        dec       edx

; Get the source pixel, put it to mm7 for future use.
; Get the alpha from this pixel and put it in mm2 for future use also.
        movd      mm7, [ebx+4*edx]    ; src pixel
        punpcklbw mm7, mm5            ; pixel from the source image
        mov       al, [ebx+4*edx+3]
        mov       ah, al
        shl       eax, 8
        mov       al, ah
        movd      mm2, eax

        movq      mm4, mm3        ; 00ff00ff00ff00ff
        punpcklbw mm2, mm5        ; alpha value
        psubw     mm4, mm2        ; 255 - alpha

        mov       eax, [esi+TGraphic.Zoom]
        mov       [.zoomx], eax

.srcok:
        cmp       ecx, [esi+TGraphic.Shadow.biWidth]
        jge       .inner

        movd      mm1, [edi+4*ecx] ; background pixel
        movq      mm0, mm7         ; image pixel

        punpcklbw mm1, mm5       ; from byte to word in mm1

        pmullw    mm0, mm2      ; image * alpha
        pmullw    mm1, mm4      ; background * (255-alpha)
        paddw     mm0, mm1      ; mm0 = a*i + (255-a)*b
        psrlw     mm0, 8        ; div 256 -> wrong, must be 255, but very fast... ;)
        packuswb  mm0, mm5

        movd      [edi+4*ecx], mm0

        jmp       .inner

.nextrow:
        mov       eax, [esi+TGraphic.Shadow.biWidth]
        lea       edi, [edi+4*eax]
        jmp       .outer

.endouter:
        emms

; Draw gridlines if any
        cmp      [esi+TGraphic.Zoom], 4
        jle      .finish

        mov     edi, [esi+TGraphic.ScreenDC]
        invoke  CreatePen, PS_SOLID, 0, clGridLines
        invoke  SelectObject, edi, eax
        push    eax

        xor     ebx, ebx  ; xcoor

.xloop:
        invoke  MoveToEx, edi, ebx, 0, 0
        invoke  LineTo, edi, ebx, [.dstheight]
        add     ebx, [esi+TGraphic.Zoom]
        cmp     ebx, [.dstwidth]
        jle     .xloop

        xor     ebx, ebx
.yloop:
        invoke  MoveToEx, edi, 0, ebx, 0
        invoke  LineTo, edi, [.dstwidth], ebx
        add     ebx, [esi+TGraphic.Zoom]
        cmp     ebx, [.dstheight]
        jle     .yloop

        invoke  SelectObject, edi ; from the stack
        invoke  DeleteObject, eax

.finish:
        invoke  GetTickCount
        sub     eax, [.time]

        stdcall NumToStr, eax, 0, 0, ntsDec or ntsUnsigned or ntsZeroTerminated
        stdcall SetControlText, [hEditorsHost], eax
        stdcall StrDel, eax

        pop     esi edi
        return
endp



