;----------------------------------------------------
; This structure describes one element of the array
; with debug information.
;----------------------------------------------------
struct TDebugLine
  .Address        dq ?          ;
  .strLine        dd ?          ; handle to string with real line after macroses executed.
  .iFile          dd ?          ; Index in the array of dwords with handles to filenames.
  .LineNum        dd ?          ;
ends


struct TAsmDumpElement
  .ofsBinary       dd ?       ; offset of the line in the output binary file.
  .ofsPreprocessed dd ?       ; offset of the line in preprocessed file.
  .Address         dq ?       ; value of $ for this line.
  .extSIB          dd ?       ; Extended SIB for the $ address, the first two bytes
                              ; are register codes and the second two bytes are corresponding scales.
  .RelocatibleTo   dd ?
  .AddrType        db ?
  .codeType        db ?       ; 16, 32 or 64
  .flagVirtual     db ?       ; <>0 means .ofsBinary is meaningless because the line is not included.; 1 = virtual block; 2 = missing from the binary, because of other reason.
  .reserved        db ?
ends