proc LastError
begin
        pushad
        invoke  GetLastError
        stdcall ErrorMessage, eax
        popad
        return
endp

;-------------------------------------------------------------------------
; Shows message box with error message.
; Arguments:
;  errorcode - code of the error. This is code returned by GetLastError.
;
;  Because of missing information about "Message table" resources, this
;  procedure uses specific processing for application defined messages
;-------------------------------------------------------------------------
proc ErrorMessage, .errorcode
.errstr dd ?
begin
        pushad

        test    [.errorcode], errFresh
        jnz     .freshmsg

        lea     esi, [.errstr]
        invoke  FormatMessage, FORMAT_MESSAGE_ALLOCATE_BUFFER or                \
                               FORMAT_MESSAGE_FROM_SYSTEM,                      \
                               NULL, [.errorcode], NULL, esi, 256, NULL
        invoke  MessageBox, [hApplication], [.errstr], NULL, MB_OK or MB_ICONERROR
        invoke  LocalFree, [.errstr]
.finish:
        popad
        return

.freshmsg:
        cmp     [.errorcode], errCanceled
        je      .finish

        mov     esi, FreshErrorMessages-8

; search for message
.loop:
        add     esi, 8
        mov     ecx, [esi]
        mov     eax, [esi+4]
        jecxz   .notfound

        cmp     eax, [.errorcode]
        jne     .loop

;found:
.msg:
        invoke  MessageBox, [hApplication], ecx, NULL, MB_OK or MB_ICONERROR
        popad
        return

.notfound:
        mov     ecx, errmsgUnknownError
        jmp     .msg

endp















;proc Stop, Num1, Num2, ptrStr
;begin
;        pushad
;        stdcall NumToStr, [Num1], NULL, 0, ntsZeroTerminated or ntsUnsigned or ntsHex
;        push    eax
;        mov     ebx, eax
;        stdcall NumToStr, [Num2], NULL, 0, ntsZeroTerminated or ntsUnsigned or ntsHex
;        push    eax
;        stdcall StrCat, ebx, msgComma
;        stdcall StrCat, ebx, eax
;
;        stdcall StrPtr, [ptrStr]
;        mov     esi, eax
;        stdcall StrPtr, ebx
;        invoke  MessageBox, [hApplication], esi, eax, MB_YESNO
;
;        stdcall StrDel      ; arg is in the stack.
;        stdcall StrDel      ; arg is in the stack.
;
;        cmp     eax, IDYES
;        jne     @f
;        int3
;@@:
;        popad
;        return
;
;msgPause db 'Pause', 0
;msgComma db ', ', 0
;
;endp

