
uglobal
  hEditorsHost    dd 0                        ; handle of editors host window
  hStatus         dd 0                        ; handle of the Statusbar of the editor host.
                                              ; This statusbar is for common use from all
                                              ; hosted windows.

  ptrMRUFiles     dd 0

  hEditorTab      dd 0
  hTabMenu        dd 0                        ; popup menu for the tab control.
  hTabIml         dd 0
endg

iglobal
  cEmptyEditorTitle db 'Fresh editor:',0

  cStatusBarParts dd    64, 128, 192, 208, 264, -1

CoolMenu TabPopup,                      \
    mfNormal, actFileClose,             \
    mfSeparator, NONE,                  \
    mfNormal, actNew,                   \
    mfNormal, actOpen,                  \
    mfNormal, actSave,                  \
    mfSeparator, NONE,                  \
    mfNormal, actSetCurrentMain,        \
    mfNormal, actAddToProject
endg



;----------------------------------------
; Creates editorhost window.
; Call this only once.
;----------------------------------------
proc InitEditorHost, .owner
begin

        stdcall CreateCoolMenu, TabPopup, TRUE
        mov     [hTabMenu], eax

        invoke   CreateWindowEx, 0, cFormClassName, cEmptyEditorTitle,               \
                 WS_VISIBLE or WS_CAPTION or WS_CLIPCHILDREN or WS_SIZEBOX or        \
                 WS_MINIMIZEBOX or WS_MAXIMIZEBOX or WS_SYSMENU,                     \
                 100, 100 , 200, 200,                                                \
                 [.owner],                                                            \
                 NULL, [hInstance],                                                  \
                 NULL

        mov     [hEditorsHost], eax

        stdcall SubclassWindow, eax, EditorHostProc

        invoke  LoadImage, [hInstance], resSourceIcon, IMAGE_ICON, 0, 0, 0
        invoke  SendMessage, [hEditorsHost], WM_SETICON, ICON_SMALL, eax

        return
endp



;-----------------------------------------------------
; Dialog proc for Source editor
;-----------------------------------------------------
proc EditorHostProc, .hwnd, .wmsg, .wparam, .lparam
.nmh    NMHDR
.ptr dd ?
.tci    TEditorTab
.str    rb      1024
.tchi    TCHITTESTINFO
.pnt     POINT
.textlen dd ?
.written dd ?
.iItem   dd ?

begin
        call    JumpTo
        MessageList                              \
            AM_INITWINDOW,      .aminitwindow,   \
            WM_DESTROY,         .destroy,        \
            WM_NOTIFY,          .notify,         \
            WM_DROPFILES,       .wmdropfiles,    \
\
            _EHM_SETACTIVETAB,   .setactivetab,   \
\ ; EHM_ messages this window is not an editor but a host for all editors.
            EHM_DOCKWINDOW,      .dockwindow,    \
            EHM_UNDOCKWINDOW,    .undockwindow,  \
            EHM_GETCURRENTASMEDIT, .getcurrentasmedit, \
            EHM_FILECHANGED,       .filechanged,       \
            EHM_FOCUSWINDOW,       .focuswindow,       \
\
            WM_CLOSE,           .close,          \
            WM_ACTIVATE,        .activate,       \
            WM_COMMAND,         .command,        \
            WM_PARENTNOTIFY,    .wmparentnotify, \
            WM_SETFOCUS,        .wmsetfocus

.default:
        stc
        return

;------------ EHM_FOCUSWINDOW ----------------------
.focuswindow:
        stdcall IndexByWindow, [.wparam]
        cmp     eax, -1
        je      .endfocus

        invoke  SendMessage, [.hwnd], _EHM_SETACTIVETAB, eax, FALSE

.endfocus:
        clc
        return

;------------ EHM_FILECHANGED ----------------------
.filechanged:
        mov     eax, [.wparam]
        stdcall IndexByWindow, [eax+TOpenFile.hEditor]
        cmp     eax, -1
        je      .endchanged

        mov     edi, eax

        mov     [.tci.mask], TCIF_TEXT or TCIF_IMAGE

        stdcall GetScreenProperties, [.wparam]
        push    eax

        mov     [.tci.iImage], edx

        stdcall StrPtr, eax
        mov     [.tci.pszText], eax
        lea     ecx, [.tci]
        invoke  SendMessage, [hEditorTab], TCM_SETITEM, edi, ecx

        stdcall StrDel ; from the stack...

        mov     eax, [.wparam]
        stdcall StrPtr, [eax+TOpenFile.hFileName]
        invoke  SendMessage, [.hwnd], WM_SETTEXT, 0, eax

.endchanged:
        clc
        return

;----------- EHM_DOCKWINDOW ------------------------
.dockwindow:
        invoke  ShowWindow, [.wparam], SW_HIDE
        invoke  SetParent, [.wparam], [.hwnd]
        stdcall SetAlign, [.wparam], [.lparam]

        cmp     [.lparam], dfClient
        je      .addtotabs

        stdcall CreateSplitter, [.wparam], FALSE, resVSplit, resHSplit
        mov     ebx, eax

; Show window and splitter.
        invoke  ShowWindow, [.wparam], SW_SHOWNORMAL
        invoke  ShowWindow, ebx, SW_SHOWNORMAL
        mov     eax, ebx
        clc
        return

.addtotabs:
        mov     [.tci.mask], TCIF_TEXT or TCIF_IMAGE or TCIF_PARAM

        stdcall GetEditorFile, [.wparam]
        stdcall GetScreenProperties, eax
        mov     [.tci.iImage], edx

        push    eax
        stdcall StrPtr, eax
        mov     [.tci.pszText], eax

        invoke  SendMessage, [hEditorTab], TCM_GETCURSEL, ebx, ebx
        lea     edi, [eax+1]

        mov     eax, [.wparam]
        mov     [.tci.hEditor], eax

        lea     ecx, [.tci]
        invoke  SendMessage, [hEditorTab], TCM_INSERTITEM, edi, ecx
        mov     edi, eax

        stdcall StrDel ; from the stack.

        invoke  ShowWindow, [hEditorTab], SW_SHOWNORMAL
        invoke  ShowWindow, [hStatus], SW_SHOWNORMAL

        invoke  SendMessage, [.hwnd], _EHM_SETACTIVETAB, edi, ebx
        return

;----------- EHM_UNDOCKWINDOW ----------------------
.undockwindow:

        return

;----------- EHM_GETCURRENTASMEDIT -----------------
.getcurrentasmedit:
        call    .loadtcitem
        xor     eax, eax
        stdcall GetAsmEdit, [.tci.hEditor]
        clc
        return

;----------- WM_DROPFILES -------------------------
.wmdropfiles:
        lea     esi, [.str]

        invoke  DragQueryFile, [.wparam], -1, esi, 1024
        mov     ebx, eax
        xor     edi, edi

.opendroploop:
        invoke  DragQueryFile, [.wparam], edi, esi, 1024
        stdcall OpenFileByName, esi, NULL, TRUE
        inc     edi
        dec     ebx
        jnz     .opendroploop

        invoke  DragFinish, [.wparam]
        xor     eax, eax
        clc
        return

;-----------WM_COMMAND-----------------------------

.command:
        movzx   esi,word [.wparam]
        cmp     esi, MR_CANCEL
        je      .close_something

        cmp     esi, MR_OK
        je      .jmp_link

        sub     esi,FirstID

        cmp     esi, [MainActionList.Number]
        jae     .maybeasmedit

        imul    esi, sizeof.TAction
        add     esi,MainActionList

        xor     eax,eax
        cmp     [esi+TAction.OnExecute],eax
        je      .qfalse

        stdcall [esi+TAction.OnExecute], [.wparam], [.lparam]
        jmp     .default

.jmp_link:
        invoke  GetFocus
        cmp     eax, [tvMessagesWin]
        jne     .qfalse

        invoke  PostMessage, [frmMsg], WM_COMMAND, MR_OK, 0
        jmp     .qfalse

.close_something:
        invoke  GetFocus
        cmp     eax, [tvMessagesWin]
        je      .closemessages

        cmp     [hCCList], 0
        je      .ccok

        invoke  PostMessage, [hCCList], WM_CLOSE, 0, 0
        jmp     .qfalse

.ccok:
        cmp     [hPAHint], 0
        je      .qfalse

        invoke  PostMessage, [hPAHint], WM_CLOSE, 0, 0
        jmp     .qfalse

.closemessages:
        invoke  PostMessage, [frmMsg], MWM_SHOWMESSAGES, 0, 0
        jmp     .qfalse

.maybeasmedit:
        movzx   eax, word [.wparam+2]
        cmp     eax, AEN_POSCHANGE
        je      .updatestatusbar
        cmp     eax, AEN_TEXTCHANGE
        je      .updatestatusbar
        cmp     eax, AEN_SETFOCUS
        je      .updatestatusbar
        cmp     eax, AEN_MODECHANGE
        jne     .default

.updatestatusbar:
        stdcall UpdateStatusbar, [.lparam]
        stdcall UpdatePAHint
        jmp     .default


iglobal
  cStatusLine db 'Line: xxxxx',0
  cStatusPos  db 'Pos: xxx',0
  cStatusOverwrite db 'Overwrite',0
  cStatusInsert    db 'Insert',0
  cStatusVertical  db '||',0
  cStatusHorizontal db '=',0
  cStatusModified db 'Modified',0
endg

;------- WM_ACTIVATE -------------------------
.activate:
        cmp     [.wparam], WA_ACTIVE
        je      .wmsetfocus
        cmp     [.wparam], WA_CLICKACTIVE
        jne     .qfalse

;----------- WM_SETFOCUS ---------------------------
.wmsetfocus:
        invoke  SendMessage, [hEditorTab], TCM_GETCURSEL, 0, 0
        cmp     eax, -1
        je      .focussomething

; focus active asmedit
        lea     ecx, [.tci]
        mov     [.tci.mask], TCIF_PARAM
        invoke  SendMessage, [hEditorTab], TCM_GETITEM, eax, ecx

        stdcall GetEditorFile, [.tci.hEditor]
        stdcall FocusFile, eax
        jmp     .qfalse

.focussomething:
        invoke  SetFocus, [frmMsg]
        test    eax, eax
        jnz     .qfalse

.activatemain:
        invoke  SetActiveWindow, [hMainWindow]
        jmp     .qfalse



;----------- WM_CLOSE ---------------------------
.close:
        stdcall ActionSetCheck, actViewSourceEditor, FALSE
        invoke  ShowWindow, [.hwnd], SW_HIDE
        jmp     .qfalse

;----------- _EHM_SETACTIVETAB -----------------------
.setactivetab:
        lea     ebx, [.nmh]

        cmp     [.lparam], FALSE
        je      .doset

        invoke  SendMessage, [hEditorTab], TCM_GETITEMCOUNT
        mov     esi, eax
        dec     esi
        js      .qfalse

        invoke  SendMessage, [hEditorTab], TCM_GETCURSEL, 0, 0
        test    eax, eax
        js      .qfalse

        add     eax, [.wparam]
        jns     @f
        mov     eax, esi        ; Set Max
@@:
        cmp     eax, esi
        jle     @f
        xor     eax, eax
@@:
        mov     [.wparam], eax

.doset:
        mov     [.nmh.code], TCN_SELCHANGING
        invoke  SendMessage, [hEditorTab], WM_NOTIFY, 0, ebx

        invoke  SendMessage, [hEditorTab], TCM_SETCURSEL, [.wparam], 0

        mov     [.nmh.code], TCN_SELCHANGE
        invoke  SendMessage, [hEditorTab], WM_NOTIFY, 0, ebx
        jmp     .qfalse

;------------------ WM_PARENTNOTIFY --------------------
.wmparentnotify:
        movzx   eax, word [.wparam]
        cmp     eax, WM_DESTROY
        jne     .default

        stdcall IndexByWindow, [.lparam]
        cmp     eax, -1
        je      .default

        mov     ebx, eax
        invoke  SendMessage, [hEditorTab], TCM_DELETEITEM, eax, 0
        invoke  SendMessage, [hEditorTab], TCM_GETITEMCOUNT, 0, 0
        test    eax, eax
        jz      .hidetabs

        test    ebx, ebx
        jz      .setactive
        dec     ebx

.setactive:
        invoke  SendMessage, [.hwnd], _EHM_SETACTIVETAB, ebx, FALSE
        jmp     .qfalse

.hidetabs:
        invoke  ShowWindow, [hEditorTab], SW_HIDE
        invoke  ShowWindow, [hStatus], SW_HIDE
; check project

        cmp     [ptrProjectFile], 0
        je      .qfalse

        stdcall FocusFile, [ptrProjectFile]
        jmp     .qfalse

;----------- WM_NOTIFY --------------------------
.notify:
        mov     esi, [.lparam]

        cmp     [esi+NMHDR.code], TCN_SELCHANGE
        je      .change

        cmp     [esi+NMHDR.code], TCN_SELCHANGING
        je      .changing

        cmp     [esi+NMHDR.code], NM_RCLICK
        jne     .qfalse

.rclick:
        mov     eax, [hEditorTab]
        cmp     [esi+NMHDR.hwndFrom], eax
        jne     .qfalse

        lea     ebx, [.pnt]
        invoke  GetCursorPos, ebx

        mov     ecx, [.pnt.x]
        mov     edx, [.pnt.y]
        mov     [.tchi.pt.x], ecx
        mov     [.tchi.pt.y], edx

        lea     ebx, [.tchi]
        invoke  ScreenToClient, [esi+NMHDR.hwndFrom], ebx
        invoke  SendMessage, [esi+NMHDR.hwndFrom], TCM_HITTEST, 0, ebx
        cmp     eax, -1
        je      .qfalse

        invoke  SendMessage, [.hwnd], _EHM_SETACTIVETAB, eax, 0
        invoke  TrackPopupMenu, [hTabMenu], TPM_LEFTALIGN or TPM_RIGHTBUTTON, [.pnt.x], [.pnt.y] , 0, [.hwnd], NULL
        jmp     .qfalse

.changing:
        invoke  SendMessage, [hEditorTab], TCM_GETCURSEL, 0, 0
        cmp     eax, -1
        je      .qfalse

        lea     ebx, [.tci]
        mov     [.tci.mask], TCIF_PARAM
        invoke  SendMessage, [hEditorTab], TCM_GETITEM, eax, ebx

        push    [.tci.hEditor]
        pop     [hLastEditorForHide]
;        invoke  ShowWindow, [.tci.hEditor], SW_HIDE
        jmp     .qfalse

uglobal
  hLastEditorForHide dd ?
endg

.change:
        invoke  SendMessage, [hEditorTab], TCM_GETCURSEL, 0, 0
        cmp     eax, -1
        je      .qfalse

        mov     ebx, eax
        lea     ecx, [.tci]
        mov     [.tci.mask], TCIF_PARAM
        invoke  SendMessage, [hEditorTab], TCM_GETITEM, ebx, ecx

        invoke  LockWindowUpdate, [.hwnd]
        invoke  ShowWindow, [hLastEditorForHide], SW_HIDE
        invoke  ShowWindow, [.tci.hEditor], SW_SHOW

        invoke  SetFocus, 0                             ; work around for ASMEDIT bug (highly obscure)
        invoke  SetFocus, [.tci.hEditor]
        stdcall GetEditorFile, [.tci.hEditor]
        mov     ebx, eax
        stdcall SetCurrentFile, ebx
        stdcall AlignChildren, [.hwnd]
        invoke  LockWindowUpdate, NULL

        stdcall StrPtr, [ebx+TOpenFile.hFileName]
        invoke  SendMessage, [.hwnd], WM_SETTEXT, 0, eax
        jmp     .qfalse

;----------- WM_DESTROY -------------------------
.destroy:
        invoke  SendMessage, [hEditorTab], TCM_GETITEMCOUNT, 0, 0
        test    eax, eax
        mov     ebx, eax

.emptyloop:
        dec     ebx
        js      .emptyok

        mov     [.tci.mask], TCIF_PARAM
        lea     eax, [.tci]
        invoke  SendMessage, [hEditorTab], TCM_GETITEM, ebx, eax
        stdcall GetEditorFile, [.tci.hEditor]
        stdcall CloseFile, eax
        jmp     .emptyloop

.emptyok:
        stdcall SaveMRUToIni, [ptrMRUFiles], [hIniFileName], cMRUFilesSection
        stdcall DestroyMRUList, [ptrMRUFiles]

        invoke  SendMessage, [.hwnd], WM_GETICON, FALSE, 0
        invoke  DestroyIcon, eax

        invoke DestroyMenu, [hTabMenu]

        invoke  ImageList_Destroy, [hTabIml]

        cmp     [ptrLabels], 0
        je      .qfalse

        stdcall DestroyLabelsTree, ptrLabels
        jmp     .qfalse

iglobal
  cMRUFilesSection db 'MRU files',0
endg

;-----------AM_INITWINDOW----------------------------
.aminitwindow:
        xor     ebx,ebx

        invoke  CreateWindowEx, 0, cTabClassName, NULL,                                         \
                WS_CHILD or WS_CLIPCHILDREN or TCS_FOCUSNEVER or TCS_TABS or TCS_TOOLTIPS,                         \
                ebx, ebx, ebx, 23,                                                              \
                [.hwnd], NULL, [hInstance], NULL
        mov     [hEditorTab], eax
        invoke  SendMessage, eax, TCM_SETITEMEXTRA, sizeof.TEditorTab - sizeof.TCITEMHEADER
        stdcall SetAlign, [hEditorTab], waTop

; Set image list.
        stdcall ImageList_LoadGif, [hInstance], resBmpTab, 16, FALSE
        mov     [hTabIml], eax
        invoke  SendMessage, [hEditorTab], TCM_SETIMAGELIST, 0, [hTabIml]

; Create status bar
        invoke  CreateWindowEx, 0, cStatusBarClassName, NULL,                                   \
                WS_CHILD or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or SBARS_SIZEGRIP,               \
                ebx,ebx, ebx, ebx,                                                              \
                [.hwnd], NULL, [hInstance], NULL

        mov     [hStatus], eax
        stdcall SetAlign, eax, waBottom

        invoke  SendMessage, [hStatus], SB_SETPARTS, 6, cStatusBarParts

        stdcall LoadMRUFromIni, 16, [hIniFileName], cMRUFilesSection
        mov     [ptrMRUFiles], eax

        invoke  DragAcceptFiles, [.hwnd], TRUE

.qfalse:
        xor     eax,eax
        clc
        return

.qtrue:
        xor     eax, eax
        inc     eax
        clc
        return

; Loads the [.tci] structure with tab info depending of
; TCommonFile structure pointed by esi.
.loadtcitem:
        invoke  SendMessage, [hEditorTab], TCM_GETCURSEL, 0, 0

        mov     [.tci.mask], TCIF_PARAM or TCIF_TEXT or TCIF_IMAGE
        lea     ecx, [.str]
        mov     [.tci.pszText], ecx
        mov     [.tci.cchTextMax], 1024

        lea     ecx, [.tci]
        invoke  SendMessage, [hEditorTab], TCM_GETITEM, eax, ecx
        retn
endp



proc UpdateStatusbar, .hEditor
.pos  AEPOS
begin
        push    esi edi ebx
        mov     ebx, [.hEditor]   ; handle of the AsmEdit window

        lea     eax, [.pos]
        invoke  SendMessage, ebx, AEM_GETPOS, eax, 0

        stdcall NumToStr, [.pos.caretLine], cStatusLine, 6, ntsZeroTerminated or ntsDec or ntsUnsigned
        invoke  SendMessage, [hStatus], SB_SETTEXT, 0, cStatusLine

        stdcall NumToStr, [.pos.caretPosition], cStatusPos, 5, ntsZeroTerminated or ntsDec or ntsUnsigned
        invoke  SendMessage, [hStatus], SB_SETTEXT, 1, cStatusPos

        invoke  SendMessage, ebx, AEM_GETMODE, 0, 0
        push    eax
        mov     ecx, cStatusOverwrite
        test    eax, AEMODE_OVERWRITE
        jnz     @f
        mov     ecx, cStatusInsert
@@:
        invoke  SendMessage, [hStatus], SB_SETTEXT, 2, ecx
        pop     eax  ; mode again
        mov     ecx, cStatusVertical
        test    eax, AEMODE_VERTICALSEL
        jnz     @f
        mov     ecx, cStatusHorizontal
@@:
        invoke  SendMessage, [hStatus], SB_SETTEXT, 3, ecx

        invoke  SendMessage, ebx, AEM_GETMODIFIED, 0, 0
        mov     ecx, cStatusModified
        test    eax, eax
        jnz     @f
        xor     ecx, ecx
@@:
        invoke  SendMessage, [hStatus], SB_SETTEXT, 4, ecx

        cmp     [idDbgThread], 0
        jne     @f

        invoke  SendMessage, [hStatus], SB_SETTEXT, 5, NULL

        cmp     [fSetCurrent], 0
        jne     @f

        invoke  SendMessage, ebx, AEM_SETFOCUSLINE, 0, 0
@@:
        pop     ebx edi esi
        return
endp

;-------------------------------------------------------------
; Returns index of the tab containing handle of given window
; or -1 if such tab item is not found.
;-------------------------------------------------------------
proc IndexByWindow, .hChildWindow
.tci TEditorTab
begin
        push    ebx

        invoke  SendMessage, [hEditorTab], TCM_GETITEMCOUNT, 0, 0
        mov     ebx, eax

.while:
        dec     ebx
        js      .notfound

        mov     [.tci.mask], TCIF_PARAM
        lea     eax, [.tci]
        invoke  SendMessage, [hEditorTab], TCM_GETITEM, ebx, eax
        test    eax, eax
        jz      .while

        mov     eax, [.hChildWindow]
        cmp     [.tci.hEditor], eax
        jne     .while

.notfound:
        mov     eax, ebx
        pop     ebx
        return
endp



;-----------------------------------------------------------
; Adds current active in editor file to current category in
; the project.
; If the file belongs to the project, remove it from the
; project and then adds it in the current category.
;-----------------------------------------------------------
proc OnAddToProject, .wparam, .lparam
begin
        mov     esi, [ptrCurrentFile]
        test    esi, esi
        jz      .finish

        invoke  SendMessage, [hProjManager], PMM_ADDFILE, esi, -1

.finish:
        return
endp


proc OnSetCurrentAsMain, .wparam, .lparam
begin
        mov     esi, [ptrCurrentFile]
        test    esi, esi
        jz      .finish

        invoke  SendMessage, [hProjManager], PMM_ADDFILE, esi, 0

.finish:
        return
endp

