iglobal
  cHHCtrlLib    db "HHCTRL.OCX", 0
  cHtmlHelpA    db "HtmlHelpA", 0
;  cFreshHelp    db "%fresh%\"
;  cFreshDefHelp db "doc\freshguide.chm", 0
;  .size = $ - cFreshDefHelp
endg

uglobal
  HtmlHelp     dd ?
  hHHCtrl      dd ?
  ptrHelpFiles dd ?     ; points to array of dwords with handles of strings with help filenames.
endg

proc InitHelp
begin
        invoke  LoadLibrary, cHHCtrlLib
        mov     [hHHCtrl],eax
        or      eax,eax
        jz      .finish

        invoke  GetProcAddress, eax, cHtmlHelpA

.finish:
        mov     [HtmlHelp],eax
        return
endp



proc RebuildHelpFilesList
begin
        push    esi edi ebx

        mov     esi, [ptrHelpFiles]
        test    esi, esi
        jz      .listisclean

        mov     ebx, [esi+TArray.Count]

.cleanloop:
        dec     ebx
        js      .endclean

        stdcall StrDel, [esi+TArray.Items+4*ebx]
        jmp     .cleanloop
.endclean:
        invoke  HeapFree, [hHeap], 0, esi

.listisclean:
        stdcall CreateArray, 4
        mov     [ptrHelpFiles], eax

        stdcall ReadSectionFromIni, [hIniFileName], cHelpSection, _AddOneHelpFile, 0

        pop     ebx edi esi
        return
endp



proc _AddOneHelpFile, .ptrName, .dummy
begin
        stdcall StrDup, [.ptrName]
        push    eax
        stdcall AddArrayItem, ptrHelpFiles
        popd    [eax]
        clc
        return
endp



proc OnHelp, .wparam, .lparam
.filecount dd ?
.str       rb 256
begin
        invoke  SendMessage, [hEditorsHost], EHM_GETCURRENTASMEDIT, 0, 0
        test    eax, eax
        jz      .finish
        lea     ebx, [.str]
        invoke  SendMessage, eax, AEM_GETWORDATCARET, 256, ebx

        mov     esi, [ptrHelpFiles]
        test    esi, esi
        jz      .finish

        push    [esi+TArray.Count]
        pop     [.filecount]

        cmp     [.filecount], 0
        je      .finish

        xor     edi, edi
.searchloop:
        stdcall SearchOneHelp, [esi+TArray.Items+4*edi], ebx, FALSE
        jc     .finish
        inc    edi
        cmp    edi, [.filecount]
        jne    .searchloop

        stdcall SearchOneHelp, [esi+TArray.Items+4*edi-4], ebx, TRUE

.finish:
        return
endp



proc SearchOneHelp, .hFileName, .ptrWord, .flagIndex
  .aklink    HH_AKLINK
begin
        push    ebx esi edi

        stdcall StrLen, [.hFileName]
        mov     ecx, eax
        stdcall StrPtr, [.hFileName]

.extloop:
        dec     ecx
        js      .notfound

        cmp     byte [eax+ecx], '.'
        jne     .extloop

        mov     ecx, dword [eax+ecx]    ; get the extension
        or      ecx, $20202000          ; case insensitive

        cmp     ecx, '.hlp'
        je      .winhelp

        cmp     ecx, '.chm'
        je      .htmlhelp

.notfound:
        clc
        pop     edi esi ebx
        return

.htmlhelp:
        cmp     [HtmlHelp], NULL
        je      .notfound

        xor     eax, eax
        mov     [.aklink.cbStruct], sizeof.HH_AKLINK
        mov     [.aklink.fReserved], eax
        mov     [.aklink.pszUrl], eax
        mov     [.aklink.pszMsgText], eax
        mov     [.aklink.pszMsgTitle], eax
        mov     [.aklink.pszWindow], eax

        push    [.ptrWord]
        pop     [.aklink.pszKeywords]

        push    [.flagIndex]
        pop     [.aklink.fIndexOnFail]

        stdcall StrPtr, [.hFileName]
        mov     ebx,eax
        lea     eax, [.aklink]
        invoke  HtmlHelp, NULL, ebx, HH_KEYWORD_LOOKUP, eax
        test    eax,eax   ; if eax==0 then given word doesn't exist in the help
        jz      .notfound   ;  file - so we search in user defined help file

.found:
        stc
        pop     edi esi ebx
        return


.winhelp:
        stdcall StrPtr, [.hFileName]
        invoke  WinHelp, [hEditorsHost], eax, HELP_PARTIALKEY, [.ptrWord]

        cmp     [.flagIndex], 0
        jne     .found

        invoke  FindWindow, cWinHelpName, 0
        mov     ebx, eax

        invoke  SendMessage, ebx, WM_GETTEXTLENGTH, 0, 0
        invoke  IsWindowVisible, ebx
        test    eax, eax
        jnz     .found

        stdcall StrPtr, [.hFileName]
        invoke  WinHelp, [hEditorsHost], eax, HELP_QUIT, 0

.waitforclose:
        invoke  FindWindow, cWinHelpName, 0
        test    eax, eax
        jnz     .waitforclose

        jmp     .notfound
endp


iglobal
  cWinHelpName db 'MS_WINHELP',0
endg