uglobal
  frmMsg        dd 0                        ; Messages window.
  hSplitterMsg  dd 0
  tvMessagesWin dd 0
  fDisableLinks dd 0
endg


iglobal
  cMessagesTitle  db 'Fresh messages.',0
endg



proc InitMessageWindow
begin
        xor     ebx, ebx
        invoke   CreateWindowEx, ebx, cFormClassName, cMessagesTitle, \
                 WS_CHILD or WS_CLIPCHILDREN ,                        \
                 ebx, ebx , ebx, 100,                                 \
                 [hEditorsHost],                                      \
                 ebx, [hInstance],                                    \
                 NULL

        mov     [frmMsg], eax
        stdcall SetAlign, eax, waBottom
        stdcall SubclassWindow, [frmMsg], MsgWindowProc

        invoke  SendMessage, [hEditorsHost], EHM_DOCKWINDOW, [frmMsg], dfBottom
        mov     [hSplitterMsg], eax

        invoke  SendMessage, [frmMsg], MWM_CLEARMESSAGES, 0, 0
        return
endp





proc MsgWindowProc, .hwnd, .wmsg, .wparam, .lparam
.tvi    TVINSERTSTRUCT
begin

        call    JumpTo
        MessageList                             \
            AM_INITWINDOW,      .aminitwindow,  \
            WM_NOTIFY,          .notify,        \
            MWM_CLEARMESSAGES,  .clearmessages, \
            MWM_SHOWMESSAGES,   .showmessages,  \
            MWM_ADDMESSAGE,     .addmessage,    \
            MWM_FIRSTERROR,     .openfirsterror,\
            WM_SETFOCUS,        .setfocus,      \
            WM_COMMAND,         .command
.qtrue:
        stc
        return

.command:
        cmp     [.wparam], MR_OK
        jne     .qtrue
        jmp     .gotolink_fromuser


; ---------- WM_SETFOCUS ------------------------------
.setfocus:
        invoke  SetFocus, [tvMessagesWin]
        stc
        return

;----------- AM_INITWINDOW ----------------------------
.aminitwindow:
        xor     ebx,ebx

        invoke  CreateWindowEx, WS_EX_CLIENTEDGE, cTreeViewClassName, ebx,                      \
                WS_VISIBLE or WS_CHILD or WS_CLIPSIBLINGS or WS_VSCROLL or                      \
                TVS_DISABLEDRAGDROP or TVS_SHOWSELALWAYS or TVS_HASBUTTONS or                   \
                TVS_LINESATROOT or TVS_HASLINES,                                                \
                ebx,ebx, ebx, ebx,                                                              \
                [.hwnd], ebx, [hInstance], ebx

        mov     esi, eax
        mov     [tvMessagesWin], eax
        stdcall SetAlign, esi, waClient
        stdcall SubclassWindow, esi, MsgTreeWinProc

        stdcall ImageList_LoadGif, [hInstance], resBmpMessage, 14, FALSE
        invoke  SendMessage, esi, TVM_SETIMAGELIST, TVSIL_NORMAL, eax
        clc
        return

;----------- WM_NOTIFY --------------------------
.notify:
        mov     esi, [.lparam]

        cmp     [esi+NMHDR.code], TVN_DELETEITEM
        je      .delitem

        cmp     [esi+NMHDR.code], TVN_SELCHANGED
        je      .selchanged

        cmp     [esi+NMHDR.code], TVN_KEYDOWN
        jne     .qfalse

; TVN_KEYDOWN
        cmp     [esi+TVKEYDOWN.wVKey], $20
        jne     .qfalse

        mov     eax, [esi+NMHDR.hwndFrom]
        cmp     eax, [tvMessagesWin]
        jne     .qfalse

.gotolink_fromuser:
        invoke  SendMessage, [tvMessagesWin], TVM_GETNEXTITEM, TVGN_CARET, NULL
        mov     [.tvi.item.hItem], eax
        mov     [.tvi.item.mask], TVIF_PARAM
        lea     eax, [.tvi.item]
        invoke  SendMessage, [tvMessagesWin], TVM_GETITEM, 0, eax
        mov     edi, [.tvi.item.lParam]

        invoke  SetFocus, [hEditorsHost]
        jmp     .gotolink

.selchanged:
        cmp     [fDisableLinks], 0
        jne     .qfalse

        test    [esi+NMTREEVIEW.itemNew.state], TVIS_SELECTED
        jz      .qfalse

        mov     edi, [esi+NMTREEVIEW.itemNew.lParam]

.gotolink:
        test    edi, edi
        jz      .qfalse

        invoke  GetFocus
        mov     [.lastfocus], eax

; this will change the focus to the asmedit window
        stdcall OpenFileByName, [edi+TFileLine.hFileName], NULL, TRUE
        test    eax, eax
        jz      .qfalse
        mov     ebx, eax

; take the focus back
        mov     eax, [.lastfocus]
        cmp     eax, [tvMessagesWin]
        jne     .focusok

        invoke  SetFocus, [tvMessagesWin]
.focusok:

        mov     esi, [edi+TFileLine.pos.selectionLine]

        cmp     [ebx+TOpenFile.ptrType], ftFormSource
        jne     .setthepos

        invoke  GetProp, [ebx+TOpenFile.hEditor], [propWinTemplate]
        stdcall CountDesignWindows, eax

        sub     esi, eax
        sub     esi, 2

.setthepos:
        stdcall GetFileAsmEdit, ebx
        test    eax, eax
        jz      .qfalse

        mov     ebx, eax

locals
  .aepos AEPOS
  .lastfocus dd ?
endl

; workaround, because AEM_SETFOCUSLINE do not move the caret.
        mov     [.aepos.selectionPosition], 1
        mov     [.aepos.caretPosition], 1
        mov     [.aepos.selectionLine], esi
        mov     [.aepos.caretLine], esi
        lea     eax, [.aepos]
        invoke  SendMessage, ebx, AEM_SETPOS, eax, 0

        invoke  SendMessage, ebx, AEM_SETFOCUSLINE, esi, 0
        jmp     .qfalse

.delitem:
        mov     edi, [esi+NMTREEVIEW.itemOld.lParam]
        test    edi, edi
        jz      .checkvisible

        stdcall StrDel, [edi+TFileLine.hFileName]
        invoke  HeapFree, [hHeap], 0, edi

.checkvisible:
        invoke  SendMessage, [tvMessagesWin], TVM_GETCOUNT, 0, 0
        cmp     eax, 1
        ja      .qfalse

.hidemsgwnd:
        mov     ebx, SW_HIDE
        jmp     .doshow

;---------- MWM_SHOWMESSAGES --------------------------------
.showmessages:
        mov     ebx, SW_HIDE

        cmp     [.wparam], 0
        je      .doshow

        mov     ebx, SW_SHOWNORMAL

.doshow:
        invoke  SetWindowPos, [hStatus], HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE
        invoke  ShowWindow, [.hwnd], ebx
        invoke  ShowWindow, [hSplitterMsg], ebx
        stdcall AlignSiblings, [.hwnd]

        stdcall SetAutoHideTimer

        jmp     .qfalse


;---------- MWM_ADDMESSAGE ----------------------------------
.addmessage:
        cmp     [flagFakeCompile], 0
        jne     .qfalse

        mov     esi, [.wparam]
        test    esi, esi
        jz      .qfalse

        mov     eax, [.lparam]
        mov     [.tvi.hParent], eax
        mov     [.tvi.hInsertAfter], TVI_LAST
        mov     [.tvi.item.mask], TVIF_IMAGE or TVIF_PARAM or TVIF_SELECTEDIMAGE or TVIF_TEXT

        mov     eax, [esi+TFreshMsg.type]
        mov     [.tvi.item.iImage], eax
        mov     [.tvi.item.iSelectedImage], eax

        stdcall StrPtr, [esi+TFreshMsg.hMessage]
        mov     [.tvi.item.pszText], eax

        mov     edi, [esi+TFreshMsg.link.hFileName]
        test    edi, edi
        jz      .skiplink

        invoke  HeapAlloc, [hHeap], HEAP_ZERO_MEMORY, sizeof.TFileLine
        mov     edi, eax

        stdcall StrNew
        mov     [edi+TFileLine.hFileName], eax
        stdcall StrCopy, eax, [esi+TFreshMsg.link.hFileName]
        mov     eax, [esi+TFreshMsg.link.pos.caretLine]
        mov     ecx, [esi+TFreshMsg.link.pos.caretPosition]
        mov     [edi+TFileLine.pos.caretLine], eax
        mov     [edi+TFileLine.pos.caretPosition], ecx
        mov     eax, [esi+TFreshMsg.link.pos.selectionLine]
        mov     ecx, [esi+TFreshMsg.link.pos.selectionPosition]
        mov     [edi+TFileLine.pos.selectionLine], eax
        mov     [edi+TFileLine.pos.selectionPosition], ecx

.skiplink:
        mov     [.tvi.item.lParam], edi

        lea     eax, [.tvi]
        invoke  SendMessage, [tvMessagesWin], TVM_INSERTITEM, 0, eax
        push    eax

        invoke  SendMessage, [tvMessagesWin], TVM_ENSUREVISIBLE, 0, eax
        invoke  SendMessage, [tvMessagesWin], TVM_EXPAND, TVE_EXPAND, [.tvi.hParent]

        invoke  GetWindowLong, [.hwnd], GWL_STYLE
        test    eax, WS_VISIBLE
        jnz     .endadd

        invoke  PostMessage, [.hwnd], MWM_SHOWMESSAGES, 1, 0

.endadd:
        call SetAutoHideTimer

        pop     eax
        clc
        return

;----------- MWM_FIRSTERROR --------------------------
.openfirsterror:
        mov     ebx, TVI_ROOT

.loopchild:
        invoke  SendMessage, [tvMessagesWin], TVM_GETNEXTITEM, TVGN_CHILD, ebx
        test    eax, eax
        jz      .notfound

        lea     esi, [.tvi.item]
        mov     [.tvi.item.mask], TVIF_IMAGE or TVIF_PARAM

.itemsloop:
        mov     ebx, eax
        mov     [.tvi.item.hItem], ebx

        invoke  SendMessage, [tvMessagesWin], TVM_GETITEM, 0, esi
        cmp     [.tvi.item.iImage], mtError
        je      .found

.next:
        invoke  SendMessage, [tvMessagesWin], TVM_GETNEXTITEM, TVGN_NEXT, ebx
        test    eax, eax
        jnz     .itemsloop

.notfound:
        mov     eax, TRUE
        clc
        return

.found:
        mov     edi, [.tvi.item.lParam]
        test    edi, edi
        jz      .next

        invoke  SendMessage, [tvMessagesWin], TVM_SELECTITEM, TVGN_CARET, ebx
        jmp     .qfalse


;----------- MWM_CLEARMESSAGES ----------------------
.clearmessages:
        mov     [blockAutoHide], 0

        invoke  SendMessage, [tvMessagesWin], TVM_GETCOUNT, 0, 0
        test    eax, eax
        jz      .hidemsgwnd

        mov     [fDisableLinks], TRUE
        invoke  SendMessage, [tvMessagesWin], TVM_DELETEITEM, 0, TVI_ROOT
        mov     [fDisableLinks], FALSE
.qfalse:
        xor     eax, eax
        clc
        return

endp



iglobal
  idCloseTimer dd 0
endg


winproc MsgTreeWinProc
begin

ondefault
        stc
        return

onmessage WM_SETFOCUS
        call    KillAutoHideTimer
        stc
        return

onmessage WM_KILLFOCUS
        call    SetAutoHideTimer
        stc
        return

onmessage WM_TIMER
        mov     eax, [.wparam]
        cmp     eax, 101
        jne     .ondefault

        call    KillAutoHideTimer
        invoke  PostMessage, [frmMsg], MWM_SHOWMESSAGES, 0, 0
        clc
        return
endwp


proc KillAutoHideTimer
begin
        cmp     [idCloseTimer],0
        je      .exit
        invoke  KillTimer, [tvMessagesWin], 101
        mov     [idCloseTimer], 0
.exit:
        return
endp

proc SetAutoHideTimer
begin
        call    KillAutoHideTimer
        cmp     [flagAutoHide], 0
        je      .exit
        cmp     [blockAutoHide], 0
        jne     .exit

        invoke  IsWindowVisible, [frmMsg]
        test    eax, eax
        jz      .exit

        invoke  SetTimer, [tvMessagesWin], 101, [timeAutoHide], 0
        mov     [idCloseTimer], eax

.exit:
        return
endp
